-- MySQL dump 10.11
--
-- Host: crater5.gene.le.ac.uk    Database: HGVbaseG2P_study
-- ------------------------------------------------------
-- Server version	5.0.67

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `AlleleFrequency`
--

DROP TABLE IF EXISTS `AlleleFrequency`;
CREATE TABLE `AlleleFrequency` (
  `AlleleFrequencyID` int(10) unsigned NOT NULL auto_increment,
  `FrequencyClusterID` int(12) unsigned default NULL,
  `AlleleCombo` varchar(767) default NULL,
  `FrequencyAsProportion` decimal(4,3) unsigned NOT NULL,
  PRIMARY KEY  (`AlleleFrequencyID`),
  KEY `FrequencyClusterID` (`FrequencyClusterID`),
  CONSTRAINT `AlleleFrequency_ibfk_3` FOREIGN KEY (`FrequencyClusterID`) REFERENCES `FrequencyCluster` (`FrequencyClusterID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=60685647 DEFAULT CHARSET=latin1;

--
-- Table structure for table `AnalysisMethod`
--

DROP TABLE IF EXISTS `AnalysisMethod`;
CREATE TABLE `AnalysisMethod` (
  `AnalysisMethodID` int(10) unsigned NOT NULL auto_increment,
  `SubmittedInStudyID` mediumint(8) unsigned default NULL,
  `Identifier` varchar(15) NOT NULL,
  `Name` varchar(100) default NULL,
  `Label` varchar(10) default NULL,
  `Accession` varchar(15) default NULL,
  `AccessionVersion` varchar(10) default NULL,
  `Description` text,
  `ProtocolParameters` text,
  PRIMARY KEY  (`AnalysisMethodID`),
  UNIQUE KEY `Identifier` (`Identifier`),
  UNIQUE KEY `Name` (`Name`,`SubmittedInStudyID`),
  UNIQUE KEY `Label` (`Label`,`SubmittedInStudyID`),
  KEY `SubmittedInStudyID` (`SubmittedInStudyID`),
  CONSTRAINT `AnalysisMethodnew_ibfk_1` FOREIGN KEY (`SubmittedInStudyID`) REFERENCES `Study` (`StudyID`)
) ENGINE=InnoDB AUTO_INCREMENT=1341 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Assayedpanel`
--

DROP TABLE IF EXISTS `Assayedpanel`;
CREATE TABLE `Assayedpanel` (
  `AssayedpanelID` int(10) unsigned NOT NULL auto_increment,
  `StudyID` mediumint(8) unsigned NOT NULL,
  `Identifier` varchar(15) default NULL,
  `Name` varchar(100) default NULL,
  `Description` text,
  `TotalNumberOfIndividuals` int(6) unsigned default NULL COMMENT '*...but required for association datasets',
  `NumberOfSexMale` int(6) unsigned default NULL,
  `NumberOfSexFemale` int(6) unsigned default NULL,
  `NumberOfSexUnknown` int(6) unsigned default NULL,
  `NumberOfProbands` int(6) unsigned default NULL COMMENT 'field used only if Composition = ''Trios''',
  `NumberOfParents` int(6) unsigned default NULL COMMENT 'field used only if Composition = ''Trios''',
  PRIMARY KEY  (`AssayedpanelID`),
  UNIQUE KEY `Identifier` (`Identifier`),
  KEY `StudyID` (`StudyID`),
  CONSTRAINT `Assayedpanel_ibfk_2` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=8105 DEFAULT CHARSET=latin1;

--
-- Table structure for table `AssayedpanelCollection`
--

DROP TABLE IF EXISTS `AssayedpanelCollection`;
CREATE TABLE `AssayedpanelCollection` (
  `AssayedpanelCollectionID` int(10) unsigned NOT NULL auto_increment,
  `AssayedpanelID` int(10) unsigned NOT NULL,
  `ExperimentID` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`AssayedpanelCollectionID`),
  UNIQUE KEY `ExperimentID` (`ExperimentID`,`AssayedpanelID`),
  KEY `AssayedpanelID` (`AssayedpanelID`),
  CONSTRAINT `AssayedpanelCollectionnew_ibfk_2` FOREIGN KEY (`AssayedpanelID`) REFERENCES `Assayedpanel` (`AssayedpanelID`) ON DELETE CASCADE,
  CONSTRAINT `AssayedpanelCollectionnew_ibfk_3` FOREIGN KEY (`ExperimentID`) REFERENCES `Experiment` (`ExperimentID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=35 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Author`
--

DROP TABLE IF EXISTS `Author`;
CREATE TABLE `Author` (
  `AuthorID` int(10) unsigned NOT NULL auto_increment,
  `ResearcherID` smallint(5) unsigned NOT NULL default '0',
  `StudyID` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY  (`AuthorID`),
  UNIQUE KEY `ResearcherID` (`ResearcherID`,`StudyID`),
  KEY `StudyID` (`StudyID`),
  CONSTRAINT `Author_ibfk_1` FOREIGN KEY (`ResearcherID`) REFERENCES `Researcher` (`ResearcherID`),
  CONSTRAINT `Author_ibfk_2` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`)
) ENGINE=InnoDB AUTO_INCREMENT=98 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Build`
--

DROP TABLE IF EXISTS `Build`;
CREATE TABLE `Build` (
  `BuildID` int(10) unsigned NOT NULL auto_increment,
  `Database` varchar(50) NOT NULL,
  `FullName` varchar(250) default NULL,
  `URL` varchar(250) default NULL,
  `Build` varchar(10) NOT NULL default 'N/A' COMMENT 'Start at 21 for HGVbase-G2P. Latest download for dbSNP',
  `Date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`BuildID`),
  UNIQUE KEY `Database` (`Database`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `BundleLoci`
--

DROP TABLE IF EXISTS `BundleLoci`;
CREATE TABLE `BundleLoci` (
  `BundleLociID` int(6) unsigned NOT NULL auto_increment,
  `BundleName` varchar(100) NOT NULL COMMENT 'Name of the standard bundle of markers',
  `Loci` text NOT NULL COMMENT 'Pipe (',
  PRIMARY KEY  (`BundleLociID`),
  UNIQUE KEY `BundleName` (`BundleName`)
) ENGINE=InnoDB AUTO_INCREMENT=514 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Citation`
--

DROP TABLE IF EXISTS `Citation`;
CREATE TABLE `Citation` (
  `CitationID` smallint(5) unsigned NOT NULL auto_increment,
  `DOI` varchar(500) default NULL,
  `PubmedID` int(10) unsigned NOT NULL,
  `Authors` text,
  `Title` varchar(250) default NULL,
  `Detail` varchar(250) default NULL,
  `MeshTerms` text,
  PRIMARY KEY  (`CitationID`),
  UNIQUE KEY `PubmedID` (`PubmedID`),
  UNIQUE KEY `DOI` (`DOI`)
) ENGINE=InnoDB AUTO_INCREMENT=807 DEFAULT CHARSET=latin1;

--
-- Table structure for table `CitationCrossref`
--

DROP TABLE IF EXISTS `CitationCrossref`;
CREATE TABLE `CitationCrossref` (
  `CitationCrossrefID` int(10) unsigned NOT NULL auto_increment,
  `CitationID` smallint(5) unsigned NOT NULL default '0',
  `CrossrefID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CitationCrossrefID`),
  UNIQUE KEY `CitationID` (`CitationID`,`CrossrefID`),
  KEY `CrossrefID` (`CrossrefID`),
  CONSTRAINT `CitationCrossref_ibfk_3` FOREIGN KEY (`CitationID`) REFERENCES `Citation` (`CitationID`) ON DELETE CASCADE,
  CONSTRAINT `CitationCrossref_ibfk_4` FOREIGN KEY (`CrossrefID`) REFERENCES `Crossref` (`CrossrefID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `Composition_TypeList`
--

DROP TABLE IF EXISTS `Composition_TypeList`;
CREATE TABLE `Composition_TypeList` (
  `Type` varchar(100) NOT NULL COMMENT 'initial values: (''Undefined'', ''Unrelated cases'',',
  PRIMARY KEY  (`Type`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `Contribution`
--

DROP TABLE IF EXISTS `Contribution`;
CREATE TABLE `Contribution` (
  `ContributionID` int(10) NOT NULL auto_increment,
  `ResearcherID` smallint(5) unsigned NOT NULL,
  `SubmissionID` int(10) unsigned NOT NULL,
  `IsSubmitter` varchar(5) default NULL,
  `IsAuthor` varchar(5) default NULL,
  `IsSource` varchar(5) NOT NULL,
  PRIMARY KEY  (`ContributionID`),
  KEY `SubmissionID` (`SubmissionID`),
  KEY `ResearcherID` (`ResearcherID`),
  CONSTRAINT `Contribution_ibfk_1` FOREIGN KEY (`SubmissionID`) REFERENCES `Submission` (`SubmissionID`),
  CONSTRAINT `Contribution_ibfk_2` FOREIGN KEY (`ResearcherID`) REFERENCES `Researcher` (`ResearcherID`)
) ENGINE=InnoDB AUTO_INCREMENT=2457 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Crossref`
--

DROP TABLE IF EXISTS `Crossref`;
CREATE TABLE `Crossref` (
  `CrossrefID` int(10) unsigned NOT NULL auto_increment,
  `HotlinkID` int(10) unsigned NOT NULL default '0',
  `UrlID` varchar(100) default '',
  PRIMARY KEY  (`CrossrefID`)
) ENGINE=InnoDB AUTO_INCREMENT=5525 DEFAULT CHARSET=latin1;

--
-- Table structure for table `DiseaseCategory`
--

DROP TABLE IF EXISTS `DiseaseCategory`;
CREATE TABLE `DiseaseCategory` (
  `DiseaseCategoryID` int(6) unsigned NOT NULL auto_increment,
  `ParentCategoryID` int(6) unsigned default NULL COMMENT 'PK for parent category, if this is not a root term',
  `MeSHTreeID` varchar(30) default NULL COMMENT 'MeSH tree ID, for linking back to NLM website',
  `Name` varchar(500) default NULL,
  `Description` text,
  PRIMARY KEY  (`DiseaseCategoryID`),
  KEY `ParentCategoryID` (`ParentCategoryID`),
  CONSTRAINT `DiseaseCategory_ibfk_1` FOREIGN KEY (`ParentCategoryID`) REFERENCES `DiseaseCategory` (`DiseaseCategoryID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=1183 DEFAULT CHARSET=latin1 COMMENT='Rough disease categories for phenotype properties, mostly ba';

--
-- Table structure for table `Experiment`
--

DROP TABLE IF EXISTS `Experiment`;
CREATE TABLE `Experiment` (
  `ExperimentID` int(10) unsigned NOT NULL auto_increment,
  `StudyID` mediumint(8) unsigned NOT NULL,
  `PhenotypeMethodID` int(10) unsigned default NULL,
  `Identifier` varchar(15) default NULL,
  `Name` varchar(100) default NULL,
  `Design` varchar(50) default NULL,
  `Label` varchar(10) default NULL,
  `Accession` varchar(15) default NULL,
  `AccessionVersion` varchar(10) default NULL,
  `Description` text,
  `Type` varchar(100) NOT NULL default '' COMMENT 'In (SELECT [Type] FROM [Experiment_TypeList];)',
  `HotlinkID` int(10) unsigned default NULL,
  `TotalMarkersTested` int(6) unsigned default NULL,
  `TotalMarkersImported` int(6) unsigned default NULL,
  `Objective` text NOT NULL,
  `Outcome` text NOT NULL,
  `Comments` text,
  `IndividualDataStatement` text,
  `FrequencySummary` text,
  `SignificanceSummary` text,
  `TimeCreated` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `GenotypedBundle` varchar(100) default NULL,
  PRIMARY KEY  (`ExperimentID`),
  UNIQUE KEY `Identifier` (`Identifier`),
  KEY `PhenotypeMethodID` (`PhenotypeMethodID`),
  KEY `HotlinkID` (`HotlinkID`),
  KEY `StudyID` (`StudyID`),
  CONSTRAINT `Experiment_ibfk_2` FOREIGN KEY (`PhenotypeMethodID`) REFERENCES `PhenotypeMethod` (`PhenotypeMethodID`),
  CONSTRAINT `Experiment_ibfk_3` FOREIGN KEY (`HotlinkID`) REFERENCES `Hotlink` (`HotlinkID`),
  CONSTRAINT `Experiment_ibfk_4` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=1644 DEFAULT CHARSET=latin1;

--
-- Table structure for table `ExperimentAssayedpanel`
--

DROP TABLE IF EXISTS `ExperimentAssayedpanel`;
CREATE TABLE `ExperimentAssayedpanel` (
  `ExperimentAssayedpanelID` int(10) unsigned NOT NULL auto_increment,
  `AssayedpanelID` int(10) unsigned NOT NULL,
  `ExperimentID` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`ExperimentAssayedpanelID`),
  UNIQUE KEY `ExperimentID` (`ExperimentID`,`AssayedpanelID`),
  KEY `AssayedpanelID` (`AssayedpanelID`),
  CONSTRAINT `ExperimentAssayedpanel_ibfk_2` FOREIGN KEY (`AssayedpanelID`) REFERENCES `Assayedpanel` (`AssayedpanelID`) ON DELETE CASCADE,
  CONSTRAINT `ExperimentAssayedpanel_ibfk_3` FOREIGN KEY (`ExperimentID`) REFERENCES `Experiment` (`ExperimentID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=2059 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Experiment_TypeList`
--

DROP TABLE IF EXISTS `Experiment_TypeList`;
CREATE TABLE `Experiment_TypeList` (
  `Type` varchar(100) NOT NULL default '' COMMENT 'initial values: (''Polymorphism frequency determination'', ''Case-control association study'',',
  PRIMARY KEY  (`Type`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `FCS`
--

DROP TABLE IF EXISTS `FCS`;
CREATE TABLE `FCS` (
  `FCSID` int(10) unsigned NOT NULL auto_increment,
  `SignificanceID` int(12) unsigned NOT NULL,
  `FrequencyClusterID` int(12) unsigned NOT NULL,
  PRIMARY KEY  (`FCSID`),
  UNIQUE KEY `GenotypeSignificanceID` (`SignificanceID`,`FrequencyClusterID`),
  KEY `FrequencyClusterID` (`FrequencyClusterID`),
  CONSTRAINT `FCS_ibfk_2` FOREIGN KEY (`SignificanceID`) REFERENCES `Significance` (`SignificanceID`) ON DELETE CASCADE,
  CONSTRAINT `FCS_ibfk_3` FOREIGN KEY (`FrequencyClusterID`) REFERENCES `FrequencyCluster` (`FrequencyClusterID`)
) ENGINE=InnoDB AUTO_INCREMENT=50513045 DEFAULT CHARSET=latin1;

--
-- Table structure for table `FrequencyCluster`
--

DROP TABLE IF EXISTS `FrequencyCluster`;
CREATE TABLE `FrequencyCluster` (
  `FrequencyClusterID` int(12) unsigned NOT NULL auto_increment,
  `UsedmarkersetID` int(12) unsigned NOT NULL,
  `MarkerID` int(10) unsigned NOT NULL,
  `ExperimentID` int(10) unsigned default NULL,
  `AssayedpanelID` int(10) unsigned NOT NULL,
  `NumberOfGenotypedSamples` smallint(5) unsigned NOT NULL,
  `PValueHWE` decimal(6,5) unsigned default NULL,
  PRIMARY KEY  (`FrequencyClusterID`),
  KEY `AssayedpanelID` (`AssayedpanelID`),
  KEY `ExperimentID` (`ExperimentID`),
  KEY `UsedmarkersetID` (`UsedmarkersetID`),
  KEY `MarkerID` (`MarkerID`),
  CONSTRAINT `FrequencyCluster_ibfk_1` FOREIGN KEY (`AssayedpanelID`) REFERENCES `Assayedpanel` (`AssayedpanelID`) ON DELETE CASCADE,
  CONSTRAINT `FrequencyCluster_ibfk_5` FOREIGN KEY (`ExperimentID`) REFERENCES `Experiment` (`ExperimentID`) ON DELETE CASCADE,
  CONSTRAINT `FrequencyCluster_ibfk_6` FOREIGN KEY (`UsedmarkersetID`) REFERENCES `Usedmarkerset` (`UsedmarkersetID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=25571588 DEFAULT CHARSET=latin1;

--
-- Table structure for table `GenotypeFrequency`
--

DROP TABLE IF EXISTS `GenotypeFrequency`;
CREATE TABLE `GenotypeFrequency` (
  `GenotypeFrequencyID` int(10) unsigned NOT NULL auto_increment,
  `FrequencyClusterID` int(12) unsigned default NULL,
  `GenotypeCombo` varchar(767) default NULL,
  `FrequencyAsProportion` decimal(4,3) unsigned NOT NULL,
  `NumberSamplesWithGenotype` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`GenotypeFrequencyID`),
  KEY `FrequencyClusterID` (`FrequencyClusterID`),
  CONSTRAINT `GenotypeFrequency_ibfk_2` FOREIGN KEY (`FrequencyClusterID`) REFERENCES `FrequencyCluster` (`FrequencyClusterID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=42965704 DEFAULT CHARSET=latin1;

--
-- Table structure for table `GenotypedBundle`
--

DROP TABLE IF EXISTS `GenotypedBundle`;
CREATE TABLE `GenotypedBundle` (
  `GenotypedBundleID` int(10) unsigned NOT NULL auto_increment,
  `BundleLociID` int(6) unsigned NOT NULL,
  `ExperimentID` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`GenotypedBundleID`),
  UNIQUE KEY `BundleLociID_2` (`BundleLociID`,`ExperimentID`),
  KEY `ExperimentID` (`ExperimentID`),
  CONSTRAINT `GenotypedBundle_ibfk_4` FOREIGN KEY (`ExperimentID`) REFERENCES `Experiment` (`ExperimentID`) ON DELETE CASCADE,
  CONSTRAINT `GenotypedBundle_ibfk_5` FOREIGN KEY (`BundleLociID`) REFERENCES `BundleLoci` (`BundleLociID`)
) ENGINE=InnoDB AUTO_INCREMENT=1646 DEFAULT CHARSET=latin1;

--
-- Table structure for table `GenotypedLoci`
--

DROP TABLE IF EXISTS `GenotypedLoci`;
CREATE TABLE `GenotypedLoci` (
  `GenotypedLociID` int(10) unsigned NOT NULL,
  `StudyID` mediumint(8) unsigned NOT NULL,
  `GenotypedLoci` text NOT NULL COMMENT 'Pipe (',
  PRIMARY KEY  (`GenotypedLociID`),
  KEY `StudyID` (`StudyID`),
  CONSTRAINT `GenotypedLoci_ibfk_1` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `Hotlink`
--

DROP TABLE IF EXISTS `Hotlink`;
CREATE TABLE `Hotlink` (
  `HotlinkID` int(10) unsigned NOT NULL auto_increment,
  `HotlinkLabel` varchar(100) NOT NULL COMMENT 'Indicate where the URL is pointing, e.g. "dbSNP refSNP report"',
  `UrlPrefix` varchar(300) NOT NULL,
  `UrlSuffix` varchar(100) default NULL,
  PRIMARY KEY  (`HotlinkID`),
  UNIQUE KEY `HotlinkLabel` (`HotlinkLabel`)
) ENGINE=InnoDB AUTO_INCREMENT=158 DEFAULT CHARSET=latin1;

--
-- Table structure for table `PVSC`
--

DROP TABLE IF EXISTS `PVSC`;
CREATE TABLE `PVSC` (
  `PVSCID` int(10) unsigned NOT NULL auto_increment,
  `PhenotypeValueID` int(10) unsigned NOT NULL,
  `SelectionCriteriaID` int(8) unsigned NOT NULL,
  PRIMARY KEY  (`PVSCID`),
  UNIQUE KEY `PhenotypeValueID` (`PhenotypeValueID`,`SelectionCriteriaID`),
  KEY `SelectionCriteriaID` (`SelectionCriteriaID`),
  CONSTRAINT `PVSC_ibfk_2` FOREIGN KEY (`PhenotypeValueID`) REFERENCES `PhenotypeValue` (`PhenotypeValueID`),
  CONSTRAINT `PVSC_ibfk_3` FOREIGN KEY (`SelectionCriteriaID`) REFERENCES `SelectionCriteria` (`SelectionCriteriaID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=775 DEFAULT CHARSET=latin1;

--
-- Table structure for table `PhenotypeMethod`
--

DROP TABLE IF EXISTS `PhenotypeMethod`;
CREATE TABLE `PhenotypeMethod` (
  `PhenotypeMethodID` int(10) unsigned NOT NULL auto_increment,
  `StudyID` mediumint(8) unsigned NOT NULL COMMENT 'Points to study that this method came in',
  `PhenotypePropertyID` int(10) unsigned NOT NULL,
  `Identifier` varchar(15) default NULL,
  `Name` varchar(255) default NULL,
  `Description` text,
  `Sample` varchar(100) default NULL COMMENT 'Biological system or sample type being assessed',
  `MeasuredAttribute` varchar(100) default NULL COMMENT 'i.e., analyte/feature & property being tested, E.g., Alzheimers\n Disease state, NaCl concentration',
  `VariableType` varchar(25) NOT NULL COMMENT 'Kind of variable: "Continuous", "nominal" or "ordinal"',
  `Unit` varchar(25) default NULL COMMENT 'Unit of measurement (e.g. kg)',
  `Circumstance` text COMMENT 'Any particular conditions under which the test is done',
  `TimeInstant` text COMMENT 'Either; when was the assessment done',
  `TimePeriod` text COMMENT 'Or; over what period was the assessment done',
  `Details` text COMMENT 'Any other specific details of the test',
  PRIMARY KEY  (`PhenotypeMethodID`),
  UNIQUE KEY `Identifier` (`Identifier`),
  KEY `PhenotypePropertyID` (`PhenotypePropertyID`),
  KEY `StudyID` (`StudyID`),
  CONSTRAINT `PhenotypeMethod_ibfk_2` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE,
  CONSTRAINT `PhenotypeMethod_ibfk_3` FOREIGN KEY (`PhenotypePropertyID`) REFERENCES `PhenotypeProperty` (`PhenotypePropertyID`)
) ENGINE=InnoDB AUTO_INCREMENT=1492 DEFAULT CHARSET=latin1;

--
-- Table structure for table `PhenotypeMethodCitation`
--

DROP TABLE IF EXISTS `PhenotypeMethodCitation`;
CREATE TABLE `PhenotypeMethodCitation` (
  `PhenotypeMethodCitationID` int(10) unsigned NOT NULL auto_increment,
  `PhenotypeMethodID` int(10) unsigned NOT NULL default '0',
  `CitationID` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`PhenotypeMethodCitationID`),
  UNIQUE KEY `PhenotypeMethodID` (`PhenotypeMethodID`,`CitationID`),
  KEY `CitationID` (`CitationID`),
  CONSTRAINT `PhenotypeMethodCitation_ibfk_2` FOREIGN KEY (`PhenotypeMethodID`) REFERENCES `PhenotypeMethod` (`PhenotypeMethodID`) ON DELETE CASCADE,
  CONSTRAINT `PhenotypeMethodCitation_ibfk_3` FOREIGN KEY (`CitationID`) REFERENCES `Citation` (`CitationID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `PhenotypeMethodCrossref`
--

DROP TABLE IF EXISTS `PhenotypeMethodCrossref`;
CREATE TABLE `PhenotypeMethodCrossref` (
  `PhenotypeMethodCrossrefID` int(10) unsigned NOT NULL auto_increment,
  `PhenotypeMethodID` int(10) unsigned NOT NULL,
  `CrossrefID` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`PhenotypeMethodCrossrefID`),
  UNIQUE KEY `PhenotypeMethodID` (`PhenotypeMethodID`,`CrossrefID`),
  KEY `CrossrefID` (`CrossrefID`),
  CONSTRAINT `PhenotypeMethodCrossref_ibfk_1` FOREIGN KEY (`PhenotypeMethodID`) REFERENCES `PhenotypeMethod` (`PhenotypeMethodID`) ON DELETE CASCADE,
  CONSTRAINT `PhenotypeMethodCrossref_ibfk_2` FOREIGN KEY (`CrossrefID`) REFERENCES `Crossref` (`CrossrefID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `PhenotypeProperty`
--

DROP TABLE IF EXISTS `PhenotypeProperty`;
CREATE TABLE `PhenotypeProperty` (
  `PhenotypePropertyID` int(10) unsigned NOT NULL auto_increment,
  `DiseaseCategoryID` int(6) unsigned default NULL,
  `Name` varchar(255) default NULL,
  `Description` text,
  PRIMARY KEY  (`PhenotypePropertyID`),
  UNIQUE KEY `Name` (`Name`),
  KEY `DiseaseCategoryID` (`DiseaseCategoryID`),
  CONSTRAINT `PhenotypeProperty_ibfk_1` FOREIGN KEY (`DiseaseCategoryID`) REFERENCES `DiseaseCategory` (`DiseaseCategoryID`)
) ENGINE=InnoDB AUTO_INCREMENT=994 DEFAULT CHARSET=latin1;

--
-- Table structure for table `PhenotypePropertyCitation`
--

DROP TABLE IF EXISTS `PhenotypePropertyCitation`;
CREATE TABLE `PhenotypePropertyCitation` (
  `PhenotypePropertyCitationID` int(10) unsigned NOT NULL auto_increment,
  `PhenotypePropertyID` int(10) unsigned NOT NULL default '0',
  `CitationID` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`PhenotypePropertyCitationID`),
  UNIQUE KEY `PhenotypePropertyID` (`PhenotypePropertyID`,`CitationID`),
  KEY `CitationID` (`CitationID`),
  CONSTRAINT `PhenotypePropertyCitation_ibfk_2` FOREIGN KEY (`PhenotypePropertyID`) REFERENCES `PhenotypeProperty` (`PhenotypePropertyID`),
  CONSTRAINT `PhenotypePropertyCitation_ibfk_3` FOREIGN KEY (`CitationID`) REFERENCES `Citation` (`CitationID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `PhenotypeValue`
--

DROP TABLE IF EXISTS `PhenotypeValue`;
CREATE TABLE `PhenotypeValue` (
  `PhenotypeValueID` int(10) unsigned NOT NULL auto_increment,
  `PhenotypeMethodID` int(10) unsigned NOT NULL COMMENT 'Reference to the method used to generate this value',
  `SamplepanelID` int(10) unsigned default NULL COMMENT 'Reference to the Samplepanel that was measured with the method to get this value (if applicable; not all values are connected to a panel)',
  `Value` varchar(500) NOT NULL COMMENT 'The actual result from the measurement (returned by the assay)  for the individuals on the panel. Can be a mean if variable is continuous (e.g. mean weight)',
  `ValueRank` int(3) unsigned default NULL COMMENT 'Rank of this value, if this is an ordinal (or ranked) variable.',
  `ValueIsMean` varchar(3) default NULL COMMENT 'Flag indicating whether the value is a mean (for a continuous variable) or not',
  `StdDev` float unsigned default NULL COMMENT 'Standard deviation (for continuous variables)',
  `Median` float unsigned default NULL COMMENT 'Median (for continuous variables)',
  `Min` float unsigned default NULL COMMENT 'Minimum value (for continuous variables)',
  `Max` float unsigned default NULL COMMENT 'Maximum value (for continuous variables)',
  `NumberOfIndividuals` int(6) unsigned default NULL COMMENT 'Number of individuals with this value if variable is discreet, or contributing to mean (if variable is continuous)',
  `Qualifier` varchar(100) default NULL COMMENT 'Can be used for setting thresholds (e.g. weight > 80kg) when splitting up panels.',
  PRIMARY KEY  (`PhenotypeValueID`),
  UNIQUE KEY `CombinedMethodID` (`PhenotypeMethodID`,`SamplepanelID`,`Value`),
  KEY `PhenotypeMethodID` (`PhenotypeMethodID`),
  KEY `SamplepanelID` (`SamplepanelID`),
  CONSTRAINT `PhenotypeValue_ibfk_1` FOREIGN KEY (`PhenotypeMethodID`) REFERENCES `PhenotypeMethod` (`PhenotypeMethodID`) ON DELETE CASCADE,
  CONSTRAINT `PhenotypeValue_ibfk_2` FOREIGN KEY (`SamplepanelID`) REFERENCES `Samplepanel` (`SamplepanelID`)
) ENGINE=InnoDB AUTO_INCREMENT=2179 DEFAULT CHARSET=latin1;

--
-- Table structure for table `PhenotypeValueDetail`
--

DROP TABLE IF EXISTS `PhenotypeValueDetail`;
CREATE TABLE `PhenotypeValueDetail` (
  `PhenotypeValueDetailID` int(10) unsigned NOT NULL auto_increment,
  `PhenotypeValueID` int(10) unsigned NOT NULL default '0',
  `Attribute` varchar(100) NOT NULL default '',
  `PhenotypeValueDetail` varchar(150) NOT NULL,
  `UnitOfMeasurement` varchar(30) default NULL,
  `Qualifier` varchar(100) default NULL,
  PRIMARY KEY  (`PhenotypeValueDetailID`),
  UNIQUE KEY `Attribute` (`Attribute`,`PhenotypeValueID`),
  KEY `PhenotypeValueID` (`PhenotypeValueID`),
  CONSTRAINT `PhenotypeValueDetail_ibfk_1` FOREIGN KEY (`PhenotypeValueID`) REFERENCES `PhenotypeValue` (`PhenotypeValueID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `Researcher`
--

DROP TABLE IF EXISTS `Researcher`;
CREATE TABLE `Researcher` (
  `ResearcherID` smallint(5) unsigned NOT NULL auto_increment,
  `SubmitterHandle` varchar(20) default NULL,
  `ShortName` varchar(100) NOT NULL,
  `FullName` varchar(200) default NULL,
  `Department` varchar(100) default NULL,
  `Institution` varchar(100) NOT NULL,
  `Address` varchar(250) default NULL,
  `Phone` varchar(50) default NULL,
  `Fax` varchar(30) default NULL,
  `Email` varchar(150) default NULL,
  `WWW` varchar(100) default NULL,
  PRIMARY KEY  (`ResearcherID`),
  UNIQUE KEY `SubmitterHandle` (`SubmitterHandle`)
) ENGINE=InnoDB AUTO_INCREMENT=726 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Resultset`
--

DROP TABLE IF EXISTS `Resultset`;
CREATE TABLE `Resultset` (
  `ResultsetID` int(10) unsigned NOT NULL auto_increment,
  `ExperimentID` int(10) unsigned NOT NULL,
  `AnalysisMethodID` int(10) unsigned default NULL,
  `Identifier` varchar(15) default NULL,
  `Name` varchar(100) default NULL,
  `Label` varchar(10) default NULL,
  `Accession` varchar(15) default NULL,
  `AccessionVersion` varchar(10) default NULL,
  `Description` text,
  `ProtocolParameters` text,
  `TimeCreated` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ResultsetID`),
  UNIQUE KEY `Identifier` (`Identifier`),
  UNIQUE KEY `Name` (`Name`,`ExperimentID`),
  KEY `ExperimentID` (`ExperimentID`),
  KEY `AnalysisMethodID` (`AnalysisMethodID`),
  CONSTRAINT `Resultset_ibfk_2` FOREIGN KEY (`AnalysisMethodID`) REFERENCES `AnalysisMethod` (`AnalysisMethodID`),
  CONSTRAINT `Resultset_ibfk_3` FOREIGN KEY (`ExperimentID`) REFERENCES `Experiment` (`ExperimentID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=1351 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Samplepanel`
--

DROP TABLE IF EXISTS `Samplepanel`;
CREATE TABLE `Samplepanel` (
  `SamplepanelID` int(10) unsigned NOT NULL auto_increment,
  `SubmittedInStudyID` mediumint(8) unsigned default NULL,
  `StudyID` mediumint(8) unsigned default NULL,
  `ParentSamplepanelID` int(10) unsigned default NULL,
  `Identifier` varchar(15) default NULL,
  `Name` varchar(100) default NULL,
  `Label` varchar(10) default NULL,
  `Accession` varchar(15) default NULL,
  `AccessionVersion` varchar(10) default NULL,
  `Description` text,
  `Composition` varchar(100) default NULL COMMENT 'In (SELECT [Composition] FROM [CompositionList];)',
  `TotalNumberOfIndividuals` int(6) unsigned default NULL COMMENT '*...but required for association datasets',
  `NumberOfSexMale` int(6) unsigned default NULL,
  `NumberOfSexFemale` int(6) unsigned default NULL,
  `NumberOfSexUnknown` int(6) unsigned default NULL,
  `NumberOfProbands` int(6) unsigned default NULL COMMENT 'field used only if Composition = ''Trios''',
  `NumberOfParents` int(6) unsigned default NULL COMMENT 'field used only if Composition = ''Trios''',
  `ModeOfRecruitment` varchar(250) default NULL,
  `DiagnosisAgeRange` varchar(150) default NULL,
  `DiagnosisPeriod` varchar(150) default NULL,
  `SamplingAgeRange` varchar(150) default NULL,
  `SamplingPeriod` varchar(150) default NULL,
  `PopulationInfo` varchar(250) default NULL,
  `GeographicRegionInfo` varchar(250) default NULL,
  `EthnicityInfo` varchar(250) default NULL,
  `BirthPlaceInfo` varchar(250) default NULL,
  `AdmixtureInfo` varchar(250) default NULL,
  `EnvironmentInfo` text,
  `SourceOfDNA` varchar(100) default NULL COMMENT 'In (SELECT [SourceOfDNA] FROM [Sampleset_SourceOfDNAList];)',
  `DNAsArePooled` enum('Undefined','Pre-prep','Post-prep','No') NOT NULL default 'Undefined',
  `DNAsAreWGA` enum('Undefined','None','All','Some') NOT NULL default 'Undefined',
  PRIMARY KEY  (`SamplepanelID`),
  UNIQUE KEY `Name` (`Name`,`SubmittedInStudyID`),
  UNIQUE KEY `Identifier` (`Identifier`),
  KEY `StudyID` (`StudyID`),
  KEY `ParentSamplepanelID` (`ParentSamplepanelID`),
  KEY `SubmittedInStudyID` (`SubmittedInStudyID`),
  CONSTRAINT `Samplepanel_ibfk_1` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE,
  CONSTRAINT `Samplepanel_ibfk_2` FOREIGN KEY (`ParentSamplepanelID`) REFERENCES `Samplepanel` (`SamplepanelID`),
  CONSTRAINT `Samplepanel_ibfk_3` FOREIGN KEY (`SubmittedInStudyID`) REFERENCES `Study` (`StudyID`)
) ENGINE=InnoDB AUTO_INCREMENT=6811 DEFAULT CHARSET=latin1;

--
-- Table structure for table `SamplepanelCrossref`
--

DROP TABLE IF EXISTS `SamplepanelCrossref`;
CREATE TABLE `SamplepanelCrossref` (
  `SamplepanelCrossrefID` int(10) unsigned NOT NULL auto_increment,
  `SamplepanelID` int(10) unsigned NOT NULL,
  `CrossrefID` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`SamplepanelCrossrefID`),
  UNIQUE KEY `SamplepanelID` (`SamplepanelID`,`CrossrefID`),
  KEY `CrossrefID` (`CrossrefID`),
  CONSTRAINT `SamplepanelCrossref_ibfk_5` FOREIGN KEY (`SamplepanelID`) REFERENCES `Samplepanel` (`SamplepanelID`) ON DELETE CASCADE,
  CONSTRAINT `SamplepanelCrossref_ibfk_6` FOREIGN KEY (`CrossrefID`) REFERENCES `Crossref` (`CrossrefID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5744 DEFAULT CHARSET=latin1;

--
-- Table structure for table `SamplepanelOverlap`
--

DROP TABLE IF EXISTS `SamplepanelOverlap`;
CREATE TABLE `SamplepanelOverlap` (
  `SamplepanelOverlapID` smallint(5) unsigned NOT NULL default '0',
  `SamplepanelID_New` int(10) unsigned NOT NULL default '0' COMMENT 'This ID is the current Sampleset',
  `SamplepanelID_Old` int(10) unsigned NOT NULL default '0' COMMENT 'This ID is the overlapping Sampleset',
  `OverlapDetails` varchar(250) default 'This samplepanel overlaps with another',
  PRIMARY KEY  (`SamplepanelOverlapID`),
  KEY `SamplesetID_New` (`SamplepanelID_New`),
  KEY `SamplesetID_Old` (`SamplepanelID_Old`),
  CONSTRAINT `SamplepanelOverlap_ibfk_1` FOREIGN KEY (`SamplepanelID_New`) REFERENCES `Samplepanel` (`SamplepanelID`),
  CONSTRAINT `SamplepanelOverlap_ibfk_2` FOREIGN KEY (`SamplepanelID_Old`) REFERENCES `Samplepanel` (`SamplepanelID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `Samplepanel_SourceOfDNAList`
--

DROP TABLE IF EXISTS `Samplepanel_SourceOfDNAList`;
CREATE TABLE `Samplepanel_SourceOfDNAList` (
  `SourceOfDNA` varchar(100) NOT NULL default '' COMMENT 'initial values: (''Cultured cells'',''Tissue biopsy''',
  PRIMARY KEY  (`SourceOfDNA`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `SelectionCriteria`
--

DROP TABLE IF EXISTS `SelectionCriteria`;
CREATE TABLE `SelectionCriteria` (
  `SelectionCriteriaID` int(8) unsigned NOT NULL auto_increment,
  `AssayedpanelID` int(10) unsigned NOT NULL,
  `SamplepanelID` int(10) unsigned default NULL,
  `SourceAssayedpanelID` int(10) unsigned default NULL COMMENT 'Points to assayedpanel (usually more than one) that a given apanel is made up from',
  `EnvironmentCriteria` varchar(500) default 'No selection',
  `NumberOfIndividuals` int(6) unsigned default NULL,
  PRIMARY KEY  (`SelectionCriteriaID`),
  UNIQUE KEY `AssayedpanelID` (`AssayedpanelID`,`SamplepanelID`),
  UNIQUE KEY `SourceAssayedpanelID` (`SourceAssayedpanelID`,`AssayedpanelID`),
  KEY `SamplepanelID` (`SamplepanelID`),
  CONSTRAINT `SelectionCriteria_ibfk_16` FOREIGN KEY (`AssayedpanelID`) REFERENCES `Assayedpanel` (`AssayedpanelID`) ON DELETE CASCADE,
  CONSTRAINT `SelectionCriteria_ibfk_17` FOREIGN KEY (`SamplepanelID`) REFERENCES `Samplepanel` (`SamplepanelID`) ON DELETE CASCADE,
  CONSTRAINT `SelectionCriteria_ibfk_18` FOREIGN KEY (`SourceAssayedpanelID`) REFERENCES `Assayedpanel` (`AssayedpanelID`)
) ENGINE=InnoDB AUTO_INCREMENT=8036 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Significance`
--

DROP TABLE IF EXISTS `Significance`;
CREATE TABLE `Significance` (
  `SignificanceID` int(12) unsigned NOT NULL auto_increment,
  `ResultsetID` int(10) unsigned default NULL,
  `UsedmarkersetID` int(12) unsigned NOT NULL,
  `UnadjustedPValue` float unsigned default NULL,
  `AdjustedPValue` float unsigned default NULL,
  `OddsRatioStatement` varchar(250) default NULL,
  `AttributableRiskStatement` varchar(250) default NULL,
  PRIMARY KEY  (`SignificanceID`),
  KEY `UsedmarkersetID` (`UsedmarkersetID`),
  KEY `UnadjustedPValue` (`UnadjustedPValue`),
  KEY `ResultsetID` (`ResultsetID`),
  CONSTRAINT `Significance_ibfk_23` FOREIGN KEY (`UsedmarkersetID`) REFERENCES `Usedmarkerset` (`UsedmarkersetID`) ON DELETE CASCADE,
  CONSTRAINT `Significance_ibfk_25` FOREIGN KEY (`ResultsetID`) REFERENCES `Resultset` (`ResultsetID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=21537636 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Study`
--

DROP TABLE IF EXISTS `Study`;
CREATE TABLE `Study` (
  `StudyID` mediumint(8) unsigned NOT NULL auto_increment,
  `Identifier` varchar(15) default NULL,
  `Name` varchar(500) default NULL,
  `Label` varchar(10) default NULL,
  `Accession` varchar(15) default NULL,
  `AccessionVersion` varchar(10) default NULL,
  `Description` text,
  `IsHidden` char(5) default NULL,
  `ResearcherID` smallint(5) unsigned default NULL,
  `Abstract` text NOT NULL,
  `Background` text,
  `Objectives` text NOT NULL,
  `KeyResults` text NOT NULL,
  `Conclusions` text NOT NULL,
  `StudyDesign` text,
  `StudySizeReason` text,
  `StudyPower` text,
  `SourcesOfBias` text,
  `Limitations` text,
  `Acknowledgements` text,
  `TimeCreated` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `TimeUpdated` timestamp NOT NULL default '0000-00-00 00:00:00',
  `IsDisplayed` char(5) default NULL,
  PRIMARY KEY  (`StudyID`),
  UNIQUE KEY `Identifier` (`Identifier`),
  KEY `ResearcherID` (`ResearcherID`),
  CONSTRAINT `Study_ibfk_1` FOREIGN KEY (`ResearcherID`) REFERENCES `Researcher` (`ResearcherID`)
) ENGINE=InnoDB AUTO_INCREMENT=749 DEFAULT CHARSET=latin1 COMMENT='A DATASET COMPRISING ALL EXPERIMENTS RELEVANT TO ONE RESEARC';

--
-- Table structure for table `StudyAnalysisMethod`
--

DROP TABLE IF EXISTS `StudyAnalysisMethod`;
CREATE TABLE `StudyAnalysisMethod` (
  `StudyAnalysisMethodID` int(10) unsigned NOT NULL auto_increment,
  `StudyID` mediumint(8) unsigned NOT NULL,
  `AnalysisMethodID` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`StudyAnalysisMethodID`),
  UNIQUE KEY `StudyID` (`StudyID`,`AnalysisMethodID`),
  KEY `AnalysisMethodID` (`AnalysisMethodID`),
  CONSTRAINT `StudyAnalysisMethod_ibfk_1` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE,
  CONSTRAINT `StudyAnalysisMethod_ibfk_2` FOREIGN KEY (`AnalysisMethodID`) REFERENCES `AnalysisMethod` (`AnalysisMethodID`)
) ENGINE=InnoDB AUTO_INCREMENT=1341 DEFAULT CHARSET=latin1;

--
-- Table structure for table `StudyCitation`
--

DROP TABLE IF EXISTS `StudyCitation`;
CREATE TABLE `StudyCitation` (
  `StudyCitationID` int(10) unsigned NOT NULL auto_increment,
  `StudyID` mediumint(8) unsigned NOT NULL default '0',
  `CitationID` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`StudyCitationID`),
  UNIQUE KEY `StudyID` (`StudyID`,`CitationID`),
  KEY `CitationID` (`CitationID`),
  CONSTRAINT `StudyCitation_ibfk_2` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE,
  CONSTRAINT `StudyCitation_ibfk_3` FOREIGN KEY (`CitationID`) REFERENCES `Citation` (`CitationID`)
) ENGINE=InnoDB AUTO_INCREMENT=1752 DEFAULT CHARSET=latin1;

--
-- Table structure for table `StudyCrossref`
--

DROP TABLE IF EXISTS `StudyCrossref`;
CREATE TABLE `StudyCrossref` (
  `StudyCrossrefID` int(10) unsigned NOT NULL auto_increment,
  `StudyID` mediumint(8) unsigned NOT NULL default '0',
  `CrossrefID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`StudyCrossrefID`),
  UNIQUE KEY `StudyID` (`StudyID`,`CrossrefID`),
  KEY `CrossrefID` (`CrossrefID`),
  CONSTRAINT `StudyCrossref_ibfk_4` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE,
  CONSTRAINT `StudyCrossref_ibfk_5` FOREIGN KEY (`CrossrefID`) REFERENCES `Crossref` (`CrossrefID`)
) ENGINE=InnoDB AUTO_INCREMENT=984 DEFAULT CHARSET=latin1;

--
-- Table structure for table `StudyOverlap`
--

DROP TABLE IF EXISTS `StudyOverlap`;
CREATE TABLE `StudyOverlap` (
  `StudyOverlapID` smallint(5) unsigned NOT NULL,
  `StudyID_New` mediumint(8) unsigned NOT NULL COMMENT 'This ID is the current Study ',
  `StudyID_Old` mediumint(8) unsigned NOT NULL COMMENT 'This ID is the overlapping Study',
  `OverlapDetails` varchar(50) NOT NULL default 'This Study overlaps with another',
  PRIMARY KEY  (`StudyOverlapID`),
  UNIQUE KEY `StudyID_New` (`StudyID_New`,`StudyID_Old`),
  KEY `StudyID_Old` (`StudyID_Old`),
  CONSTRAINT `StudyOverlap_ibfk_1` FOREIGN KEY (`StudyID_New`) REFERENCES `Study` (`StudyID`),
  CONSTRAINT `StudyOverlap_ibfk_2` FOREIGN KEY (`StudyID_Old`) REFERENCES `Study` (`StudyID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `StudySamplepanel`
--

DROP TABLE IF EXISTS `StudySamplepanel`;
CREATE TABLE `StudySamplepanel` (
  `StudySamplepanel` int(10) unsigned NOT NULL auto_increment,
  `StudyID` mediumint(8) unsigned NOT NULL,
  `SamplepanelID` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`StudySamplepanel`),
  UNIQUE KEY `StudyID` (`StudyID`,`SamplepanelID`),
  KEY `SamplepanelID` (`SamplepanelID`),
  CONSTRAINT `StudySamplepanel_ibfk_1` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`) ON DELETE CASCADE,
  CONSTRAINT `StudySamplepanel_ibfk_2` FOREIGN KEY (`SamplepanelID`) REFERENCES `Samplepanel` (`SamplepanelID`)
) ENGINE=InnoDB AUTO_INCREMENT=5111 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Submission`
--

DROP TABLE IF EXISTS `Submission`;
CREATE TABLE `Submission` (
  `SubmissionID` int(10) unsigned NOT NULL auto_increment,
  `StudyID` mediumint(8) unsigned NOT NULL,
  `Name` varchar(100) NOT NULL,
  `Description` text,
  `TimeCreated` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`SubmissionID`),
  UNIQUE KEY `StudyID` (`StudyID`,`Name`),
  CONSTRAINT `Submission_ibfk_1` FOREIGN KEY (`StudyID`) REFERENCES `Study` (`StudyID`)
) ENGINE=InnoDB AUTO_INCREMENT=916 DEFAULT CHARSET=latin1;

--
-- Table structure for table `Usedmarkerset`
--

DROP TABLE IF EXISTS `Usedmarkerset`;
CREATE TABLE `Usedmarkerset` (
  `UsedmarkersetID` int(10) unsigned NOT NULL auto_increment,
  `ExperimentID` int(10) unsigned default NULL,
  `MarkersetID` int(10) unsigned NOT NULL,
  `MarkerIdentifier` varchar(15) default NULL,
  `Name` varchar(100) default NULL,
  PRIMARY KEY  (`UsedmarkersetID`),
  UNIQUE KEY `ExperimentID` (`ExperimentID`,`MarkerIdentifier`),
  KEY `Name` (`Name`),
  CONSTRAINT `Usedmarkerset_ibfk_1` FOREIGN KEY (`ExperimentID`) REFERENCES `Experiment` (`ExperimentID`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=21286736 DEFAULT CHARSET=latin1;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-07-17 11:38:24
