/*
 * AlleleFrequencyCluster.java
 *
 * Created on den 19 december 2006, 13:58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.data;

import phenobase.storage.*;
import java.io.*;

/**
 *
 * @author fresjo
 */
public class AlleleFrequencyCluster implements DataElement {
    
    /** Creates a new instance of AlleleFrequencyCluster */
    public AlleleFrequencyCluster() {
        COUNT++;
        id = COUNT;
        alleleFrequencies = new DataArray();
    }
    
    public AlleleFrequencyCluster(int i) {
        id = i;
        alleleFrequencies = new DataArray();
    }
    
    public void setExperiment(Experiment e) {
        experiment = e;
    }
    
    public Experiment getExperiment() {
        return experiment;
    }
    
    public void setAssayedpanel(Assayedpanel ap) {
        assayedpanel = ap;
    }
    
    public Assayedpanel getAssayedpanel() {
        return assayedpanel;
    }
    
    public void setMarker(Marker m) {
        marker = m;
    }
    
    public Marker getMarker() {
        return marker;
    }
    
    public void setNrGenotypedSamples(int i) {
        nrGenotypedSamples = i;
    }
    
    public int getNrGenotypedSamples() {
        return nrGenotypedSamples;
    }
        
    public void addAlleleFrequency(AlleleFrequency gf) {
        alleleFrequencies.add(gf);
    }
    
    public Object[] getAlleleComboArray() {
        return alleleFrequencies.getArray();
    }
    
    public String toString() {
        return assayedpanel.getLabID() + " ON " + marker.getRsID();
    }
    
    public int getType() {
        return DataElement.ALLELE_FREQUENCY_CLUSTER;
    }
    
    public int getID() {
        return id;
    }
    
    public void writeXML(PrintStream out, int offset) {
        String offsetString = "";
        for(int i = 0; i < offset; i++) {
            offsetString = offsetString + " ";
        }
        out.println(offsetString + "<alleleFrequencyCluster>");
        out.println(offsetString + "  <id>" + id + "</id>");
        out.println(offsetString + "  <experimentID>" + experiment.getID() + "</experimentID>");
        out.println(offsetString + "  <assayedpanelID>" + assayedpanel.getID() + "</assayedpanelID>");
        out.println(offsetString + "  <markerID>" + marker.getID() + "</markerID>");
        out.println(offsetString + "  <nrGenotypedSamples>" + nrGenotypedSamples + "</nrGenotypedSamples>");
        for(int i = 0; i < alleleFrequencies.nrOfElements(); i++) {
            AlleleFrequency af = (AlleleFrequency)alleleFrequencies.get(i);
            af.writeXML(out, offset + 2);
        }
        out.println(offsetString + "</alleleFrequencyCluster>");
    }

    public static int COUNT;
    
    private int id;
    private Experiment experiment;
    private Assayedpanel assayedpanel;
    private Marker marker;
    private int nrGenotypedSamples;
    private DataArray alleleFrequencies;
    
}
