/*
 * AlleleSignificance.java
 *
 * Created on den 19 december 2006, 13:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.data;

import java.io.*;

/**
 *
 * @author fresjo
 */
public class AlleleSignificance extends Significance implements DataElement {
    
    /** Creates a new instance of AlleleSignificance */
    public AlleleSignificance() {
        COUNT++;
        id = COUNT;
    }
    
    public AlleleSignificance(int i) {
        id = i;
    }
    
    public void setCount(int i) {
        COUNT = i;
    }
  
    public void setCluster1(AlleleFrequencyCluster c) {
        cluster1 = c;
    }
    
    public AlleleFrequencyCluster getCluster1() {
        return cluster1;
    }
    
    public void setCluster2(AlleleFrequencyCluster c) {
        cluster2 = c;
    }
    
    public AlleleFrequencyCluster getCluster2() {
        return cluster2;
    }
    
    public String toString() {
        return cluster1 + " - " + cluster2 + " : " + getPValue();
    }
        
    public int getType() {
        return DataElement.ALLELE_SIGNIFICANCE;
    }
    
    public int getID() {
        return id;
    }
    
    public void writeXML(PrintStream out, int offset) {
        String os = "";
        for(int i = 0; i < offset; i++) {
            os = os + " ";
        }
        out.println(os + "<alleleSignificance>");
        out.println(os + "  <alleleFrequencyCluster1>" + cluster1.getID() + "</alleleFrequencyCluster1>");
        out.println(os + "  <alleleFrequencyCluster2>" + cluster2.getID() + "</alleleFrequencyCluster2>");
        out.println(os + "  <pValue>" + getPValue() + "</pValue>");
        out.println(os + "  <oddsRatioStatement>" + getOddsRatioStatement() + "</oddsRatioStatement>");
        out.println(os + "  <attributableRiskStatement>" + getAttributableRiskStatement() + "</attributableRiskStatement>");
        out.println(os + "  <statisticalMethod>" + getStatisticalMethod() + "</statisticalMethod>");
        out.println(os + "</alleleSignificance>");
    }
    
    public static int COUNT;
    
    private int id;
    private AlleleFrequencyCluster cluster1;
    private AlleleFrequencyCluster cluster2;
    
}
