/*
 * Experiement.java
 *
 * Created on den 19 december 2006, 15:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.data;

import phenobase.storage.*;
import java.io.*;

/**
 *
 * @author fresjo
 */
public class Experiment implements DataElement {
    
    /** Creates a new instance of Experiement */
    public Experiment() {
        COUNT++;
        id = COUNT;
        significances = new DataArray();
        assayedpanels = new DataArray();
        markers = new DataArray();
    }
    
    public Experiment(int i) {
        id = i;
    }
    
    public void setCount(int i) {
        COUNT = i;
    }
    
    public void setExpType(String s) {
        type = s;
    }
    
    public String getExpType() {
        return type;
    }
    
    public void setObjective(String s) {
        objective = s;
    }
    
    public String getObjective() {
        return objective;
    }
    
    public void setOutcome(String s) {
        outcome = s;
    }
    
    public String getOutcome() {
        return outcome;
    }
    
    public void setComments(String s) {
        comments = s;
    }
    
    public String getComments() {
        return comments;
    }
    
    public void setDbSNPBatch(String s) {
        dbSNPBatch = s;
    }
    
    public String getDbSNPBatch() {
        return dbSNPBatch;
    }
    
    public void addAssayedpanel(Assayedpanel a) {
        assayedpanels.add(a);
    }
    
    public void deleteAssayedpanel(int id) {
        for(int i = 0; i < assayedpanels.nrOfElements(); i++) {
            Assayedpanel a = (Assayedpanel)assayedpanels.get(i);
            if(a.getID() == id) {
                try {
                    assayedpanels.remove(i);
                }
                catch(StorageException se) {

                }
            }
        }
    }
    
    public Object[] getAssayedpanelArray() {
        return assayedpanels.getArray();
    }
   
    public void addMarker(Marker m) {
        markers.add(m);
    }
    
    public void deleteMarker(int id) {
        for(int i = 0; i < markers.nrOfElements(); i++) {
            Marker m = (Marker)markers.get(i);
            if(m.getID() == id) {
                try {
                    markers.remove(i);
                }
                catch(StorageException se) {

                }
            }
        }
    }
    
    public Object[] getMarkerArray() {
        return markers.getArray();
    }
    
    public void addSignificance(Object o) {
        significances.add(o);
    }
    
    public void deleteSignificance(int type, int id) {
        for(int i = 0; i < significances.nrOfElements(); i++) {
            DataElement de = (DataElement)significances.get(i);
            if(de.getType() == type) {
                if(de.getID() == id) {
                    try {
                        significances.remove(i);
                    }
                    catch(StorageException se) {
                        
                    }
                }
            }
        }
    }
    
    public Object[] getSignificanceArray() {
        return significances.getArray();
    }
    
    public String toString() {
        return type;
    }
    
    public int getType() {
        return DataElement.EXPERIMENT;
    }
    
    public int getID() {
        return id;
    }
    
    public void writeXML(PrintStream out, int offset) {
        
    }
    
    public static int COUNT;
    
    private int id;
    private String type;
    private String objective;
    private String outcome;
    private String comments;
    private String dbSNPBatch;
    private DataArray assayedpanels;
    private DataArray markers;
    private DataArray significances;
}
