/*
 * GenotypeFrequencyCluster.java
 *
 * Created on den 18 december 2006, 16:01
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.data;

import java.io.*;
import phenobase.storage.*;

/**
 *
 * @author fresjo
 */
public class GenotypeFrequencyCluster implements DataElement {
    
    /** Creates a new instance of GenotypeFrequencyCluster */
    public GenotypeFrequencyCluster() {
        COUNT++;
        id = COUNT;
        genotypeFrequencies = new DataArray();
    }
    
    public void setExperiment(Experiment e) {
        experiment = e;
    }
    
    public Experiment getExperiment() {
        return experiment;
    }
    
    public void setAssayedpanel(Assayedpanel ap) {
        assayedpanel = ap;
    }
    
    public Assayedpanel getAssayedpanel() {
        return assayedpanel;
    }
    
    public void setMarker(Marker m) {
        marker = m;
    }
    
    public Marker getMarker() {
        return marker;
    }
    
    public void setNrGenotypedSamples(int i) {
        nrGenotypedSamples = i;
    }
    
    public int getNrGenotypedSamples() {
        return nrGenotypedSamples;
    }
    
    public void setPValueHWE(float f) {
        pValueHWE = f;
    }
    
    public float getPValueHWE() {
        return pValueHWE;
    }
    
    public void addGenotypeFrequency(GenotypeFrequency gf) {
        genotypeFrequencies.add(gf);
    }
    
    public Object[] getGenotypeComboArray() {
        return genotypeFrequencies.getArray();
    }
    
    public String toString() {
        return assayedpanel.getLabID() + " ON " + marker.getRsID();
    }
    
    public int getType() {
        return DataElement.GENOTYPE_FREQUENCY_CLUSTER;
    }
    
    public int getID() {
        return id;
    }
    
    public void writeXML(PrintStream out, int offset) {
        String offsetString = "";
        for(int i = 0; i < offset; i++) {
            offsetString = offsetString + " ";
        }
        out.println(offsetString + "<genotypeFrequencyCluster>");
        out.println(offsetString + "  <id>" + id + "</id>");
        out.println(offsetString + "  <experimentID>" + experiment.getID() + "</experimentID>");
        out.println(offsetString + "  <assayedpanelID>" + assayedpanel.getID() + "</assayedpanelID>");
        out.println(offsetString + "  <markerID>" + marker.getID() + "</markerID>");
        out.println(offsetString + "  <nrGenotypedSamples>" + nrGenotypedSamples + "</nrGenotypedSamples>");
        out.println(offsetString + "  <pValueHWE>" + pValueHWE + "</pValueHWE>");
        for(int i = 0; i < genotypeFrequencies.nrOfElements(); i++) {
            GenotypeFrequency gf = (GenotypeFrequency)genotypeFrequencies.get(i);
            gf.writeXML(out, offset + 2);
        }
        out.println(offsetString + "</genotypeFrequencyCluster>");
    }

    public static int COUNT;
    
    private int id;
    private Experiment experiment;
    private Assayedpanel assayedpanel;
    private Marker marker;
    private int nrGenotypedSamples;
    private DataArray genotypeFrequencies;
    private float pValueHWE;
}
