/*
 * GenotypeSignificance.java
 *
 * Created on den 19 december 2006, 13:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.data;

import java.io.*;

/**
 *
 * @author fresjo
 */
public class GenotypeSignificance extends Significance implements DataElement  {
    
    /** Creates a new instance of GenotypeSignificance */
    public GenotypeSignificance() {
        COUNT++;
        id = COUNT;
    }
    
    public GenotypeSignificance(int i) {
        id = i;
    }
    
    public void setCount(int i) {
        COUNT = i;
    }
  
    public void setCluster1(GenotypeFrequencyCluster c) {
        cluster1 = c;
    }
    
    public GenotypeFrequencyCluster getCluster1() {
        return cluster1;
    }
    
    public void setCluster2(GenotypeFrequencyCluster c) {
        cluster2 = c;
    }
    
    public GenotypeFrequencyCluster getCluster2() {
        return cluster2;
    }
        
    public String toString() {
        return cluster1 + " - " + cluster2 + " : " + getPValue();
    }
    
    public int getType() {
        return DataElement.GENOTYPE_SIGNIFICANCE;
    }
    
    public int getID() {
        return id;
    }
    
    public void writeXML(PrintStream out, int offset) {
        String os = "";
        for(int i = 0; i < offset; i++) {
            os = os + " ";
        }
        out.println(os + "<genotypeSignificance>");
        out.println(os + "  <genotypeFrequencyClusterID1>" + cluster1.getID() + "</genotypeFrequencyClusterID1>");
        out.println(os + "  <genotypeFrequencyClusterID2>" + cluster2.getID() + "</genotypeFrequencyClusterID2>");
        out.println(os + "  <pValue>" + getPValue() + "</pValue>");
        out.println(os + "  <oddsRatioStatement>" + getOddsRatioStatement() + "</oddsRatioStatement>");
        out.println(os + "  <attributableRiskStatement>" + getAttributableRiskStatement() + "</attributableRiskStatement>");
        out.println(os + "  <statisticalMethod>" + getStatisticalMethod() + "</statisticalMethod>");
        out.println(os + "</genotypeSignificance>");
    }
    
    public static int COUNT;
    
    private int id;
    private GenotypeFrequencyCluster cluster1;
    private GenotypeFrequencyCluster cluster2;
    
}
