/*
 * Observation.java
 *
 * Created on den 27 april 2006, 14:49
 */

package phenobase.data;

import java.io.*;
import phenobase.storage.*;

/**
 *
 * @author fresjo
 */
public class PhenotypeValue implements DataElement {
    
    public static int COUNT;
    
    private String phenotypeMethod;
    private String phenotypeValue;
    private DataArray phenotypeValueDetails;
    private int id;
    
    /** Creates a new instance of Observation */
    public PhenotypeValue() {
        phenotypeMethod = "";
        phenotypeValue = "";
        phenotypeValueDetails = new DataArray();
        id = COUNT;
        COUNT++;
    }
    
    public int getType() {
        return DataElement.PHENOTYPE_VALUE;
    }
    
    public int getID() {
        return id;
    }
    
    public void setPhenotypeMethod(String s) {
        phenotypeMethod = s;
    }
    
    public String getPhenotypeMethod() {
        return phenotypeMethod;
    }
        
    public void setPhenotypeValue(String s) {
        phenotypeValue = s;
    }
    
    public String getPhenotypeValue() {
        return phenotypeValue;
    }
    
    public void addPhenotypeValueDetail(PhenotypeValueDetail v) {
        phenotypeValueDetails.add(v);
    }
    
    public Object[] getPhenotypeValueDetailArray() {
        return phenotypeValueDetails.getArray();
    }
    
    public String toString() {
        return phenotypeValue;
    }
    
    public void writeXML(PrintStream out, int offset) {
        String offsetString = "";
        for(int i = 0; i < offset; i++) {
            offsetString = offsetString + " ";
        }
        out.println(offsetString + "<phenotypeValue>");
        out.println(offsetString + "  <phenotypeMethod>" + phenotypeMethod + "</phenotypeMethod>");
        out.println(offsetString + "  <value>" + phenotypeValue + "</value>");
        for(int i = 0; i < phenotypeValueDetails.nrOfElements(); i++) {
            PhenotypeValueDetail tmp = (PhenotypeValueDetail)phenotypeValueDetails.get(i);
            tmp.writeXML(out, offset + 2);
        }
        out.println(offsetString + "</phenotypeValue>");
    }
}
