/*
 * Measurement.java
 *
 * Created on den 15 mars 2005, 10:54
 */

package phenobase.data;

import java.io.*;

/**
 *
 */
public class PhenotypeValueDetail implements DataElement {
    
    public static int COUNT;
    
    private String attribute;
    private String qualifier;
    private String unitOfMeasurement;
    private String phenotypeValueDetail;
    private int id;
    
    /** Creates a new instance of Measurement */
    public PhenotypeValueDetail() {
        attribute = "";
        qualifier = "=";
        unitOfMeasurement = "";
        phenotypeValueDetail = "";
        id = COUNT;
        COUNT++;
    }
    
    public int getType() {
        return DataElement.PHENOTYPE_VALUE_DETAIL;
    }
    
    public int getID() {
        return id;
    }
    
    public void setAttribute(String s) {
        attribute = s;
    }
        
    public void setQualifier(String s) {
        qualifier = s;
    }
    
    public void setUnitOfMeasurement(String s) {
        unitOfMeasurement = s;
    }
    
    public void setPhenotypeValueDetail(String s) {
        phenotypeValueDetail = s;
    }
    
    public String getAttribute() {
        return attribute;
    }
    
    public String getQualifier() {
        return qualifier;
    }
    
    public String getUnitOfMeasurement() {
        return unitOfMeasurement;
    }
    
    public String getPhenotypeValueDetail() {
        return phenotypeValueDetail;
    }
    
    public Object[] getTableRow() {
        Object[] row = new Object[4];
        row[0] = attribute;
        row[1] = phenotypeValueDetail;
        row[2] = unitOfMeasurement;
        row[3] = qualifier;
        return row;
    }
    
    public void writeXML(PrintStream out, int offset) {
        String offsetString = "";
        for(int i = 0; i < offset; i++) {
            offsetString = offsetString + " ";
        }
        out.println(offsetString + "<phenotypeValueDetail>"); 
        out.println(offsetString + "  <attribute>" + attribute + "</attribute>");
        out.println(offsetString + "  <value>" + phenotypeValueDetail + "</value>");
        out.println(offsetString + "  <qualifier>" + qualifier + "</qualifier>");
        out.println(offsetString + "  <unitOfMeasurement>" + unitOfMeasurement + "</unitOfMeasurement>");
        out.println(offsetString + "</phenotypeValueDetail>");
    }
}
