/*
 * Sampleset.java
 *
 * Created on den 14 november 2005, 16:40
 */

package phenobase.data;

import java.io.*;
import phenobase.storage.*;

/**
 *
 * @author fresjo
 */
public class Samplepanel implements DataElement {
    
    public static int COUNT;
    
    private String labID4Samplepanel;
    private String summaryDescription;
    private String composition;
    private int nrOfIndividuals;
    private int nrOfMales;
    private int nrOfFemales;
    private int nrOfProbands;
    private int nrOfParents;
    private String modeOfRecruitment;
    private String diagnosisAgeRange;
    private String diagnosisPeriod;
    private String samplingAgeRange;
    private String samplingPeriod;
    private String populationInfo;
    private String geographicRegionInfo;
    private String ethnicityInfo;
    private String birthplaceInfo;
    private String admixtureInfo;
    private String environmentInfo;
    private String sourceOfDNA;
    private String dnasArePooled;
    private String dnasAreWGA;
    private DataArray overlaps;
    private DataArray numberWithPhenotypes;
    private int id;
    
    /** Creates a new instance of Sampleset */
    public Samplepanel() {
        labID4Samplepanel = "";
        summaryDescription = "";
        composition = "";
        nrOfIndividuals = -1;
        nrOfMales = -1;
        nrOfFemales = -1;
        nrOfProbands = -1;
        nrOfParents = -1;
        modeOfRecruitment = "";
        diagnosisAgeRange = "";
        diagnosisPeriod = "";
        samplingAgeRange = "";
        samplingPeriod = "";
        populationInfo = "";
        geographicRegionInfo = "";
        ethnicityInfo = "";
        birthplaceInfo = "";
        admixtureInfo = "";
        environmentInfo = "";
        sourceOfDNA = "";
        dnasArePooled = "";
        dnasAreWGA = "";
        overlaps = new DataArray();
        numberWithPhenotypes = new DataArray();
        id = COUNT;
        COUNT++;
    }
    
    public void setLabID(String s) {
         labID4Samplepanel = s;
    }
    
    public String getLabID() {
        return labID4Samplepanel;
    }
    
    public void setSummaryDescription(String s) {
         summaryDescription = s;
    }
    
    public String getSummaryDescription() {
        return summaryDescription;
    }

    public void setComposition(String s) {
         composition = s;
    }
    
    public String getComposition() {
        return composition;
    }
    
    public void setNrOfIndividuals(int i) {
        nrOfIndividuals = i;
    }
    
    public int getNrOfIndividuals() {
        return nrOfIndividuals;
    }
    
    public void setNrOfMales(int i) {
        nrOfMales = i;
    }
    
    public int getNrOfMales() {
        return nrOfMales;
    }
    
    public void setNrOfFemales(int i) {
        nrOfFemales = i;
    }

    public int getNrOfFemales() {
        return nrOfFemales;
    }
    
    public void setNrOfProbands(int i) {
        nrOfProbands = i;
    }
    
    public int getNrOfProbands() {
        return nrOfProbands;
    }
    
    public void setNrOfParents(int i) {
        nrOfParents = i;
    }
    
    public int getNrOfParents() {
        return nrOfParents;
    }

    public void setModeOfRecruitment(String s) {
        modeOfRecruitment = s;
    }
    
    public String getModeOfRecruitment() {
        return modeOfRecruitment;
    }
    
    public void setDiagnosisAgeRange(String s) {
        diagnosisAgeRange = s;
    }
    
    public String getDiagnosisAgeRange() {
        return diagnosisAgeRange;
    }

    public void setDiagnosisPeriod(String s) {
        diagnosisPeriod = s;
    } 
    
    public String getDiagnosisPeriod() {
        return diagnosisPeriod;
    }
    
    public void setSamplingAgeRange(String s) {
        samplingAgeRange = s;
    }
    
    public String getSamplingAgeRange() {
        return samplingAgeRange;
    } 
    
    public void setSamplingPeriod(String s) {
        samplingPeriod = s;
    }
    
    public String getSamplingPeriod() {
        return samplingPeriod;
    }
    
    public void setPopulationInfo(String s) {
        populationInfo = s;
    }
    
    public String getPopulationInfo() {
        return populationInfo;
    }
    
    public void setGeographicRegionInfo(String s) {
        geographicRegionInfo = s;
    }
    
    public String getGeographicRegionInfo() {
        return geographicRegionInfo;
    }
    
    public void setEthnicityInfo(String s) {
        ethnicityInfo = s;
    }
    
    public String getEthnicityInfo() {
        return ethnicityInfo;
    }
    
    public void setBirthplaceInfo(String s) {
        birthplaceInfo = s;
    }
    
    public String getBirthplaceInfo() {
        return birthplaceInfo;
    }
    
    public void setAdmixtureInfo(String s) {
        admixtureInfo = s;
    }
    
    public String getAdmixtureInfo() {
        return admixtureInfo;
    }

    public void setEnvironmentInfo(String s) {
        environmentInfo = s;
    }
    
    public String getEnvironmentInfo() {
        return environmentInfo;
    }
    
    public void setSourceOfDNA(String s) {
        sourceOfDNA = s;
    }
    
    public String getSourceOfDNA() {
        return sourceOfDNA;
    }

    public void setDnasArePooled(String s) {
        dnasArePooled = s;
    }
    
    public String getDnasArePooled() {
        return dnasArePooled;
    }
    
    public void setDnasAreWGA(String s) {
        dnasAreWGA = s;
    }
    
    public String getDnasAreWGA() {
        return dnasAreWGA;
    }
    
    public void addOverlap(SamplepanelOverlap so) {
        overlaps.add(so);
    }
    
    public Object[] getOverlaps() {
        return overlaps.getArray();
    }
    
    public void addNumberWithPhenotype(NumberWithPhenotype np) {
        numberWithPhenotypes.add(np);
    }
    
    public Object[] getNumberWithPhenotypes() {
        return numberWithPhenotypes.getArray();
    }
    
    public int getID() {
        return id;
    }
    
    public String toString() {
        return labID4Samplepanel + "(" + composition + ")";
    }
    
    public int getType() {
        return DataElement.SAMPLEPANEL;
    }
    
    public void writeXML(PrintStream out, int offset) {
        String os = "";
        for(int i = 0; i < offset; i++) {
            os = os + " ";
        }
        out.println(os + "<samplepanel>");
        out.println(os + "  <labID4Samplepanel>" + labID4Samplepanel + "</labID4Samplepanel>");
        out.println(os + "  <summaryDescription>" + summaryDescription + "</summaryDescription>");
        out.println(os + "  <composition>" + composition + "</composition>");
        if(nrOfIndividuals != -1) {
            out.println(os + "  <nrOfIndividuals>" + nrOfIndividuals + "</nrOfIndividuals>");
        }
        else {
            out.println(os + "  <nrOfIndividuals></nrOfIndividuals>");
        }
        if(nrOfMales != -1) {
            out.println(os + "  <nrOfMales>" + nrOfMales + "</nrOfMales>");
        }
        else {
            out.println(os + "  <nrOfMales></nrOfMales>");
        }
        if(nrOfFemales != -1) {
            out.println(os + "  <nrOfFemales>" + nrOfFemales + "</nrOfFemales>");
        }
        else {
            out.println(os + "  <nrOfFemales></nrOfFemales>");
        }
        if(nrOfProbands != -1) {
            out.println(os + "  <nrOfProbands>" + nrOfProbands + "</nrOfProbands>");
        }
        else {
            out.println(os + "  <nrOfProbands></nrOfProbands>");
        }
        if(nrOfParents != -1) {
            out.println(os + "  <nrOfParents>" + nrOfParents + "</nrOfParents>");
        }
        else {
            out.println(os + "  <nrOfParents></nrOfParents>");
        }
        out.println(os + "  <modeOfRecruitment>" + modeOfRecruitment + "</modeOfRecruitment>");
        out.println(os + "  <diagnosisAgeRange>" + diagnosisAgeRange + "</diagnosisAgeRange>");
        out.println(os + "  <diagnosisPeriod>" + diagnosisPeriod + "</diagnosisPeriod>");
        out.println(os + "  <samplingAgeRange>" + samplingAgeRange + "</samplingAgeRange>");
        out.println(os + "  <samplingPeriod>" + samplingPeriod + "</samplingPeriod>");
        out.println(os + "  <populationInfo>" + populationInfo + "</populationInfo>");
        out.println(os + "  <geographicRegionInfo>" + geographicRegionInfo + "</geographicRegionInfo>");
        out.println(os + "  <ethnicityInfo>" + ethnicityInfo + "</ethnicityInfo>");
        out.println(os + "  <birthplaceInfo>" + birthplaceInfo + "</birthplaceInfo>");
        out.println(os + "  <admixtureInfo>" + admixtureInfo + "</admixtureInfo>");
        out.println(os + "  <environmentInfo>" + environmentInfo + "</environmentInfo>");
        out.println(os + "  <sourceOfDNA>" + sourceOfDNA + "</sourceOfDNA>");
        out.println(os + "  <dnasArePooled>" + dnasArePooled + "</dnasArePooled>");
        out.println(os + "  <dnasAreWGA>" + dnasAreWGA + "</dnasAreWGA>");
        for(int i = 0; i < overlaps.nrOfElements(); i++) {
            SamplepanelOverlap tmp = (SamplepanelOverlap)overlaps.get(i);
            tmp.writeXML(out, offset + 2);
        }
        for(int i = 0; i < numberWithPhenotypes.nrOfElements(); i++) {
            NumberWithPhenotype tmp = (NumberWithPhenotype)numberWithPhenotypes.get(i);
            tmp.writeXML(out, offset + 2);
        }
        out.println(os + "</samplepanel>");
    }
}
