/*
 * AlleleFrequencyPanel.java
 *
 * Created on den 17 juli 2006, 17:20
 */

package phenobase.gui;

import java.util.*;
import phenobase.data.*;
import phenobase.handling.*;
import phenobase.storage.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 * @author  fresjo
 */
public class AlleleFrequencyClusterPanel extends javax.swing.JPanel implements Observer {
    
    /** Creates new form AlleleFrequencyPanel */
    public AlleleFrequencyClusterPanel(HGVbaseSubmissionTool mf) {
        mainFrame = mf;
        mainFrame.getCurrentStudy().addObserver(this);
        initComponents();
    }
    
    public void update(Observable o, Object arg) {
        Study s = (Study)o;
        addedAlleleFrequencyClustersList.setListData(s.getAlleleFrequencyClusterArray());
        experimentComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getExperimentArray()));
        updateComboBoxes();
        updateAlleleComboBox();
        validate();
        repaint();
    }
    
    public void clearForm() {
        addedAlleleFrequencyClustersList.clearSelection();
        if(experimentComboBox.getItemCount() > 0) {
            experimentComboBox.setSelectedIndex(0);
        }
        if(assayedpanelComboBox.getItemCount() > 0) {
            assayedpanelComboBox.setSelectedIndex(0);
        }
        if(markerComboBox.getItemCount() > 0) {
            markerComboBox.setSelectedIndex(0);
        }
        nrGenotypedSamplesField.setText("");
        alleleFrequencyList.setListData(new AlleleFrequency[0]);
        clearFrequencyForm();
    }
    
    public void clearFrequencyForm() {
        alleleFrequencyList.clearSelection();
        if(alleleComboBox.getItemCount() > 0) {
            alleleComboBox.setSelectedIndex(0);
        }
        frequencyField.setText("");
    }

    public void fillForm(AlleleFrequencyCluster afc) {
        experimentComboBox.setSelectedItem(afc.getExperiment());
        assayedpanelComboBox.setSelectedItem(afc.getAssayedpanel());
        markerComboBox.setSelectedItem(afc.getMarker());
        nrGenotypedSamplesField.setText("" + afc.getNrGenotypedSamples());
        Object[] alleleFrequencies = afc.getAlleleComboArray();
        alleleFrequencyList.setListData(alleleFrequencies);
        validate();
        repaint();
    }
    
    public void fillFrequencyForm(AlleleFrequency af) {
        alleleComboBox.setSelectedItem(af.getAlleleCombo());
        frequencyField.setText("" + af.getFrequency());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        addedAlleleFrequencyClusterPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        addedAlleleFrequencyClustersScrollPane = new javax.swing.JScrollPane();
        addedAlleleFrequencyClustersList = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        alleleFrequencyClusterPanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        assayedpanelComboBox = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        markerComboBox = new javax.swing.JComboBox();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        nrGenotypedSamplesField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        alleleFrequencyList = new javax.swing.JList();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        alleleComboBox = new javax.swing.JComboBox();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        frequencyField = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        clearFrequencyButton = new javax.swing.JButton();
        deleteFrequencyButton = new javax.swing.JButton();
        addModifyFrequencyButton = new javax.swing.JButton();
        jLabel15 = new javax.swing.JLabel();
        experimentComboBox = new javax.swing.JComboBox();
        jLabel16 = new javax.swing.JLabel();
        buttonPanel = new javax.swing.JPanel();
        buttons = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        addModifyButton = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        setBorder(javax.swing.BorderFactory.createTitledBorder("Allele Frequency Clusters"));
        addedAlleleFrequencyClusterPanel.setLayout(new java.awt.GridBagLayout());

        addedAlleleFrequencyClusterPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Allele Frequency Clusters"));
        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel1.setForeground(new java.awt.Color(102, 102, 255));
        jLabel1.setText("Allele Frequency Clusters that has been added so far");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        addedAlleleFrequencyClusterPanel.add(jLabel1, gridBagConstraints);

        addedAlleleFrequencyClustersScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        addedAlleleFrequencyClustersList.setBackground(new java.awt.Color(255, 255, 204));
        addedAlleleFrequencyClustersList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                addedAlleleFrequencyClustersListValueChanged(evt);
            }
        });

        addedAlleleFrequencyClustersScrollPane.setViewportView(addedAlleleFrequencyClustersList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        addedAlleleFrequencyClusterPanel.add(addedAlleleFrequencyClustersScrollPane, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel2.setForeground(new java.awt.Color(255, 51, 51));
        jLabel2.setText("Help text");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        addedAlleleFrequencyClusterPanel.add(jLabel2, gridBagConstraints);

        add(addedAlleleFrequencyClusterPanel, java.awt.BorderLayout.NORTH);

        alleleFrequencyClusterPanel.setLayout(new java.awt.GridBagLayout());

        alleleFrequencyClusterPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Allele Frequency Cluster"));
        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel3.setForeground(new java.awt.Color(102, 102, 255));
        jLabel3.setText("Add a new Allele Frequency Cluster to the Study");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel3, gridBagConstraints);

        jLabel4.setForeground(java.awt.SystemColor.textHighlight);
        jLabel4.setText("Assayedpanel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel4, gridBagConstraints);

        assayedpanelComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        alleleFrequencyClusterPanel.add(assayedpanelComboBox, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel5.setForeground(new java.awt.Color(255, 51, 51));
        jLabel5.setText("jLabel5");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel5, gridBagConstraints);

        jLabel6.setForeground(java.awt.SystemColor.textHighlight);
        jLabel6.setText("Marker");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel6, gridBagConstraints);

        markerComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        markerComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                markerComboBoxActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        alleleFrequencyClusterPanel.add(markerComboBox, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel7.setForeground(new java.awt.Color(255, 51, 51));
        jLabel7.setText("jLabel7");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel7, gridBagConstraints);

        jLabel8.setForeground(java.awt.SystemColor.textHighlight);
        jLabel8.setText("Number of Genotyped Samples");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel8, gridBagConstraints);

        nrGenotypedSamplesField.setPreferredSize(new java.awt.Dimension(400, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        alleleFrequencyClusterPanel.add(nrGenotypedSamplesField, gridBagConstraints);

        jLabel9.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel9.setForeground(new java.awt.Color(255, 51, 51));
        jLabel9.setText("jLabel9");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel9, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Allele Frequencies"));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(750, 80));
        alleleFrequencyList.setBackground(new java.awt.Color(255, 255, 204));
        jScrollPane1.setViewportView(alleleFrequencyList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel1.add(jScrollPane1, gridBagConstraints);

        jLabel10.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel10.setForeground(new java.awt.Color(255, 51, 51));
        jLabel10.setText("jLabel10");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel1.add(jLabel10, gridBagConstraints);

        jLabel11.setForeground(java.awt.SystemColor.textHighlight);
        jLabel11.setText("Allele");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel1.add(jLabel11, gridBagConstraints);

        alleleComboBox.setPreferredSize(new java.awt.Dimension(375, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel1.add(alleleComboBox, gridBagConstraints);

        jLabel12.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel12.setForeground(new java.awt.Color(255, 51, 51));
        jLabel12.setText("jLabel12");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel1.add(jLabel12, gridBagConstraints);

        jLabel13.setForeground(java.awt.SystemColor.textHighlight);
        jLabel13.setText("Frequency");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel1.add(jLabel13, gridBagConstraints);

        frequencyField.setPreferredSize(new java.awt.Dimension(375, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel1.add(frequencyField, gridBagConstraints);

        jLabel14.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel14.setForeground(new java.awt.Color(255, 51, 51));
        jLabel14.setText("jLabel14");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel1.add(jLabel14, gridBagConstraints);

        jPanel2.setLayout(new java.awt.BorderLayout());

        clearFrequencyButton.setText("Clear Allele Frequency Form");
        clearFrequencyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearFrequencyButtonActionPerformed(evt);
            }
        });

        jPanel3.add(clearFrequencyButton);

        deleteFrequencyButton.setText("Delete Allele Frequency");
        deleteFrequencyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteFrequencyButtonActionPerformed(evt);
            }
        });

        jPanel3.add(deleteFrequencyButton);

        addModifyFrequencyButton.setText("Add/Modify Allele Frequency");
        addModifyFrequencyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyFrequencyButtonActionPerformed(evt);
            }
        });

        jPanel3.add(addModifyFrequencyButton);

        jPanel2.add(jPanel3, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel1.add(jPanel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jPanel1, gridBagConstraints);

        jLabel15.setForeground(java.awt.SystemColor.textHighlight);
        jLabel15.setText("Experiment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel15, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        alleleFrequencyClusterPanel.add(experimentComboBox, gridBagConstraints);

        jLabel16.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel16.setForeground(new java.awt.Color(255, 51, 51));
        jLabel16.setText("jLabel16");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        alleleFrequencyClusterPanel.add(jLabel16, gridBagConstraints);

        add(alleleFrequencyClusterPanel, java.awt.BorderLayout.CENTER);

        buttonPanel.setLayout(new java.awt.BorderLayout());

        clearButton.setText("Clear Form");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        buttons.add(clearButton);

        deleteButton.setText("Delete Allele Frequency Cluster");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        buttons.add(deleteButton);

        addModifyButton.setText("Add/Modify Allele Frequency Cluster");
        addModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyButtonActionPerformed(evt);
            }
        });

        buttons.add(addModifyButton);

        buttonPanel.add(buttons, java.awt.BorderLayout.EAST);

        add(buttonPanel, java.awt.BorderLayout.SOUTH);

    }// </editor-fold>//GEN-END:initComponents

    private void markerComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_markerComboBoxActionPerformed
        updateAlleleComboBox();
    }//GEN-LAST:event_markerComboBoxActionPerformed

    private void addModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyButtonActionPerformed
        try {
            AlleleFrequencyCluster afc = new AlleleFrequencyCluster();
            afc.setExperiment((Experiment)experimentComboBox.getSelectedItem());
            afc.setAssayedpanel((Assayedpanel)assayedpanelComboBox.getSelectedItem());
            afc.setMarker((Marker)markerComboBox.getSelectedItem());
            afc.setNrGenotypedSamples(Integer.parseInt(nrGenotypedSamplesField.getText()));
            ListModel lm = alleleFrequencyList.getModel();
            for(int i = 0; i < lm.getSize(); i++) {
                afc.addAlleleFrequency((AlleleFrequency)lm.getElementAt(i));
            }
            if(addedAlleleFrequencyClustersList.getSelectedValue() == null) {
                mainFrame.getCurrentStudy().addAlleleFrequencyCluster(afc);
                clearForm();
            }
            else {
                int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to update the selected allele frequency cluster?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
                if(answer == JOptionPane.YES_OPTION) {
                    AlleleFrequencyCluster selectedAlleleFrequencyCluster = (AlleleFrequencyCluster)addedAlleleFrequencyClustersList.getSelectedValue();
                    int id = selectedAlleleFrequencyCluster.getID();
                    mainFrame.getCurrentStudy().updateAlleleFrequencyCluster(afc, id);
                    clearForm(); 
                }
            }
        }
        catch(NumberFormatException nfe) {
            JOptionPane.showMessageDialog(this,
                nfe.getMessage(),
                "Error",
                JOptionPane.ERROR_MESSAGE);    
        }
    }//GEN-LAST:event_addModifyButtonActionPerformed

    private void clearFrequencyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearFrequencyButtonActionPerformed
        clearFrequencyForm();
    }//GEN-LAST:event_clearFrequencyButtonActionPerformed

    private void deleteFrequencyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteFrequencyButtonActionPerformed
        int selectedIndex = alleleFrequencyList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteAlleleFrequency(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a Allele Frequency to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_deleteFrequencyButtonActionPerformed

    private void addModifyFrequencyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyFrequencyButtonActionPerformed
        try {
            AlleleFrequency af = new AlleleFrequency();
            af.setAlleleCombo((String)alleleComboBox.getSelectedItem());
            af.setFrequency(Float.parseFloat(frequencyField.getText()));
            if(alleleFrequencyList.getSelectedIndex() == -1) {
                addAlleleFrequency(af);
            }
            else {
                
            }
            clearFrequencyForm();
            validate();
            repaint();
        }
        catch(NumberFormatException nfe) {
            JOptionPane.showMessageDialog(this,
                nfe.getMessage(),
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_addModifyFrequencyButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void addedAlleleFrequencyClustersListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_addedAlleleFrequencyClustersListValueChanged
        AlleleFrequencyCluster afc = (AlleleFrequencyCluster)addedAlleleFrequencyClustersList.getSelectedValue();
        if(afc != null) {
            fillForm(afc);
        }
    }//GEN-LAST:event_addedAlleleFrequencyClustersListValueChanged

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        deleteAlleleFrequencyCluster();
    }//GEN-LAST:event_deleteButtonActionPerformed
    
    private void updateComboBoxes() {
        if(experimentComboBox.getItemCount() > 0) {
            Experiment selectedExp = (Experiment)experimentComboBox.getSelectedItem();
            Object[] markers = selectedExp.getMarkerArray();
            markerComboBox.setModel(new javax.swing.DefaultComboBoxModel(markers));
            Object[] assayedpanels = selectedExp.getAssayedpanelArray();
            assayedpanelComboBox.setModel(new javax.swing.DefaultComboBoxModel(assayedpanels));
            validate();
            repaint();
        }
    }
    
    private void updateAlleleComboBox() {
        if(markerComboBox.getItemCount() > 0) {
            Marker selectedMarker = (Marker)markerComboBox.getSelectedItem();
            Object[] alleles = selectedMarker.getAlleleSequences();
            alleleComboBox.setModel(new javax.swing.DefaultComboBoxModel(alleles));
            validate();
            repaint();
        }
    }
    
    private void deleteAlleleFrequencyCluster() {
        AlleleFrequencyCluster afc = (AlleleFrequencyCluster)addedAlleleFrequencyClustersList.getSelectedValue();
        if(afc == null) {
            JOptionPane.showMessageDialog(this,
                "You have to select a allele frequency cluster to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the selected allele frequency cluster from the submission?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                mainFrame.getCurrentStudy().deleteAlleleFrequencyCluster(afc.getID());
                clearForm();    
            }
        }
    }
    
    private void deleteAlleleFrequency(int index) {
        ListModel lm = alleleFrequencyList.getModel();
        AlleleFrequency[] alleleFrequencyArray = new AlleleFrequency[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            AlleleFrequency tmp = (AlleleFrequency)lm.getElementAt(i);
            if(i != index) {
                alleleFrequencyArray[count] = tmp;
                count++;
            }
        }
        alleleFrequencyList.setListData(alleleFrequencyArray);
        validate();
        repaint();
    }
    
    private void addAlleleFrequency(AlleleFrequency af) {
        ListModel lm = alleleFrequencyList.getModel();
        AlleleFrequency[] array = new AlleleFrequency[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            array[i] = (AlleleFrequency)lm.getElementAt(i);
        }
        array[lm.getSize()] = af;
        alleleFrequencyList.setListData(array);
        validate();
        repaint();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addModifyButton;
    private javax.swing.JButton addModifyFrequencyButton;
    private javax.swing.JPanel addedAlleleFrequencyClusterPanel;
    private javax.swing.JList addedAlleleFrequencyClustersList;
    private javax.swing.JScrollPane addedAlleleFrequencyClustersScrollPane;
    private javax.swing.JComboBox alleleComboBox;
    private javax.swing.JPanel alleleFrequencyClusterPanel;
    private javax.swing.JList alleleFrequencyList;
    private javax.swing.JComboBox assayedpanelComboBox;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel buttons;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton clearFrequencyButton;
    private javax.swing.JButton deleteButton;
    private javax.swing.JButton deleteFrequencyButton;
    private javax.swing.JComboBox experimentComboBox;
    private javax.swing.JTextField frequencyField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JComboBox markerComboBox;
    private javax.swing.JTextField nrGenotypedSamplesField;
    // End of variables declaration//GEN-END:variables
    private HGVbaseSubmissionTool mainFrame;
}
