/*
 * AssaysetPanel.java
 *
 * Created on den 20 mars 2006, 16:47
 */

package phenobase.gui;

import phenobase.data.*;
import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 *
 * @author  fresjo
 */
public class AssayedpanelPanel extends javax.swing.JPanel implements Observer {
    
    public static final int GENERAL = 0;
    
    public static final int SELECTION_CRITERIA = 1;
    
    /** Creates new form AssaysetPanel */
    public AssayedpanelPanel(HGVbaseSubmissionTool mf) {
        mainFrame = mf;
        mainFrame.getCurrentStudy().addObserver(this);
        initComponents();
        generalInfoPanel = new Assayedpanel_GeneralInformationPanel(this);
        selectionPanel = new Assayedpanel_SelectionCriteriaPanel(this);
        contentPanel.add(generalInfoPanel, BorderLayout.NORTH);
        validate();
        repaint();
    }
    
    public void update(Observable o, Object arg) {
        Study s = (Study)o;
        addedAssayedpanelsList.setListData(s.getAssayedpanelArray());
        Object[] samplepanels = s.getSamplepanelArray();
        String[] labIDs = new String[samplepanels.length];
        for(int i = 0; i < samplepanels.length; i++) {
            labIDs[i] = ((Samplepanel)samplepanels[i]).getLabID();
        }
        selectionPanel.setSamplepanels(labIDs);
        validate();
        repaint();
    }
    
    public void clearForm() {
        addedAssayedpanelsList.clearSelection();
        generalInfoPanel.clearForm();
    }
    
    public void fillForm(Assayedpanel a) {
        generalInfoPanel.fillForm(a);
    }
    
    public void switchPanel(int panel) {
        contentPanel.removeAll();
        if(panel == GENERAL) {
            contentPanel.add(generalInfoPanel, BorderLayout.NORTH);
        }
        else if(panel == SELECTION_CRITERIA) {
            contentPanel.add(selectionPanel, BorderLayout.NORTH);
        }
        validate();
        repaint();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        addedAssayedpanelsPanel = new javax.swing.JPanel();
        addedAssayedpanelsScrollPane = new javax.swing.JScrollPane();
        addedAssayedpanelsList = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        contentPanel = new javax.swing.JPanel();
        buttonPanel = new javax.swing.JPanel();
        eastButtonPanel = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        addModifyButton = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        setBorder(javax.swing.BorderFactory.createTitledBorder("Assayed-Panels: define each aggregate collection of samples (called Assayed-Panels) upon which statistical tests were performed"));
        addedAssayedpanelsPanel.setLayout(new java.awt.GridBagLayout());

        addedAssayedpanelsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Assayed-Panels"));
        addedAssayedpanelsScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        addedAssayedpanelsList.setBackground(new java.awt.Color(255, 255, 204));
        addedAssayedpanelsList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                addedAssayedpanelsListValueChanged(evt);
            }
        });

        addedAssayedpanelsScrollPane.setViewportView(addedAssayedpanelsList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        addedAssayedpanelsPanel.add(addedAssayedpanelsScrollPane, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setText("Assayed-Panels already entered (click entries to view and edit)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        addedAssayedpanelsPanel.add(jLabel3, gridBagConstraints);

        add(addedAssayedpanelsPanel, java.awt.BorderLayout.NORTH);

        contentPanel.setLayout(new java.awt.BorderLayout());

        contentPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Assayed-Panel Details"));
        add(contentPanel, java.awt.BorderLayout.CENTER);

        buttonPanel.setLayout(new java.awt.BorderLayout());

        clearButton.setText("New Assayed-Panel");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        eastButtonPanel.add(clearButton);

        deleteButton.setText("Delete Assayed-Panel");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        eastButtonPanel.add(deleteButton);

        addModifyButton.setText("Save Assayed-Panel");
        addModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyButtonActionPerformed(evt);
            }
        });

        eastButtonPanel.add(addModifyButton);

        buttonPanel.add(eastButtonPanel, java.awt.BorderLayout.EAST);

        add(buttonPanel, java.awt.BorderLayout.SOUTH);

    }// </editor-fold>//GEN-END:initComponents

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        deleteAssayedpanel();
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void addedAssayedpanelsListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_addedAssayedpanelsListValueChanged
        Assayedpanel a = (Assayedpanel)addedAssayedpanelsList.getSelectedValue();
        if(a != null) {
            fillForm(a);
        }
    }//GEN-LAST:event_addedAssayedpanelsListValueChanged

    private void addModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyButtonActionPerformed
        Assayedpanel a = new Assayedpanel();
        try {
            a.setLabID(generalInfoPanel.getLabID());
            a.setComposition(generalInfoPanel.getComposition());
            a.setNrOfIndividuals(generalInfoPanel.getNrOfIndividuals());
            a.setNrOfMales(generalInfoPanel.getNrOfMales());
            a.setNrOfFemales(generalInfoPanel.getNrOfFemales());
            a.setNrOfProbands(generalInfoPanel.getNrOfProbands());
            a.setNrOfParents(generalInfoPanel.getNrOfParents());
            a.setDescription(generalInfoPanel.getSummaryDescription());
            if(addedAssayedpanelsList.getSelectedValue() == null) {
                mainFrame.getCurrentStudy().addAssayedpanel(a);
                clearForm();
            }
            else {
                int answer = JOptionPane.showConfirmDialog(this,
                        "Do you wish to update the selected assayedpanel?",
                        "Warning",
                        JOptionPane.WARNING_MESSAGE,
                        JOptionPane.YES_NO_OPTION);
                if(answer == JOptionPane.YES_OPTION) {
                    Assayedpanel selectedAssayedpanel = (Assayedpanel)addedAssayedpanelsList.getSelectedValue();
                    int id = selectedAssayedpanel.getID();
                    mainFrame.getCurrentStudy().updateAssayedpanel(a, id);
                    clearForm(); 
                }
            }
            
        }
        catch(FormatingException fe) {
            JOptionPane.showMessageDialog(this,
                fe.getMessage(),
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_addModifyButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed
    
    private void deleteAssayedpanel() {
        Assayedpanel a = (Assayedpanel)addedAssayedpanelsList.getSelectedValue();
        if(a == null) {
            JOptionPane.showMessageDialog(this,
                "You have to select a assayedpanel to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the selected assayedpanel from the submission?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                mainFrame.getCurrentStudy().deleteAssayedpanel(a.getID());
                clearForm();    
            }
        }
    }
    
    
    private Assayedpanel_GeneralInformationPanel generalInfoPanel;
    private Assayedpanel_SelectionCriteriaPanel selectionPanel;
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addModifyButton;
    private javax.swing.JList addedAssayedpanelsList;
    private javax.swing.JPanel addedAssayedpanelsPanel;
    private javax.swing.JScrollPane addedAssayedpanelsScrollPane;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton clearButton;
    private javax.swing.JPanel contentPanel;
    private javax.swing.JButton deleteButton;
    private javax.swing.JPanel eastButtonPanel;
    private javax.swing.JLabel jLabel3;
    // End of variables declaration//GEN-END:variables
    
}
