/*
 * Assayedpanel_GeneralInformation.java
 *
 * Created on den 12 december 2006, 11:54
 */

package phenobase.gui;

import phenobase.data.*;
import phenobase.handling.*;
import phenobase.storage.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 * @author  fredrik
 */
public class Assayedpanel_GeneralInformationPanel extends javax.swing.JPanel {
    
    /** Creates new form Assayedpanel_GeneralInformation */
    public Assayedpanel_GeneralInformationPanel(AssayedpanelPanel p) {
        parent = p;
        initComponents();
    }
    
    public void clearForm() {
        labIDField.setText("");
        compositionComboBox.setSelectedIndex(0);
        nrIndividualsField.setText("");
        nrMalesField.setText("");
        nrFemalesField.setText("");
        nrParentsField.setEnabled(false);
        nrProbandsField.setEnabled(false);
        descriptionField.setText("");
    }
    
    public void fillForm(Assayedpanel a) {
        setLabID(a.getLabID());
        setComposition(a.getComposition());
        setNrOfIndividuals(a.getNrOfIndividuals());
        setNrOfMales(a.getNrOfMales());
        setNrOfFemales(a.getNrOfFemales());
        if(a.getComposition().equals("Trios")) {
            setNrOfProbands(a.getNrOfProbands());
            setNrOfParents(a.getNrOfParents());
        }
        setSummaryDescription(a.getDescription());
    }
      
    public String getLabID() {
        return labIDField.getText();
    }
    
    public void setLabID(String s) {
        labIDField.setText(s);
    }
    
    public String getComposition() {
        return (String)compositionComboBox.getSelectedItem();
    }
    
    public void setComposition(String s) {
        compositionComboBox.setSelectedItem(s);
    }
    
    public int getNrOfIndividuals() throws FormatingException {
        int res = 0;
        try {
            if(!nrIndividualsField.getText().equals("")) {
                res = Integer.parseInt(nrIndividualsField.getText());
            }
            else {
                res = -1;
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Individuals field");
        }
        return res;
    }
    
    public void setNrOfIndividuals(int i) {
        if(i != -1) {
            nrIndividualsField.setText("" + i);
        }
        else {
            nrIndividualsField.setText("");
        }
    }
    
    public int getNrOfMales() throws FormatingException {
        int res = 0;
        try {
            if(!nrMalesField.getText().equals("")) {
                res = Integer.parseInt(nrMalesField.getText());
            }
            else {
                res = -1;
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Males field");
        }
        return res;
    }
    
    public void setNrOfMales(int i) {
        if(i != -1) {
            nrMalesField.setText("" + i);
        }
        else {
            nrMalesField.setText("");
        }
    }
    
    public int getNrOfFemales() throws FormatingException {
        int res = 0;
        try {
            if(!nrFemalesField.getText().equals("")) {
                res = Integer.parseInt(nrFemalesField.getText());
            }
            else {
                res = -1;
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Females field");
        }
        return res;
    }
    
    public void setNrOfFemales(int i) {
        if(i != -1) {
            nrFemalesField.setText("" + i);
        }
        else {
            nrFemalesField.setText("");
        }
    }
    
    public int getNrOfProbands() throws FormatingException {
        int res = 0;
        try {
            if((compositionComboBox.getSelectedItem()).equals("Trios")) {
                if(!nrProbandsField.getText().equals("")) {
                    res = Integer.parseInt(nrProbandsField.getText());
                }
                else {
                    res = -1;
                }
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Probands field");
        }
        return res;
    }
    
    public void setNrOfProbands(int i) {
        if(i != -1) {
            nrProbandsField.setText("" + i);
            nrProbandsField.setEnabled(true);
        }
        else {
            nrProbandsField.setText("");
        }
    }
    
    public int getNrOfParents() throws FormatingException {
        int res = 0;
        try {
            if((compositionComboBox.getSelectedItem()).equals("Trios")) {
                if(!nrParentsField.getText().equals("")) {
                    res =  Integer.parseInt(nrParentsField.getText());
                }
                else {
                    res = -1;
                }
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Parents field");
        }
        return res;
    }
    
    public void setNrOfParents(int i) {
        if(i != -1) {
            nrParentsField.setEnabled(true);
            nrParentsField.setText("" + i);
        }
        else {
            nrParentsField.setText("");
        }
    }
    
    public String getSummaryDescription() {
        return descriptionField.getText();
    }
    
    public void setSummaryDescription(String s) {
        descriptionField.setText(s);
    }
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel2 = new javax.swing.JLabel();
        labIDField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        String[] compositions = {"-", "Undefined", "Unrelated Cases", "Unrelated Controls", "Trios"};
        compositionComboBox = new javax.swing.JComboBox(compositions);
        jLabel5 = new javax.swing.JLabel();
        distributionPanel = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        nrIndividualsField = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        nrMalesField = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        nrFemalesField = new javax.swing.JTextField();
        triosPanel = new javax.swing.JPanel();
        jLabel14 = new javax.swing.JLabel();
        nrProbandsField = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        nrParentsField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        navigationPanel = new javax.swing.JPanel();
        navigationPanelEast = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        navigationButtonEast = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        descriptionField = new javax.swing.JTextArea();

        setLayout(new java.awt.GridBagLayout());

        jLabel2.setForeground(java.awt.SystemColor.textHighlight);
        jLabel2.setText("Name or ID");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 6, 3);
        add(jLabel2, gridBagConstraints);

        labIDField.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        labIDField.setPreferredSize(new java.awt.Dimension(400, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(labIDField, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setText("Short, convenient, and unique name for the Assayed-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel3, gridBagConstraints);

        jLabel4.setForeground(java.awt.SystemColor.textHighlight);
        jLabel4.setText("Composition");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 6, 3);
        add(jLabel4, gridBagConstraints);

        compositionComboBox.setEditable(true);
        compositionComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        compositionComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compositionComboBoxActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(compositionComboBox, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel5.setForeground(new java.awt.Color(255, 51, 51));
        jLabel5.setText("The composition of the Assayed-Panel. To enter a composition not available in the list simply type it in the field");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel5, gridBagConstraints);

        distributionPanel.setLayout(new java.awt.GridBagLayout());

        distributionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Size of Assayed-Panel"));
        jLabel10.setForeground(java.awt.SystemColor.textHighlight);
        jLabel10.setText("Nr of individuals:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(jLabel10, gridBagConstraints);

        nrIndividualsField.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        nrIndividualsField.setPreferredSize(new java.awt.Dimension(170, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(nrIndividualsField, gridBagConstraints);

        jLabel11.setForeground(java.awt.SystemColor.textHighlight);
        jLabel11.setText("Nr of males:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(jLabel11, gridBagConstraints);

        nrMalesField.setPreferredSize(new java.awt.Dimension(170, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(nrMalesField, gridBagConstraints);

        jLabel12.setForeground(java.awt.SystemColor.textHighlight);
        jLabel12.setText("Nr of females:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(jLabel12, gridBagConstraints);

        nrFemalesField.setPreferredSize(new java.awt.Dimension(170, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(nrFemalesField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(distributionPanel, gridBagConstraints);

        triosPanel.setLayout(new java.awt.GridBagLayout());

        triosPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Size of Trios panel (only available if \u2018Composition\u2019 is set to \u201cTrios\u201d)"));
        jLabel14.setForeground(java.awt.SystemColor.textHighlight);
        jLabel14.setText("Nr of probands:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        triosPanel.add(jLabel14, gridBagConstraints);

        nrProbandsField.setEnabled(false);
        nrProbandsField.setPreferredSize(new java.awt.Dimension(300, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        triosPanel.add(nrProbandsField, gridBagConstraints);

        jLabel15.setForeground(java.awt.SystemColor.textHighlight);
        jLabel15.setText("Nr of parents:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        triosPanel.add(jLabel15, gridBagConstraints);

        nrParentsField.setEnabled(false);
        nrParentsField.setPreferredSize(new java.awt.Dimension(300, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        triosPanel.add(nrParentsField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(triosPanel, gridBagConstraints);

        jLabel6.setForeground(java.awt.SystemColor.textHighlight);
        jLabel6.setText("Summary Description");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel6, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel7.setForeground(new java.awt.Color(255, 51, 51));
        jLabel7.setText("Summary description of this Assayed-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel7, gridBagConstraints);

        navigationPanel.setLayout(new java.awt.BorderLayout());

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel8.setText("Go to Selection Criterias");
        navigationPanelEast.add(jLabel8);

        navigationButtonEast.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                navigationButtonEastActionPerformed(evt);
            }
        });

        navigationPanelEast.add(navigationButtonEast);

        navigationPanel.add(navigationPanelEast, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

        descriptionField.setColumns(20);
        descriptionField.setLineWrap(true);
        descriptionField.setRows(2);
        descriptionField.setWrapStyleWord(true);
        jScrollPane1.setViewportView(descriptionField);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(jScrollPane1, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void navigationButtonEastActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_navigationButtonEastActionPerformed
        parent.switchPanel(AssayedpanelPanel.SELECTION_CRITERIA);
    }//GEN-LAST:event_navigationButtonEastActionPerformed

    private void compositionComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compositionComboBoxActionPerformed
        if(compositionComboBox.getSelectedItem() == "Trios") {
            nrProbandsField.setEnabled(true);
            nrParentsField.setEnabled(true);
        }
        else {
            nrProbandsField.setEnabled(false);
            nrParentsField.setEnabled(false);
            nrProbandsField.setText("");
            nrParentsField.setText("");
        }
    }//GEN-LAST:event_compositionComboBoxActionPerformed
    
    private AssayedpanelPanel parent;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox compositionComboBox;
    private javax.swing.JTextArea descriptionField;
    private javax.swing.JPanel distributionPanel;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField labIDField;
    private javax.swing.JButton navigationButtonEast;
    private javax.swing.JPanel navigationPanel;
    private javax.swing.JPanel navigationPanelEast;
    private javax.swing.JTextField nrFemalesField;
    private javax.swing.JTextField nrIndividualsField;
    private javax.swing.JTextField nrMalesField;
    private javax.swing.JTextField nrParentsField;
    private javax.swing.JTextField nrProbandsField;
    private javax.swing.JPanel triosPanel;
    // End of variables declaration//GEN-END:variables
    
}
