/*
 * Assayedpanel_SelectionCriteriaPanel.java
 *
 * Created on den 12 december 2006, 15:04
 */

package phenobase.gui;

import phenobase.data.*;
import javax.swing.*;

/**
 *
 * @author  fredrik
 */
public class Assayedpanel_SelectionCriteriaPanel extends javax.swing.JPanel {
    
    /** Creates new form Assayedpanel_SelectionCriteriaPanel */
    public Assayedpanel_SelectionCriteriaPanel(AssayedpanelPanel p) {
        parent = p;
        initComponents();
    }
   
    public void setSamplepanels(String[] ids) {
        samplepanelComboBox.setModel(new javax.swing.DefaultComboBoxModel(ids));
    }
    
    public void addSelectionCriteria(SelectionCriteria s) {
        ListModel lm = addedSelectionCriteriasList.getModel();
        SelectionCriteria[] selectionCriteriaArray = new SelectionCriteria[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            selectionCriteriaArray[i] = (SelectionCriteria)lm.getElementAt(i);
        }
        selectionCriteriaArray[lm.getSize()] = s;
        addedSelectionCriteriasList.setListData(selectionCriteriaArray);
        validate();
        repaint();
    }
   
    public void clearEntireForm() {
        addedSelectionCriteriasList.setListData(new SelectionCriteria[0]);
        clearForm();
    }
    
    public void clearForm() {
        addedSelectionCriteriasList.clearSelection();
        if(samplepanelComboBox.getItemCount() > 0) {
            samplepanelComboBox.setSelectedIndex(0);
        }
        nrOfIndividualsField.setText("");
        phenotypeCriteriaField.setText("");
        environmentCriteriaField.setText("");
    }
    
    public void fillForm(Assayedpanel a) {
        Object[] selectionCriterias = a.getSelectionCriteriaArray();
        addedSelectionCriteriasList.setListData(selectionCriterias);
        validate();
        repaint();
    }
    
    public void fillForm(SelectionCriteria s) {
        samplepanelComboBox.setSelectedItem(s.getSamplepanelID());
        nrOfIndividualsField.setText("" + s.getNrOfIndividuals());
        phenotypeCriteriaField.setText(s.getPhenotypeCriteria());
        environmentCriteriaField.setText(s.getEnvironmentCriteria());
        validate();
        repaint();
    }
    
    public SelectionCriteria[] getSelectionCriterias() {
        ListModel lm = addedSelectionCriteriasList.getModel();
        SelectionCriteria[] array = new SelectionCriteria[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            array[i] = (SelectionCriteria)lm.getElementAt(i);
        }
        return array;
    }
        
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        selectionCriteriasPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        addedSelectionCriteriasScrollPane = new javax.swing.JScrollPane();
        addedSelectionCriteriasList = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        buttonPanel = new javax.swing.JPanel();
        buttonPanelEast = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        addModifyButton = new javax.swing.JButton();
        navigationPanel = new javax.swing.JPanel();
        westNavigationPanel = new javax.swing.JPanel();
        westNavigationButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        selectionCriteriaPanel = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        nrOfIndividualsField = new javax.swing.JTextField();
        samplepanelComboBox = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        phenotypeCriteriaField = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        environmentCriteriaField = new javax.swing.JTextArea();

        setLayout(new java.awt.GridBagLayout());

        selectionCriteriasPanel.setLayout(new java.awt.GridBagLayout());

        selectionCriteriasPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Selection Criterias"));
        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel1.setForeground(new java.awt.Color(102, 102, 255));
        jLabel1.setText("Criterias added for this Assayedpanel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        selectionCriteriasPanel.add(jLabel1, gridBagConstraints);

        addedSelectionCriteriasScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        addedSelectionCriteriasList.setBackground(new java.awt.Color(255, 255, 204));
        addedSelectionCriteriasList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                addedSelectionCriteriasListValueChanged(evt);
            }
        });

        addedSelectionCriteriasScrollPane.setViewportView(addedSelectionCriteriasList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        selectionCriteriasPanel.add(addedSelectionCriteriasScrollPane, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel2.setForeground(new java.awt.Color(255, 51, 51));
        jLabel2.setText("Selection Criterias and the respective Samplepanels used to compose this Assayedpanel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        selectionCriteriasPanel.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(selectionCriteriasPanel, gridBagConstraints);

        buttonPanel.setLayout(new java.awt.BorderLayout());

        clearButton.setText("New Sample-Panel Contribution");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        buttonPanelEast.add(clearButton);

        deleteButton.setText("Delete Sample-Panel Contribution");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        buttonPanelEast.add(deleteButton);

        addModifyButton.setText("Save Sample-Panel Contribution");
        addModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyButtonActionPerformed(evt);
            }
        });

        buttonPanelEast.add(addModifyButton);

        buttonPanel.add(buttonPanelEast, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(buttonPanel, gridBagConstraints);

        navigationPanel.setLayout(new java.awt.BorderLayout());

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        westNavigationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                westNavigationButtonActionPerformed(evt);
            }
        });

        westNavigationPanel.add(westNavigationButton);

        jLabel3.setText("Go to General Information");
        westNavigationPanel.add(jLabel3);

        navigationPanel.add(westNavigationPanel, java.awt.BorderLayout.WEST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

        selectionCriteriaPanel.setLayout(new java.awt.GridBagLayout());

        selectionCriteriaPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Sample-Panel Contribution to Assayed-Panel"));
        jLabel12.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel12.setForeground(new java.awt.Color(255, 51, 51));
        jLabel12.setText("Text description of any Sample-Panel Environmental criteria that were the basis for including these individuals in the selected Assayed-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel12, gridBagConstraints);

        jLabel9.setForeground(java.awt.SystemColor.textHighlight);
        jLabel9.setText("Environment Criteria");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel9, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel4.setForeground(new java.awt.Color(102, 102, 255));
        jLabel4.setText("Sample-Panel Contributions to Assayed-Panel: specify the portions of the Sample-Panels that were aggregated to create the Assayed-Panel, plus criteria for their inclusion");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel4, gridBagConstraints);

        jLabel11.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel11.setForeground(new java.awt.Color(255, 51, 51));
        jLabel11.setText("Text description of the Sample-Panel Phenotypic criteria that were the basis for including these individuals in the selected Assayed-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel11, gridBagConstraints);

        jLabel10.setForeground(java.awt.SystemColor.textHighlight);
        jLabel10.setText("Phenotype Criteria");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel10, gridBagConstraints);

        jLabel8.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel8.setForeground(new java.awt.Color(255, 51, 51));
        jLabel8.setText("Number of individuals from the Sample-Panel contributing to (included in) the selected Assayed-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel8, gridBagConstraints);

        jLabel7.setForeground(java.awt.SystemColor.textHighlight);
        jLabel7.setText("Nr of Individuals Contributed");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel7, gridBagConstraints);

        jLabel6.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel6.setForeground(new java.awt.Color(255, 51, 51));
        jLabel6.setText("Sample-Panel source of the individuals contributing to the selected Assayed-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel6, gridBagConstraints);

        nrOfIndividualsField.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        nrOfIndividualsField.setPreferredSize(new java.awt.Dimension(400, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        selectionCriteriaPanel.add(nrOfIndividualsField, gridBagConstraints);

        samplepanelComboBox.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        samplepanelComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        selectionCriteriaPanel.add(samplepanelComboBox, gridBagConstraints);

        jLabel5.setForeground(java.awt.SystemColor.textHighlight);
        jLabel5.setText("Sample-Panel Making the Contribution");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        selectionCriteriaPanel.add(jLabel5, gridBagConstraints);

        phenotypeCriteriaField.setColumns(20);
        phenotypeCriteriaField.setLineWrap(true);
        phenotypeCriteriaField.setRows(2);
        phenotypeCriteriaField.setWrapStyleWord(true);
        jScrollPane1.setViewportView(phenotypeCriteriaField);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        selectionCriteriaPanel.add(jScrollPane1, gridBagConstraints);

        environmentCriteriaField.setColumns(20);
        environmentCriteriaField.setLineWrap(true);
        environmentCriteriaField.setRows(2);
        environmentCriteriaField.setWrapStyleWord(true);
        jScrollPane2.setViewportView(environmentCriteriaField);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        selectionCriteriaPanel.add(jScrollPane2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(selectionCriteriaPanel, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void addedSelectionCriteriasListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_addedSelectionCriteriasListValueChanged
        SelectionCriteria selectedCriteria = (SelectionCriteria)addedSelectionCriteriasList.getSelectedValue();
        if(selectedCriteria != null) {
            fillForm(selectedCriteria);
        }
        else {
            clearForm();
        }
    }//GEN-LAST:event_addedSelectionCriteriasListValueChanged

    private void addModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyButtonActionPerformed
        SelectionCriteria s = new SelectionCriteria();
        String id = (String)samplepanelComboBox.getSelectedItem();
        s.setSamplepanelID(id);
        s.setNrOfIndividuals(Integer.parseInt(nrOfIndividualsField.getText()));
        s.setPhenotypeCriteria(phenotypeCriteriaField.getText());
        s.setEnvironmentCriteria(environmentCriteriaField.getText());
        if(addedSelectionCriteriasList.getSelectedValue() == null) {
            addSelectionCriteria(s);
            clearForm();
        }
        else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to update the selected selection criteria?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                SelectionCriteria selectedCriteria = (SelectionCriteria)addedSelectionCriteriasList.getSelectedValue();
                selectedCriteria.setSamplepanelID(s.getSamplepanelID());
                selectedCriteria.setNrOfIndividuals(s.getNrOfIndividuals());
                selectedCriteria.setPhenotypeCriteria(s.getPhenotypeCriteria());
                selectedCriteria.setEnvironmentCriteria(s.getEnvironmentCriteria());
            }
            clearForm();
        }
    }//GEN-LAST:event_addModifyButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        SelectionCriteria s = (SelectionCriteria)addedSelectionCriteriasList.getSelectedValue();
        if(s == null) {
            JOptionPane.showMessageDialog(this,
                "You have to select a selection criteria to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the selected selection criteria from the submission?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                ListModel lm = addedSelectionCriteriasList.getModel();
                int removeIndex = addedSelectionCriteriasList.getSelectedIndex();
                SelectionCriteria[] selectionCriteriaArray = new SelectionCriteria[lm.getSize() - 1];
                int index = 0;
                for(int i = 0; i < lm.getSize(); i++) {
                    if(i != removeIndex) {
                        selectionCriteriaArray[index] = (SelectionCriteria)lm.getElementAt(i);
                        index++;
                    }
                }
                addedSelectionCriteriasList.setListData(selectionCriteriaArray);
                validate();
                repaint();
                clearForm();
            }
        }
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void westNavigationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_westNavigationButtonActionPerformed
        parent.switchPanel(AssayedpanelPanel.GENERAL);
    }//GEN-LAST:event_westNavigationButtonActionPerformed
    
    private AssayedpanelPanel parent;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addModifyButton;
    private javax.swing.JList addedSelectionCriteriasList;
    private javax.swing.JScrollPane addedSelectionCriteriasScrollPane;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel buttonPanelEast;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton deleteButton;
    private javax.swing.JTextArea environmentCriteriaField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JPanel navigationPanel;
    private javax.swing.JTextField nrOfIndividualsField;
    private javax.swing.JTextArea phenotypeCriteriaField;
    private javax.swing.JComboBox samplepanelComboBox;
    private javax.swing.JPanel selectionCriteriaPanel;
    private javax.swing.JPanel selectionCriteriasPanel;
    private javax.swing.JButton westNavigationButton;
    private javax.swing.JPanel westNavigationPanel;
    // End of variables declaration//GEN-END:variables
    
}
