/*
 * DiseaseAreaFrame.java
 *
 * Created on den 3 juni 2005, 14:05
 */

package phenobase.gui;

/**
 *
 * @author  fresjo
 */
public class DiseaseAreaFrame extends javax.swing.JFrame {
    
    public DiseaseAreaFrame() {
        
    }
    
    /** Creates new form DiseaseAreaFrame */
    public DiseaseAreaFrame(PhenotypeProperty_OtherInformationPanel pp, int xCoord, int yCoord) {
        initComponents();
        parent = pp;
        setLocation(xCoord, yCoord);
        setVisible(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        diseaseAreaLabel = new javax.swing.JLabel();
        diseaseAreaFieldLabel = new javax.swing.JLabel();
        diseaseAreaField = new javax.swing.JTextField();
        diseaseAreaHelpLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        diseaseAreaScrollPane = new javax.swing.JScrollPane();
        String[] diseaseAreas = {"neoplasm", "infection", "endocrine/metabolic disorder", "immune disorder", "psychological disorder",
            "neorudegenerative disorder", "disease of the blood and blood forming organs", "disease of the nervous system and sense organs",
            "disease of the circulatory system", "disease of the respiratory system"};
        diseaseAreaList = new javax.swing.JList(diseaseAreas);
        bottonPanel = new javax.swing.JPanel();
        eastPanel = new javax.swing.JPanel();
        cancelButton = new javax.swing.JButton();
        clearSelectionButton = new javax.swing.JButton();
        addButton = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        diseaseAreaLabel.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        diseaseAreaLabel.setForeground(new java.awt.Color(102, 102, 255));
        diseaseAreaLabel.setText("Add a disease area ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        getContentPane().add(diseaseAreaLabel, gridBagConstraints);

        diseaseAreaFieldLabel.setForeground(java.awt.SystemColor.textHighlight);
        diseaseAreaFieldLabel.setText("Custom Disease Area");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        getContentPane().add(diseaseAreaFieldLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        getContentPane().add(diseaseAreaField, gridBagConstraints);

        diseaseAreaHelpLabel.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        diseaseAreaHelpLabel.setForeground(new java.awt.Color(255, 51, 51));
        diseaseAreaHelpLabel.setText("Type the name of the disease area here if it is not present in the list above");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        getContentPane().add(diseaseAreaHelpLabel, gridBagConstraints);

        jLabel1.setForeground(java.awt.SystemColor.textHighlight);
        jLabel1.setText("List of Disease Areas");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        getContentPane().add(jLabel1, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel2.setForeground(new java.awt.Color(255, 51, 51));
        jLabel2.setText("Choose a disease area from the list above");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        getContentPane().add(jLabel2, gridBagConstraints);

        diseaseAreaScrollPane.setPreferredSize(new java.awt.Dimension(320, 170));
        diseaseAreaList.setBackground(new java.awt.Color(255, 255, 204));
        diseaseAreaScrollPane.setViewportView(diseaseAreaList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        getContentPane().add(diseaseAreaScrollPane, gridBagConstraints);

        bottonPanel.setLayout(new java.awt.BorderLayout());

        cancelButton.setText("Cancel");
        cancelButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                cancelButtonMouseClicked(evt);
            }
        });

        eastPanel.add(cancelButton);

        clearSelectionButton.setText("Clear Selection");
        clearSelectionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearSelectionButtonActionPerformed(evt);
            }
        });

        eastPanel.add(clearSelectionButton);

        addButton.setText("OK");
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        eastPanel.add(addButton);

        bottonPanel.add(eastPanel, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        getContentPane().add(bottonPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void clearSelectionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearSelectionButtonActionPerformed
        diseaseAreaField.setText("");
        diseaseAreaList.clearSelection();
    }//GEN-LAST:event_clearSelectionButtonActionPerformed

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
        if(diseaseAreaList.getSelectedValue() == null) {
            if(diseaseAreaField.getText().equals("")) {
                javax.swing.JOptionPane.showMessageDialog(this,
                    "You must either choose a disease area from the list or wite\n" +
                        "a custom disease area in the text field",
                    "Error",
                    javax.swing.JOptionPane.ERROR_MESSAGE);
            }
            else {
                parent.addDiseaseArea(diseaseAreaField.getText());
                dispose();
            }
        }
        else {
            if(!diseaseAreaField.getText().equals("")) {
                javax.swing.JOptionPane.showMessageDialog(this,
                    "You cannot both choose a disease area from the list\n" +
                        "and write a custom disease area in the text field",
                    "Error",
                    javax.swing.JOptionPane.ERROR_MESSAGE);
            }
            else {
                parent.addDiseaseArea("" + diseaseAreaList.getSelectedValue());
                dispose();
            }
        }
    }//GEN-LAST:event_addButtonActionPerformed

    private void cancelButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cancelButtonMouseClicked
        dispose();
    }//GEN-LAST:event_cancelButtonMouseClicked
    
    private PhenotypeProperty_OtherInformationPanel parent;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private javax.swing.JPanel bottonPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton clearSelectionButton;
    private javax.swing.JTextField diseaseAreaField;
    private javax.swing.JLabel diseaseAreaFieldLabel;
    private javax.swing.JLabel diseaseAreaHelpLabel;
    private javax.swing.JLabel diseaseAreaLabel;
    private javax.swing.JList diseaseAreaList;
    private javax.swing.JScrollPane diseaseAreaScrollPane;
    private javax.swing.JPanel eastPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    // End of variables declaration//GEN-END:variables
    
}
