/*
 * ExperimentPanel.java
 *
 * Created on den 13 september 2005, 11:50
 */

package phenobase.gui;
import phenobase.data.*;
import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 *
 * @author  fresjo
 */
public class ExperimentPanel extends javax.swing.JPanel implements Observer {
    
    /** Creates new form ExperimentPanel */
    public ExperimentPanel(HGVbaseSubmissionTool mf) {
        mainFrame = mf;
        mainFrame.getCurrentStudy().addObserver(this);
        generalPanel = new Experiment_GeneralInformationPanel(this, mainFrame);
        initComponents();
        contentPanel.add(generalPanel, BorderLayout.NORTH);
    }
    
    public void update(Observable o, Object arg) {
        Study s = (Study)o;
        addedExperimentsList.setListData(s.getExperimentArray());
        validate();
        repaint();
    }
    
    public void clearForm() {
        generalPanel.clearForm();
        addedExperimentsList.clearSelection();
    }
    
    public void fillForm(Experiment e) {
        generalPanel.fillForm(e);
    } 
     
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonPanel = new javax.swing.JPanel();
        buttons = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        addModifyButton = new javax.swing.JButton();
        addedExperimentsPanel = new javax.swing.JPanel();
        addedExperimentsScrollPane = new javax.swing.JScrollPane();
        addedExperimentsList = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        contentPanel = new javax.swing.JPanel();

        setLayout(new java.awt.BorderLayout());

        setBorder(javax.swing.BorderFactory.createTitledBorder("Experiments: enter here a summary for each distinct Experiment in your Study."));
        buttonPanel.setLayout(new java.awt.BorderLayout());

        clearButton.setText("Clear Form");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        buttons.add(clearButton);

        deleteButton.setText("Delete Experiment");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        buttons.add(deleteButton);

        addModifyButton.setText("Add/Modify Experiment");
        addModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyButtonActionPerformed(evt);
            }
        });

        buttons.add(addModifyButton);

        buttonPanel.add(buttons, java.awt.BorderLayout.EAST);

        add(buttonPanel, java.awt.BorderLayout.SOUTH);

        addedExperimentsPanel.setLayout(new java.awt.GridBagLayout());

        addedExperimentsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Experiments"));
        addedExperimentsScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        addedExperimentsList.setBackground(new java.awt.Color(255, 255, 204));
        addedExperimentsList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                addedExperimentsListValueChanged(evt);
            }
        });

        addedExperimentsScrollPane.setViewportView(addedExperimentsList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        addedExperimentsPanel.add(addedExperimentsScrollPane, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel2.setForeground(new java.awt.Color(255, 51, 51));
        jLabel2.setText("Experiments already entered (click entries to view and edit)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        addedExperimentsPanel.add(jLabel2, gridBagConstraints);

        add(addedExperimentsPanel, java.awt.BorderLayout.NORTH);

        contentPanel.setLayout(new java.awt.BorderLayout());

        contentPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Experiment"));
        add(contentPanel, java.awt.BorderLayout.CENTER);

    }// </editor-fold>//GEN-END:initComponents

    private void addModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyButtonActionPerformed
        Experiment e = new Experiment();
        e.setExpType(generalPanel.getType());
        e.setObjective(generalPanel.getObjective());
        e.setOutcome(generalPanel.getOutcome());
        e.setComments(generalPanel.getComments());
        Marker[] markers = generalPanel.getAddedMarkers();
        for(int i = 0; i < markers.length; i++) {
            e.addMarker(markers[i]);
        }
        Assayedpanel[] assayedpanels = generalPanel.getAddedAssayedpanels();
        for(int i = 0; i < assayedpanels.length; i++) {
            e.addAssayedpanel(assayedpanels[i]);
        }
        if(addedExperimentsList.getSelectedValue() == null) {
            mainFrame.getCurrentStudy().addExperiment(e);
            clearForm();
        }
        else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to update the selected Experiment?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                Experiment selectedExperiment = (Experiment)addedExperimentsList.getSelectedValue();
                int id = selectedExperiment.getID();
                mainFrame.getCurrentStudy().updateExperiment(e, id);
                clearForm(); 
            }
        }
    }//GEN-LAST:event_addModifyButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        deleteExperiment();
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void addedExperimentsListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_addedExperimentsListValueChanged
        Experiment e = (Experiment)addedExperimentsList.getSelectedValue();
        if(e != null) {
            fillForm(e);
        }
    }//GEN-LAST:event_addedExperimentsListValueChanged

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed
    
    private void deleteExperiment() {
        Experiment e = (Experiment)addedExperimentsList.getSelectedValue();
        if(e == null) {
            JOptionPane.showMessageDialog(this,
                "You have to select a Experiment to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the selected Experiment from the submission?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                mainFrame.getCurrentStudy().deleteExperiment(e.getID());
                clearForm();    
            }
        }
    }
    
    private Experiment_GeneralInformationPanel generalPanel;
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addModifyButton;
    private javax.swing.JList addedExperimentsList;
    private javax.swing.JPanel addedExperimentsPanel;
    private javax.swing.JScrollPane addedExperimentsScrollPane;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel buttons;
    private javax.swing.JButton clearButton;
    private javax.swing.JPanel contentPanel;
    private javax.swing.JButton deleteButton;
    private javax.swing.JLabel jLabel2;
    // End of variables declaration//GEN-END:variables
    
    
    
}
