/*
 * Experiment_GeneralInformationPanel.java
 *
 * Created on den 20 december 2006, 14:57
 */

package phenobase.gui;

import phenobase.data.*;
import javax.swing.*;

/**
 *
 * @author  fresjo
 */
public class Experiment_GeneralInformationPanel extends javax.swing.JPanel {
    
    /** Creates new form Experiment_GeneralInformationPanel */
    public Experiment_GeneralInformationPanel(ExperimentPanel p, HGVbaseSubmissionTool t) {
        mainFrame = t;
        parent = p;
        initComponents();
    }
    
    public void fillForm(Experiment e) {
        typeComboBox.setSelectedItem(e.getExpType());
        objectiveField.setText(e.getObjective());
        outcomeField.setText(e.getOutcome());
        commentsField.setText(e.getComments());
        Object[] assayedpanels = e.getAssayedpanelArray();
        assayedpanelList.setListData(assayedpanels);
        Object[] markers = e.getMarkerArray();
        markerList.setListData(markers);
    }
    
    public void clearForm() {
        typeComboBox.setSelectedIndex(0);
        objectiveField.setText("");
        outcomeField.setText("");
        commentsField.setText("");
        assayedpanelList.setListData(new Assayedpanel[0]);
        markerList.setListData(new Marker[0]);
    }
    
    public String getType() {
        return (String)typeComboBox.getSelectedItem();
    }
    
    public String getObjective() {
        return objectiveField.getText(); 
    }
    
    public String getOutcome() {
        return outcomeField.getText();
    }
    
    public String getComments() {
        return commentsField.getText();
    }
    
    public void addAssayedpanel(Assayedpanel a) {
        ListModel lm = assayedpanelList.getModel();
        Assayedpanel[] array = new Assayedpanel[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            array[i] = (Assayedpanel)lm.getElementAt(i);
        }
        array[lm.getSize()] = a;
        assayedpanelList.setListData(array);
        validate();
        repaint();
    }
    
    public Assayedpanel[] getAddedAssayedpanels() {
        ListModel lm = assayedpanelList.getModel();
        Assayedpanel[] assayedpanelArray = new Assayedpanel[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            assayedpanelArray[i] = (Assayedpanel)lm.getElementAt(i);
        }
        return assayedpanelArray;
    }
    
    private void deleteAssayedpanel(int index) {
        ListModel lm = assayedpanelList.getModel();
        Assayedpanel[] assayedpanelArray = new Assayedpanel[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            Assayedpanel tmp = (Assayedpanel)lm.getElementAt(i);
            if(i != index) {
                assayedpanelArray[count] = tmp;
                count++;
            }
        }
        assayedpanelList.setListData(assayedpanelArray);
        validate();
        repaint();
    }
    
    public void addMarker(Marker m) {
        ListModel lm = markerList.getModel();
        Marker[] array = new Marker[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            array[i] = (Marker)lm.getElementAt(i);
        }
        array[lm.getSize()] = m;
        markerList.setListData(array);
        validate();
        repaint();
    }
    
    public Marker[] getAddedMarkers() {
        ListModel lm = markerList.getModel();
        Marker[] array = new Marker[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            array[i] = (Marker)lm.getElementAt(i);
        }
        return array;
    }
    
    private void deleteMarker(int index) {
        ListModel lm = markerList.getModel();
        Marker[] array = new Marker[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            Marker tmp = (Marker)lm.getElementAt(i);
            if(i != index) {
                array[count] = tmp;
                count++;
            }
        }
        markerList.setListData(array);
        validate();
        repaint();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        typeComboBox = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        objectiveField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        outcomeField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        assayedpanelList = new javax.swing.JList();
        jLabel14 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        deleteAssayedpanelButton = new javax.swing.JButton();
        addAssayedpanelButton = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        markerList = new javax.swing.JList();
        jLabel15 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        deleteMarkerButton = new javax.swing.JButton();
        addMarkerButton = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        commentsField = new javax.swing.JTextArea();

        setLayout(new java.awt.GridBagLayout());

        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel1.setForeground(new java.awt.Color(102, 102, 255));
        jLabel1.setText("A single Experiment can include several statistical analyses that together address ONE discrete research question (e.g., the role of a gene or region in a disease, ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(jLabel1, gridBagConstraints);

        jLabel2.setForeground(java.awt.SystemColor.textHighlight);
        jLabel2.setText("Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel2, gridBagConstraints);

        typeComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Frequency determination", "Case-control study", "Gene/Region based, case-control study", "Whole genome, case-control study", "Whole chromosome, case-control study", "Cohort study", "Gene/Region-based, cohort study", "Whole-genome, cohort study", "Whole-chromosome, cohort study", "TDT study", "Gene-based, TDT study", "Whole-genome, TDT study", "Whole-chromosome, TDT study" }));
        typeComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(typeComboBox, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setText("Simple categorisation of the Experiment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel3, gridBagConstraints);

        jLabel6.setForeground(java.awt.SystemColor.textHighlight);
        jLabel6.setText("Objective");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(objectiveField, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel7.setForeground(new java.awt.Color(255, 51, 51));
        jLabel7.setText("Single sentence, stating the main research Objective of the Experiment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel7, gridBagConstraints);

        jLabel8.setForeground(java.awt.SystemColor.textHighlight);
        jLabel8.setText("Outcome");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel8, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(outcomeField, gridBagConstraints);

        jLabel9.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel9.setForeground(new java.awt.Color(255, 51, 51));
        jLabel9.setText("Single sentence, stating the main research Outcome of the Experiment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel9, gridBagConstraints);

        jLabel10.setForeground(java.awt.SystemColor.textHighlight);
        jLabel10.setText("Comments");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel10, gridBagConstraints);

        jLabel11.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel11.setForeground(new java.awt.Color(255, 51, 51));
        jLabel11.setText("Free text describing any other key aspects of the Experiment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel11, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Assayed-Panels"));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(380, 80));
        assayedpanelList.setBackground(new java.awt.Color(255, 255, 204));
        jScrollPane1.setViewportView(assayedpanelList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel1.add(jScrollPane1, gridBagConstraints);

        jLabel14.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel14.setForeground(new java.awt.Color(255, 51, 51));
        jLabel14.setText("All the Assayed-Panels used in the selected Experiment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel1.add(jLabel14, gridBagConstraints);

        jPanel2.setLayout(new java.awt.BorderLayout());

        deleteAssayedpanelButton.setText("Delete");
        deleteAssayedpanelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteAssayedpanelButtonActionPerformed(evt);
            }
        });

        jPanel3.add(deleteAssayedpanelButton);

        addAssayedpanelButton.setText("Add");
        addAssayedpanelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAssayedpanelButtonActionPerformed(evt);
            }
        });

        jPanel3.add(addAssayedpanelButton);

        jPanel2.add(jPanel3, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel1.add(jPanel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jPanel1, gridBagConstraints);

        jPanel4.setLayout(new java.awt.GridBagLayout());

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Markers"));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(380, 80));
        markerList.setBackground(new java.awt.Color(255, 255, 204));
        jScrollPane2.setViewportView(markerList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel4.add(jScrollPane2, gridBagConstraints);

        jLabel15.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel15.setForeground(new java.awt.Color(255, 51, 51));
        jLabel15.setText("All the Markers used in the selected Experiment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel4.add(jLabel15, gridBagConstraints);

        jPanel5.setLayout(new java.awt.BorderLayout());

        deleteMarkerButton.setText("Delete");
        deleteMarkerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteMarkerButtonActionPerformed(evt);
            }
        });

        jPanel6.add(deleteMarkerButton);

        addMarkerButton.setText("Add");
        addMarkerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addMarkerButtonActionPerformed(evt);
            }
        });

        jPanel6.add(addMarkerButton);

        jPanel5.add(jPanel6, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel4.add(jPanel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jPanel4, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel4.setForeground(new java.awt.Color(102, 102, 255));
        jLabel4.setText("or a whole genome association scan). One Experiment may therefore involve one or a few Sample-Panels and one or more Markers.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel4, gridBagConstraints);

        commentsField.setColumns(20);
        commentsField.setLineWrap(true);
        commentsField.setRows(2);
        commentsField.setWrapStyleWord(true);
        jScrollPane3.setViewportView(commentsField);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(jScrollPane3, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void deleteMarkerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteMarkerButtonActionPerformed
        int selectedIndex = markerList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteMarker(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a Marker to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_deleteMarkerButtonActionPerformed

    private void deleteAssayedpanelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteAssayedpanelButtonActionPerformed
        int selectedIndex = assayedpanelList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteAssayedpanel(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a Assayedpanel to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_deleteAssayedpanelButtonActionPerformed

    private void addAssayedpanelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAssayedpanelButtonActionPerformed
        AssayedpanelFrame frame = new AssayedpanelFrame(this, mainFrame, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());
    }//GEN-LAST:event_addAssayedpanelButtonActionPerformed

    private void addMarkerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addMarkerButtonActionPerformed
        ExperimentMarkerFrame frame = new ExperimentMarkerFrame(this, mainFrame, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());
    }//GEN-LAST:event_addMarkerButtonActionPerformed
    
    private HGVbaseSubmissionTool mainFrame;
    private ExperimentPanel parent;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addAssayedpanelButton;
    private javax.swing.JButton addMarkerButton;
    private javax.swing.JList assayedpanelList;
    private javax.swing.JTextArea commentsField;
    private javax.swing.JButton deleteAssayedpanelButton;
    private javax.swing.JButton deleteMarkerButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JList markerList;
    private javax.swing.JTextField objectiveField;
    private javax.swing.JTextField outcomeField;
    private javax.swing.JComboBox typeComboBox;
    // End of variables declaration//GEN-END:variables
    
}
