/*
 * GeneralInformationPanel.java
 *
 * Created on den 21 november 2005, 17:51
 */

package phenobase.gui;

import phenobase.data.*;

/**
 * This is the panel representing the first major step in the data entering process.
 * The two substeps of this step is Researchers and Citations. This, and all the
 * other panels representing the main steps are created by the <code>MainPanel</code>.
 *
 * @author  Fredrik Sjholm
 */
public class GeneralInformationPanel extends javax.swing.JPanel {
    
    /** 
     * Creates a new instance of <code>GeneralInformationPanel</code>.
     *
     * @param t    The <code>HGVbaseSubmissionTool</code> that this 
     *              <code>GeneralInformationPanel</code> is a part of.
     */
    public GeneralInformationPanel(HGVbaseSubmissionTool t) {
        mainFrame = t;
        initComponents();
    }
    
    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new ResearcherPanel(mainFrame);
        jPanel2 = new CitationPanel(mainFrame);
        jLabel1 = new javax.swing.JLabel();

        jTabbedPane1.addTab("Step 1: Researchers", jPanel1);

        jTabbedPane1.addTab("Step 2: Citations", jPanel2);

        jLabel1.setFont(new java.awt.Font("Times New Roman", 1, 18));
        jLabel1.setForeground(java.awt.Color.blue);
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Boxes with a thick blue border MUST be filled in");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 430, Short.MAX_VALUE)
            .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 430, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 287, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
    
}
