/*
 * GenotypeSignificancePanel.java
 *
 * Created on den 19 december 2006, 12:09
 */

package phenobase.gui;

import phenobase.data.*;
import java.util.*;
import javax.swing.*;

/**
 *
 * @author  fresjo
 */
public class GenotypeSignificancePanel extends javax.swing.JPanel implements Observer {
    
    /** Creates new form GenotypeSignificancePanel */
    public GenotypeSignificancePanel(HGVbaseSubmissionTool h) {
        mainFrame = h;
        mainFrame.getCurrentStudy().addObserver(this);
        initComponents();
    }

    public void update(Observable o, Object arg) {
        Study s = (Study)o;
        Object[] genArray = s.getGenotypeSignificanceArray();
        Object[] allArray = s.getAlleleSignificanceArray();
        Object[] array = new Object[genArray.length + allArray.length];
        int count = 0;
        for(int i = 0; i < genArray.length; i++) {
            array[count] = genArray[i];
            count++;
        }
        for(int i = 0; i < allArray.length; i++) {
            array[count] = allArray[i];
            count++;
        }
        addedSignificancesList.setListData(array);
        if(typeComboBox.getSelectedIndex() == 0) {
            frequencyCluster1ComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getGenotypeFrequencyClusterArray()));
            frequencyCluster2ComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getGenotypeFrequencyClusterArray()));
        }
        else {
            frequencyCluster1ComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getAlleleFrequencyClusterArray()));
            frequencyCluster2ComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getAlleleFrequencyClusterArray()));
        }
        validate();
        repaint();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        addedGenotypeSignificancesPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        addedSignificancesList = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        genotypeSignificancePanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        frequencyCluster1ComboBox = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        pValueField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        oddsRatioStatementField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        attributableRiskStatementField = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        statisticalMethodField = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        frequencyCluster2ComboBox = new javax.swing.JComboBox();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        typeComboBox = new javax.swing.JComboBox();
        jLabel17 = new javax.swing.JLabel();
        buttonPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        addModifyButton = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        setBorder(javax.swing.BorderFactory.createTitledBorder("Significance"));
        addedGenotypeSignificancesPanel.setLayout(new java.awt.GridBagLayout());

        addedGenotypeSignificancesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Significances"));
        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel1.setForeground(new java.awt.Color(102, 102, 255));
        jLabel1.setText("Significances that have been added so far");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        addedGenotypeSignificancesPanel.add(jLabel1, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(810, 80));
        addedSignificancesList.setBackground(new java.awt.Color(255, 255, 204));
        addedSignificancesList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                addedSignificancesListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(addedSignificancesList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        addedGenotypeSignificancesPanel.add(jScrollPane1, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel2.setForeground(new java.awt.Color(255, 51, 51));
        jLabel2.setText("jLabel2");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        addedGenotypeSignificancesPanel.add(jLabel2, gridBagConstraints);

        add(addedGenotypeSignificancesPanel, java.awt.BorderLayout.NORTH);

        genotypeSignificancePanel.setLayout(new java.awt.GridBagLayout());

        genotypeSignificancePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Significance"));
        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel3.setForeground(new java.awt.Color(102, 102, 255));
        jLabel3.setText("Add a new Significance to the Study");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel3, gridBagConstraints);

        jLabel4.setForeground(java.awt.SystemColor.textHighlight);
        jLabel4.setText("Frequency Cluster 1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel4, gridBagConstraints);

        frequencyCluster1ComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        genotypeSignificancePanel.add(frequencyCluster1ComboBox, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel5.setForeground(new java.awt.Color(255, 51, 51));
        jLabel5.setText("jLabel5");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel5, gridBagConstraints);

        jLabel6.setForeground(java.awt.SystemColor.textHighlight);
        jLabel6.setText("p-Value");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        genotypeSignificancePanel.add(pValueField, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel7.setForeground(new java.awt.Color(255, 51, 51));
        jLabel7.setText("jLabel7");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel7, gridBagConstraints);

        jLabel8.setForeground(java.awt.SystemColor.textHighlight);
        jLabel8.setText("Odds Ratio Statement");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel8, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        genotypeSignificancePanel.add(oddsRatioStatementField, gridBagConstraints);

        jLabel9.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel9.setForeground(new java.awt.Color(255, 51, 51));
        jLabel9.setText("jLabel9");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel9, gridBagConstraints);

        jLabel10.setForeground(java.awt.SystemColor.textHighlight);
        jLabel10.setText("Attributable Risk Statement");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel10, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        genotypeSignificancePanel.add(attributableRiskStatementField, gridBagConstraints);

        jLabel11.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel11.setForeground(new java.awt.Color(255, 51, 51));
        jLabel11.setText("jLabel11");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel11, gridBagConstraints);

        jLabel12.setForeground(java.awt.SystemColor.textHighlight);
        jLabel12.setText("Statistical Method");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel12, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        genotypeSignificancePanel.add(statisticalMethodField, gridBagConstraints);

        jLabel13.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel13.setForeground(new java.awt.Color(255, 51, 51));
        jLabel13.setText("jLabel13");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 15;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel13, gridBagConstraints);

        jLabel14.setForeground(java.awt.SystemColor.textHighlight);
        jLabel14.setText("Frequency Cluster 2");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel14, gridBagConstraints);

        frequencyCluster2ComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        genotypeSignificancePanel.add(frequencyCluster2ComboBox, gridBagConstraints);

        jLabel15.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel15.setForeground(new java.awt.Color(255, 51, 51));
        jLabel15.setText("jLabel15");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel15, gridBagConstraints);

        jLabel16.setForeground(java.awt.SystemColor.textHighlight);
        jLabel16.setText("Type of Significance");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel16, gridBagConstraints);

        typeComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Genotype", "Allele" }));
        typeComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                typeComboBoxActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        genotypeSignificancePanel.add(typeComboBox, gridBagConstraints);

        jLabel17.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel17.setForeground(new java.awt.Color(255, 51, 51));
        jLabel17.setText("jLabel17");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        genotypeSignificancePanel.add(jLabel17, gridBagConstraints);

        add(genotypeSignificancePanel, java.awt.BorderLayout.CENTER);

        buttonPanel.setLayout(new java.awt.BorderLayout());

        clearButton.setText("Clear Form");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        jPanel1.add(clearButton);

        deleteButton.setText("Delete Significance");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        jPanel1.add(deleteButton);

        addModifyButton.setText("Add/Modify Significance");
        addModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyButtonActionPerformed(evt);
            }
        });

        jPanel1.add(addModifyButton);

        buttonPanel.add(jPanel1, java.awt.BorderLayout.EAST);

        add(buttonPanel, java.awt.BorderLayout.SOUTH);

    }// </editor-fold>//GEN-END:initComponents

    private void typeComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_typeComboBoxActionPerformed
        Study s = mainFrame.getCurrentStudy();
        if(typeComboBox.getSelectedIndex() == 0) {
            frequencyCluster1ComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getGenotypeFrequencyClusterArray()));
            frequencyCluster2ComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getGenotypeFrequencyClusterArray()));
        }
        else {
            frequencyCluster1ComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getAlleleFrequencyClusterArray()));
            frequencyCluster2ComboBox.setModel(new javax.swing.DefaultComboBoxModel(s.getAlleleFrequencyClusterArray()));
        }
        validate();
        repaint();
    }//GEN-LAST:event_typeComboBoxActionPerformed

    private void addModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyButtonActionPerformed
        try {
            if(typeComboBox.getSelectedIndex() == 0) {
                GenotypeSignificance gs = new GenotypeSignificance();
                gs.setCluster1((GenotypeFrequencyCluster)frequencyCluster1ComboBox.getSelectedItem());
                gs.setCluster2((GenotypeFrequencyCluster)frequencyCluster2ComboBox.getSelectedItem());
                gs.setPValue(Float.parseFloat(pValueField.getText()));
                gs.setOddsRatioStatement(oddsRatioStatementField.getText());
                gs.setAttributableRiskStatement(attributableRiskStatementField.getText());
                gs.setStatisticalMethod(statisticalMethodField.getText());
                if(addedSignificancesList.getSelectedValue() == null) {
                    mainFrame.getCurrentStudy().addGenotypeSignificance(gs);
                    clearForm();
                }
                else {
                    int answer = JOptionPane.showConfirmDialog(this,
                        "Do you wish to update the selected Significance?",
                        "Warning",
                        JOptionPane.WARNING_MESSAGE,
                        JOptionPane.YES_NO_OPTION);
                    if(answer == JOptionPane.YES_OPTION) {
                        GenotypeSignificance selectedGenotypeSignificance = (GenotypeSignificance)addedSignificancesList.getSelectedValue();
                        int id = selectedGenotypeSignificance.getID();
                        mainFrame.getCurrentStudy().updateGenotypeSignificance(gs, id);
                        clearForm(); 
                    }
                }
            }
            else {
                AlleleSignificance as = new AlleleSignificance();
                as.setCluster1((AlleleFrequencyCluster)frequencyCluster1ComboBox.getSelectedItem());
                as.setCluster2((AlleleFrequencyCluster)frequencyCluster2ComboBox.getSelectedItem());
                as.setPValue(Float.parseFloat(pValueField.getText()));
                as.setOddsRatioStatement(oddsRatioStatementField.getText());
                as.setAttributableRiskStatement(attributableRiskStatementField.getText());
                as.setStatisticalMethod(statisticalMethodField.getText());
                if(addedSignificancesList.getSelectedValue() == null) {
                    mainFrame.getCurrentStudy().addAlleleSignificance(as);
                    clearForm();
                }
                else {
                    int answer = JOptionPane.showConfirmDialog(this,
                        "Do you wish to update the selected Significance?",
                        "Warning",
                        JOptionPane.WARNING_MESSAGE,
                        JOptionPane.YES_NO_OPTION);
                    if(answer == JOptionPane.YES_OPTION) {
                        AlleleSignificance selectedSignificance = (AlleleSignificance)addedSignificancesList.getSelectedValue();
                        int id = selectedSignificance.getID();
                        mainFrame.getCurrentStudy().updateAlleleSignificance(as, id);
                        clearForm(); 
                    }
                }
            }
        }
        catch(NumberFormatException nfe) {
            JOptionPane.showMessageDialog(this,
                nfe.getMessage(),
                "Error",
                JOptionPane.ERROR_MESSAGE);    
        }
    }//GEN-LAST:event_addModifyButtonActionPerformed

    private void addedSignificancesListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_addedSignificancesListValueChanged
        Significance s = (Significance)addedSignificancesList.getSelectedValue();
        if(s != null) {
            fillForm(s);
        }
    }//GEN-LAST:event_addedSignificancesListValueChanged

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        deleteSignificance();
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed
    
    private void clearForm() {
        if(frequencyCluster1ComboBox.getItemCount() > 0) {
            frequencyCluster1ComboBox.setSelectedIndex(0);
        }
        if(frequencyCluster2ComboBox.getItemCount() > 0) {
            frequencyCluster2ComboBox.setSelectedIndex(0);
        }
        pValueField.setText("");
        oddsRatioStatementField.setText("");
        attributableRiskStatementField.setText("");
        statisticalMethodField.setText("");
        validate();
        repaint();
    }
    
    private void fillForm(Significance s) {
        if(((DataElement)s).getType() == DataElement.GENOTYPE_SIGNIFICANCE) {
            typeComboBox.setSelectedIndex(0);
            frequencyCluster1ComboBox.setSelectedItem(((GenotypeSignificance)s).getCluster1());
            frequencyCluster2ComboBox.setSelectedItem(((GenotypeSignificance)s).getCluster2());
        }
        else {
            typeComboBox.setSelectedIndex(1);
            frequencyCluster1ComboBox.setSelectedItem(((AlleleSignificance)s).getCluster1());
            frequencyCluster2ComboBox.setSelectedItem(((AlleleSignificance)s).getCluster2());
        }
        pValueField.setText("" + s.getPValue());
        oddsRatioStatementField.setText(s.getOddsRatioStatement());
        attributableRiskStatementField.setText(s.getAttributableRiskStatement());
        statisticalMethodField.setText(s.getStatisticalMethod());
        validate();
        repaint();
    }
    
    private void deleteSignificance() {
        Significance s = (Significance)addedSignificancesList.getSelectedValue();
        if(s == null) {
            JOptionPane.showMessageDialog(this,
                "You have to select a Significance to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the selected Significance from the submission?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                if(((DataElement)s).getType() == DataElement.GENOTYPE_SIGNIFICANCE) {
                    mainFrame.getCurrentStudy().deleteGenotypeSignificance(((GenotypeSignificance)s).getID());
                }
                else {
                    mainFrame.getCurrentStudy().deleteAlleleSignificance(((AlleleSignificance)s).getID());
                }
                clearForm();    
            }
        }
    }
    
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addModifyButton;
    private javax.swing.JPanel addedGenotypeSignificancesPanel;
    private javax.swing.JList addedSignificancesList;
    private javax.swing.JTextField attributableRiskStatementField;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton deleteButton;
    private javax.swing.JComboBox frequencyCluster1ComboBox;
    private javax.swing.JComboBox frequencyCluster2ComboBox;
    private javax.swing.JPanel genotypeSignificancePanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField oddsRatioStatementField;
    private javax.swing.JTextField pValueField;
    private javax.swing.JTextField statisticalMethodField;
    private javax.swing.JComboBox typeComboBox;
    // End of variables declaration//GEN-END:variables
    
}
