/*
 * MainPanel.java
 *
 * Created on den 21 november 2005, 17:44
 */

package phenobase.gui;

import javax.swing.*;

/**
 * The Main Panel of the tool contains the tabs for all the different steps
 * in the process. 
 *
 * @author  Fredrik Sjholm
 */
public class MainPanel extends javax.swing.JPanel {
    
    /** 
     * Creates a new instance of <code>MainPanel</code>.
     *
     * @param t     The <code>HGVbaseSubmissionTool</code> that created this object.
     */
    public MainPanel(HGVbaseSubmissionTool t) {
        mainFrame = t;
        initComponents();
    }
    
    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new GeneralInformationPanel(mainFrame);
        jPanel2 = new PhenotypesPanel(mainFrame);
        jPanel3 = new SamplesPanel(mainFrame);
        jPanel4 = new MarkersAndAssaysPanel(mainFrame);
        jPanel5 = new ExperimentsAndFindingsPanel(mainFrame);

        jTabbedPane1.addTab("A: General information", jPanel1);

        jTabbedPane1.addTab("B: Phenotypes", jPanel2);

        jTabbedPane1.addTab("C:Samples", jPanel3);

        jTabbedPane1.addTab("D: Markers and Assays", jPanel4);

        jTabbedPane1.addTab("E: Experiments and Findings", jPanel5);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
}
