/*
 * MarkerPanel.java
 *
 * Created on den 10 maj 2006, 15:33
 */

package phenobase.gui;

import phenobase.handling.*;
import phenobase.data.*;
import phenobase.storage.*;
import java.util.*;
import java.util.regex.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author  fresjo
 */
public class MarkerPanel extends javax.swing.JPanel implements Observer {
    
    /** Creates new form MarkerPanel */
    public MarkerPanel(HGVbaseSubmissionTool mf) {
        mainFrame = mf;
        mainFrame.getCurrentStudy().addObserver(this);
        initComponents();
        TableColumn column = alleleTable.getColumnModel().getColumn(0);
        column.setPreferredWidth(130);
        column = alleleTable.getColumnModel().getColumn(1);
        column.setPreferredWidth(275);
        column = alleleTable.getColumnModel().getColumn(2);
        column.setPreferredWidth(120);
        column = alleleTable.getColumnModel().getColumn(3);
        column.setPreferredWidth(275);

    }
    
    private void deleteMarker() {
        Object[] o = markerList.getSelectedValues();
        if(o.length == 0) {
            JOptionPane.showMessageDialog(this,
                "You have to select one or more Marker(s) to be able to delete it or them.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the selected Marker(s) from the submission?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                for(int i = 0; i < o.length; i++) {
                    Marker tmp = (Marker)o[i];
                    mainFrame.getCurrentStudy().deleteMarker(tmp.getID());
                }                
                clearForm();    
            }
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        addedMarkersScrollPane = new javax.swing.JScrollPane();
        markerList = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteMarkerButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        rsIDField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        markerIDField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        validationField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        sequenceTypeField = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        alleleScrollPane = new javax.swing.JScrollPane();
        alleleTable = new javax.swing.JTable();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        addMarkersTextField = new javax.swing.JTextField();
        findMarkersButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();

        setLayout(new java.awt.BorderLayout());

        setBorder(javax.swing.BorderFactory.createTitledBorder("Markers: provide a list of all the markers used in your study (as dbSNP rsIDs)"));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Markers"));
        addedMarkersScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        markerList.setBackground(new java.awt.Color(255, 255, 204));
        markerList.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                markerListKeyPressed(evt);
            }
        });
        markerList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                markerListValueChanged(evt);
            }
        });

        addedMarkersScrollPane.setViewportView(markerList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel1.add(addedMarkersScrollPane, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 9));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setText("Markers already entered (click entries to view and edit)\u201d \u2013 color red, and move to below the yellow box");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel1.add(jLabel3, gridBagConstraints);

        jPanel4.setLayout(new java.awt.BorderLayout());

        clearButton.setText("Clear Form");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        jPanel5.add(clearButton);

        deleteMarkerButton.setText("Delete Marker");
        deleteMarkerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteMarkerButtonActionPerformed(evt);
            }
        });

        jPanel5.add(deleteMarkerButton);

        jPanel4.add(jPanel5, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel1.add(jPanel4, gridBagConstraints);

        add(jPanel1, java.awt.BorderLayout.NORTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Marker Details"));
        jLabel2.setForeground(java.awt.SystemColor.textHighlight);
        jLabel2.setText("rsID");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel2.add(jLabel2, gridBagConstraints);

        rsIDField.setEditable(false);
        rsIDField.setPreferredSize(new java.awt.Dimension(400, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel2.add(rsIDField, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel5.setForeground(new java.awt.Color(255, 51, 51));
        jLabel5.setText("dbSNP reference SNP marker ID");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel2.add(jLabel5, gridBagConstraints);

        jLabel6.setForeground(java.awt.SystemColor.textHighlight);
        jLabel6.setText("MarkerID");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel2.add(jLabel6, gridBagConstraints);

        markerIDField.setEditable(false);
        markerIDField.setPreferredSize(new java.awt.Dimension(400, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel2.add(markerIDField, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel7.setForeground(new java.awt.Color(255, 51, 51));
        jLabel7.setText("Other database marker ID");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel2.add(jLabel7, gridBagConstraints);

        jLabel8.setForeground(java.awt.SystemColor.textHighlight);
        jLabel8.setText("Validation");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel2.add(jLabel8, gridBagConstraints);

        validationField.setEditable(false);
        validationField.setPreferredSize(new java.awt.Dimension(400, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel2.add(validationField, gridBagConstraints);

        jLabel9.setFont(new java.awt.Font("Tahoma", 0, 9));
        jLabel9.setForeground(new java.awt.Color(255, 51, 51));
        jLabel9.setText("Validation evidence in dbSNP");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel2.add(jLabel9, gridBagConstraints);

        jLabel10.setForeground(java.awt.SystemColor.textHighlight);
        jLabel10.setText("Sequence Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel2.add(jLabel10, gridBagConstraints);

        sequenceTypeField.setEditable(false);
        sequenceTypeField.setPreferredSize(new java.awt.Dimension(400, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel2.add(sequenceTypeField, gridBagConstraints);

        jLabel11.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel11.setForeground(new java.awt.Color(255, 51, 51));
        jLabel11.setText("Alleles and flank sequences are Genomic or cDNA based");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel2.add(jLabel11, gridBagConstraints);

        alleleScrollPane.setPreferredSize(new java.awt.Dimension(800, 80));
        alleleTable.setModel(new AlleleTableModel());
        alleleScrollPane.setViewportView(alleleTable);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        jPanel2.add(alleleScrollPane, gridBagConstraints);

        jLabel12.setForeground(java.awt.SystemColor.textHighlight);
        jLabel12.setText("Alleles");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel2.add(jLabel12, gridBagConstraints);

        jLabel13.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel13.setForeground(new java.awt.Color(255, 51, 51));
        jLabel13.setText("Known alleles in their strand and flanking sequence context. Be particularly careful when submitting data for T/A or C/G SNPs as their alleles can be mixed up if the wrong strand is considered");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        jPanel2.add(jLabel13, gridBagConstraints);

        jPanel6.setLayout(new java.awt.GridBagLayout());

        addMarkersTextField.setPreferredSize(new java.awt.Dimension(700, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 1, 0);
        jPanel6.add(addMarkersTextField, gridBagConstraints);

        findMarkersButton.setText("Find Marker(s)");
        findMarkersButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                findMarkersButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 0);
        jPanel6.add(findMarkersButton, gridBagConstraints);

        jLabel1.setForeground(java.awt.SystemColor.textHighlight);
        jLabel1.setText("Add Marker(s)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 3, 0);
        jPanel6.add(jLabel1, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel4.setForeground(new java.awt.Color(255, 51, 51));
        jLabel4.setText("Marker IDs: Type in a list of rsIDs separated by \u2018;\u2019 and then click the \u2019Find Marker(s)\u2019 button. Sequential additions are possible.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 0, 3, 0);
        jPanel6.add(jLabel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        jPanel2.add(jPanel6, gridBagConstraints);

        add(jPanel2, java.awt.BorderLayout.CENTER);

    }// </editor-fold>//GEN-END:initComponents

    private void findMarkersButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_findMarkersButtonActionPerformed
        String rsIDs = addMarkersTextField.getText();
        String errorString = "";
        String duplicatedIDs = "";
        if(rsIDs.equals("")) {
            JOptionPane.showMessageDialog(this,
                    "You have to type one or more rsIDs in the field to be able to add them",
                    "Error",
                    JOptionPane.ERROR_MESSAGE);
        } else {
            DBSNPAdapter adapter = new DBSNPAdapter(this);
            StringTokenizer strTok = new StringTokenizer(rsIDs, "; ");
            while(strTok.hasMoreTokens()) {
                String rsID = strTok.nextToken();
                Pattern p = Pattern.compile("^rs\\d+$");
                Matcher m = p.matcher(rsID);
                if(m.matches()) {
                    if(!mainFrame.getCurrentStudy().isAddedMarker(rsID)) {
                        try {
                            Marker marker = adapter.getMarker(rsID, this);
                            mainFrame.getCurrentStudy().addMarker(marker);
                        } catch(MarkerException me) {
                            errorString = errorString + rsID + ";";
                        }
                    }
                    else {
                        duplicatedIDs = duplicatedIDs + rsID + ",";
                    }
                } else {
                    errorString = errorString + rsID + ";";
                }
            }
            clearForm();
            if(!duplicatedIDs.equals("")) {
                duplicatedIDs = duplicatedIDs.substring(0, duplicatedIDs.length() - 1);
                JOptionPane.showMessageDialog(this,
                                "Markers " + duplicatedIDs + " were duplicated or already added to the Study",
                                "Error",
                                JOptionPane.ERROR_MESSAGE);
                
            }
            if(!errorString.equals("")) {
                errorString = errorString.substring(0, errorString.length() - 1);
                JOptionPane.showMessageDialog(this,
                                "Input Data Error: the Marker(s) still listed in the input list box had invalid rsIDs\n" + 
                                "(i.e., not in dbSNP, merged with other Marker(s) or incorrectly formatted).",
                                "Error",
                                JOptionPane.ERROR_MESSAGE);
            }
            addMarkersTextField.setText(errorString);
        }
    }//GEN-LAST:event_findMarkersButtonActionPerformed

    private void markerListKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_markerListKeyPressed
        if(evt.getKeyCode() == java.awt.event.KeyEvent.VK_DELETE) {
            deleteMarker();
        }
    }//GEN-LAST:event_markerListKeyPressed

    private void deleteMarkerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteMarkerButtonActionPerformed
        deleteMarker();
    }//GEN-LAST:event_deleteMarkerButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void markerListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_markerListValueChanged
        Marker m = (Marker)markerList.getSelectedValue();
            if(m != null) {
                fillForm(m);
        }
    }//GEN-LAST:event_markerListValueChanged

    public void update(Observable o, Object arg) {
        Study s = (Study)o;
        markerList.setListData(s.getMarkerArray());
        validate();
        repaint();
    }
    
    public void clearForm() {
        addMarkersTextField.setText("");
        markerList.clearSelection();
        rsIDField.setText("");
        markerIDField.setText("");
        validationField.setText("");
        sequenceTypeField.setText("");
        AlleleTableModel model = (AlleleTableModel)alleleTable.getModel();
        model.removeAllAlleles();
        validate();
        repaint();
    }
    
    public void fillForm(Marker m) {
        rsIDField.setText(m.getRsID());
        markerIDField.setText(m.getMarkerID());
        validationField.setText(m.getValidation());
        sequenceTypeField.setText(m.getSequenceType());
        Object[] alleles = m.getAlleles();
        AlleleTableModel model = (AlleleTableModel)alleleTable.getModel();
        model.setAlleles(alleles);
        validate();
        repaint();
    }
        
    private HGVbaseSubmissionTool mainFrame;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField addMarkersTextField;
    private javax.swing.JScrollPane addedMarkersScrollPane;
    private javax.swing.JScrollPane alleleScrollPane;
    private javax.swing.JTable alleleTable;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton deleteMarkerButton;
    private javax.swing.JButton findMarkersButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JTextField markerIDField;
    private javax.swing.JList markerList;
    private javax.swing.JTextField rsIDField;
    private javax.swing.JTextField sequenceTypeField;
    private javax.swing.JTextField validationField;
    // End of variables declaration//GEN-END:variables
    
}
