/*
 * MarkerFrame.java
 *
 * Created on den 17 juli 2006, 14:45
 */

package phenobase.gui;

import javax.swing.*;
import phenobase.data.*;


/**
 *
 * @author  fresjo
 */
public class MarkersFrame extends javax.swing.JFrame {
    
    /** Creates new form MarkerFrame */
    public MarkersFrame(AssayPanel ap, int xCoord, int yCoord) {
        parent = ap;
        initComponents();
        setLocation(xCoord + 300, yCoord + 300);
        setVisible(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        markerScrollPane = new javax.swing.JScrollPane();
        markerList = new JList(parent.getCurrentSubmission().getMarkerArray());
        jLabel3 = new javax.swing.JLabel();
        buttonPanel = new javax.swing.JPanel();
        buttons = new javax.swing.JPanel();
        cancelButton = new javax.swing.JButton();
        addMarkerButton = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel1.setForeground(new java.awt.Color(102, 102, 255));
        jLabel1.setText("Add a marker to this Assay");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        getContentPane().add(jLabel1, gridBagConstraints);

        jLabel2.setForeground(java.awt.SystemColor.textHighlight);
        jLabel2.setText("Markers");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        getContentPane().add(jLabel2, gridBagConstraints);

        markerList.setBackground(new java.awt.Color(255, 255, 204));
        markerScrollPane.setViewportView(markerList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        getContentPane().add(markerScrollPane, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setText("Add a previoously enterd marker to this assay");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        getContentPane().add(jLabel3, gridBagConstraints);

        buttonPanel.setLayout(new java.awt.BorderLayout());

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        buttons.add(cancelButton);

        addMarkerButton.setText("Add Marker");
        addMarkerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addMarkerButtonActionPerformed(evt);
            }
        });

        buttons.add(addMarkerButton);

        buttonPanel.add(buttons, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        getContentPane().add(buttonPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void addMarkerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addMarkerButtonActionPerformed
        if(markerList.getSelectedValue() == null) {
            javax.swing.JOptionPane.showMessageDialog(this,
                "You have to choose a marker from the list\n" +
                "to be able to add it to the Phenotype General",
                "Error",
                javax.swing.JOptionPane.ERROR_MESSAGE);
        }
        else {
            Marker m = (Marker)markerList.getSelectedValue();
            parent.addMarker(m);
            dispose();
        }
    }//GEN-LAST:event_addMarkerButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addMarkerButton;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel buttons;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JList markerList;
    private javax.swing.JScrollPane markerScrollPane;
    // End of variables declaration//GEN-END:variables

    private AssayPanel parent;
    
}
