/*
 * PhenotypeMethodGeneralInformationPanel.java
 *
 * Created on den 21 april 2006, 11:21
 */

package phenobase.gui;

import phenobase.data.*;
import java.awt.*;
import javax.swing.*;

/**
 *
 * @author  fresjo
 */
public class PhenotypeMethod_GeneralInformationPanel extends javax.swing.JPanel {
    
    /** Creates new form PhenotypeMethodGeneralInformationPanel */
    public PhenotypeMethod_GeneralInformationPanel(PhenotypeMethodPanel p, HGVbaseSubmissionTool mf) {
        mainFrame = mf;
        parent = p;
        initComponents();
    }
    
    public void fillForm(PhenotypeMethod pm) {
        setMethodName(pm.getMethodName());
        phenotypeComboBox.setSelectedItem(pm.getPhenotypeName());
        setSampleType(pm.getSampleType());
        setResultType(pm.getResultType());
        setCircumstance(pm.getCircumstance());
        setDetails(pm.getDetails());
    }
    
    public void clearForm() {
        setMethodName("");
        setSampleType("");
        setResultType("");
        setCircumstance("");
        setDetails("");
    }
    
    public void setPhenotypeNames(String[] names) {
        DefaultComboBoxModel model = (DefaultComboBoxModel)phenotypeComboBox.getModel();
        model.removeAllElements();
        for(int i = 0; i < names.length; i++) {
            model.addElement(names[i]);
        }
    }
    
    public String getMethodName() {
        return methodNameField.getText();
    }
    
    public void setMethodName(String s) {
        methodNameField.setText(s);
    }
    
    public String getPhenotypeName() {
        return (String)phenotypeComboBox.getSelectedItem();
    }
    
    public void setPhenotypeName(String name) {
        phenotypeComboBox.setSelectedItem(name);
    }
    
    public String getSampleType() {
        return sampleTypeField.getText();
    }
    
    public void setSampleType(String s) {
        sampleTypeField.setText(s);
    }
    
    public String getResultType() {
        return resultTypeField.getText();
    }
    
    public void setResultType(String s) {
        resultTypeField.setText(s);
    }
    
    public String getCircumstance() {
        return circumstanceField.getText();
    }
    
    public void setCircumstance(String s) {
        circumstanceField.setText(s);
    }
    
    public String getDetails() {
        return detailsField.getText();
    }
    
    public void setDetails(String s) {
        detailsField.setText(s);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        navigationPanel = new javax.swing.JPanel();
        navigationEastPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        otherInformationButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        methodNameField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        sampleTypeField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        resultTypeField = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        circumstanceField = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        detailsField = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        phenotypeComboBox = new javax.swing.JComboBox(mainFrame.getCurrentStudy().getPhenotypePropertyNames());
        jLabel14 = new javax.swing.JLabel();

        setLayout(new java.awt.GridBagLayout());

        navigationPanel.setLayout(new java.awt.BorderLayout());

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel1.setText("Go to Other Information");
        navigationEastPanel.add(jLabel1);

        otherInformationButton.setIcon(new javax.swing.ImageIcon("C:\\hgvbasePics\\right30.gif"));
        otherInformationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                otherInformationButtonActionPerformed(evt);
            }
        });

        navigationEastPanel.add(otherInformationButton);

        navigationPanel.add(navigationEastPanel, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 19;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

        jLabel3.setForeground(java.awt.SystemColor.textHighlight);
        jLabel3.setText("Phenotype Method Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel3, gridBagConstraints);

        methodNameField.setPreferredSize(new java.awt.Dimension(820, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(methodNameField, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel4.setForeground(new java.awt.Color(255, 51, 51));
        jLabel4.setText("Only enter this if it has a internationally accepted name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel4, gridBagConstraints);

        jLabel5.setForeground(java.awt.SystemColor.textHighlight);
        jLabel5.setText("Sample Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(sampleTypeField, gridBagConstraints);

        jLabel6.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel6.setForeground(new java.awt.Color(255, 51, 51));
        jLabel6.setText("The organism, organ, tissue or biological sample that is being tested");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel6, gridBagConstraints);

        jLabel7.setForeground(java.awt.SystemColor.textHighlight);
        jLabel7.setText("Result Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel7, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(resultTypeField, gridBagConstraints);

        jLabel8.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel8.setForeground(new java.awt.Color(255, 51, 51));
        jLabel8.setText("The 'thing' being tested and it's tested property, eg disease status, body weight, NaCl concentration");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel8, gridBagConstraints);

        jLabel9.setForeground(java.awt.SystemColor.textHighlight);
        jLabel9.setText("Circumstance");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel9, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 14;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(circumstanceField, gridBagConstraints);

        jLabel10.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel10.setForeground(new java.awt.Color(255, 51, 51));
        jLabel10.setText("Any perticular situation under which the test is being conducted");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 15;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel10, gridBagConstraints);

        jLabel11.setForeground(java.awt.SystemColor.textHighlight);
        jLabel11.setText("Details");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 16;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel11, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 17;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(detailsField, gridBagConstraints);

        jLabel12.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel12.setForeground(new java.awt.Color(255, 51, 51));
        jLabel12.setText("Additional info that helps to describe this Phenotype Method");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 18;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel12, gridBagConstraints);

        jLabel13.setForeground(java.awt.SystemColor.textHighlight);
        jLabel13.setText("Tested Phenotype Entity");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel13, gridBagConstraints);

        phenotypeComboBox.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(phenotypeComboBox, gridBagConstraints);

        jLabel14.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel14.setForeground(new java.awt.Color(255, 51, 51));
        jLabel14.setText("The Phenotype Entity that is determined by this Phenotype Method");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel14, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void otherInformationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_otherInformationButtonActionPerformed
        parent.switchPanel(PhenotypeMethodPanel.OTHER);
    }//GEN-LAST:event_otherInformationButtonActionPerformed
    
    private HGVbaseSubmissionTool mainFrame;
    private PhenotypeMethodPanel parent;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField circumstanceField;
    private javax.swing.JTextField detailsField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JTextField methodNameField;
    private javax.swing.JPanel navigationEastPanel;
    private javax.swing.JPanel navigationPanel;
    private javax.swing.JButton otherInformationButton;
    private javax.swing.JComboBox phenotypeComboBox;
    private javax.swing.JTextField resultTypeField;
    private javax.swing.JTextField sampleTypeField;
    // End of variables declaration//GEN-END:variables
    
}
