/*
 * PhenotypeMethodOtherSettingsPanel.java
 *
 * Created on den 1 februari 2005, 11:28
 */

package phenobase.gui;

import java.util.*;
import phenobase.data.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *
 * @author  fresjo
 */
public class PhenotypeMethod_OtherInformationPanel extends javax.swing.JPanel implements PhenotypePanel {
    
    /** Creates new form MethodsPanel */
    public PhenotypeMethod_OtherInformationPanel(PhenotypeMethodPanel p, HGVbaseSubmissionTool mf) {
        parent = p;
        mainFrame = mf;
        initComponents();
    }
    
    public void fillForm(PhenotypeMethod pm) {
        timeInstantField.setText(pm.getTimeInstant());
        timePeriodField.setText(pm.getTimePeriod());
        Object[] keywords = pm.getKeywordArray();
        keywordList.setListData(keywords);
        Object[] citations = pm.getCitationArray();
        citationList.setListData(citations);
    }
    
    public void clearForm() {
        timeInstantField.setText("");
        timePeriodField.setText("");
        keywordList.setListData(new String[0]);
        citationList.setListData(new Citation[0]);
    }
    
    public String getTimeInstant() {
        return timeInstantField.getText();
    }
    
    public void setTimeInstant(String s) {
        timeInstantField.setText(s);
    }
    
    public String getTimePeriod() {
        return timePeriodField.getText();
    }
    
    public void setTimePeriodField(String s) {
        timePeriodField.setText(s);
    }
    
    public void addKeyword(String keyword) {
        ListModel lm = keywordList.getModel();
        String[] keywordArray = new String[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            keywordArray[i] = (String)lm.getElementAt(i);
        }
        keywordArray[lm.getSize()] = keyword;
        keywordList.setListData(keywordArray);
        validate();
        repaint();
    }
    
    public String[] getAddedKeywords() {
        ListModel lm = keywordList.getModel();
        String[] keywordArray = new String[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            keywordArray[i] = (String)lm.getElementAt(i);
        }
        return keywordArray;
    }
    
    private void deleteKeyword(int index) {
        ListModel lm = keywordList.getModel();
        String[] keywordArray = new String[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            String tmpKeyword = (String)lm.getElementAt(i);
            if(i != index) {
                keywordArray[count] = tmpKeyword;
                count++;
            }
        }
        keywordList.setListData(keywordArray);
        validate();
        repaint();
    }
    
    public void addCitation(Citation c) {
        ListModel lm = citationList.getModel();
        Citation[] citationArray = new Citation[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            citationArray[i] = (Citation)lm.getElementAt(i);
        }
        citationArray[lm.getSize()] = c;
        citationList.setListData(citationArray);
        validate();
        repaint();
    }
    
    public Object[] getCitations() {
        return mainFrame.getCurrentStudy().getCitationArray();
    }
    
    public Citation[] getAddedCitations() {
        ListModel lm = citationList.getModel();
        Citation[] citationArray = new Citation[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            citationArray[i] = (Citation)lm.getElementAt(i);
        }
        return citationArray;
    }
    
    private void deleteCitation(int index) {
        ListModel lm = citationList.getModel();
        Citation[] citationArray = new Citation[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            Citation tmpCitation = (Citation)lm.getElementAt(i);
            if(i != index) {
                citationArray[count] = tmpCitation;
                count++;
            }
        }
        citationList.setListData(citationArray);
        validate();
        repaint();
    }
    
    private void emptyForm() {
        timeInstantField.setText("");
        timePeriodField.setText("");
        keywordList.setListData(new Object[0]);
        citationList.setListData(new Object[0]);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        citationsPanel = new javax.swing.JPanel();
        citationsScrollPane1 = new javax.swing.JScrollPane();
        citationList = new javax.swing.JList();
        jPanel7 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        citationsdeleteButton = new javax.swing.JButton();
        citationsAddButton = new javax.swing.JButton();
        timeAspectsPanel = new javax.swing.JPanel();
        timeInstanceLabel1 = new javax.swing.JLabel();
        timeInstantField = new javax.swing.JTextField();
        timeInstanceHelpLabel1 = new javax.swing.JLabel();
        timePeriodLabel1 = new javax.swing.JLabel();
        timePeriodField = new javax.swing.JTextField();
        timePeriodHelpLabel1 = new javax.swing.JLabel();
        timeAspectsLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        keywordsPanel = new javax.swing.JPanel();
        keywordsLabel1 = new javax.swing.JLabel();
        keywordsScrollPane1 = new javax.swing.JScrollPane();
        keywordList = new javax.swing.JList();
        keywordButtonPanel = new javax.swing.JPanel();
        keywordButtonPanelEast = new javax.swing.JPanel();
        keywordDeleteButton = new javax.swing.JButton();
        keywordAddButton = new javax.swing.JButton();
        navigationPanel = new javax.swing.JPanel();
        westNavigationPanel = new javax.swing.JPanel();
        generalInformationButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setLayout(new java.awt.GridBagLayout());

        citationsPanel.setLayout(new java.awt.GridBagLayout());

        citationsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Citations"));
        citationsScrollPane1.setPreferredSize(new java.awt.Dimension(810, 80));
        citationList.setBackground(new java.awt.Color(255, 255, 204));
        citationsScrollPane1.setViewportView(citationList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        citationsPanel.add(citationsScrollPane1, gridBagConstraints);

        jPanel7.setLayout(new java.awt.BorderLayout());

        citationsdeleteButton.setText("Discard Citation for this Phenotype Method");
        citationsdeleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                citationsdeleteButtonActionPerformed(evt);
            }
        });

        jPanel8.add(citationsdeleteButton);

        citationsAddButton.setText("Choose new Citation for this Phenotype Method");
        citationsAddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                citationsAddButtonActionPerformed(evt);
            }
        });

        jPanel8.add(citationsAddButton);

        jPanel7.add(jPanel8, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        citationsPanel.add(jPanel7, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(citationsPanel, gridBagConstraints);

        timeAspectsPanel.setLayout(new java.awt.GridBagLayout());

        timeAspectsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Time Aspects"));
        timeInstanceLabel1.setForeground(java.awt.SystemColor.textHighlight);
        timeInstanceLabel1.setText("Time Instant");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        timeAspectsPanel.add(timeInstanceLabel1, gridBagConstraints);

        timeInstantField.setPreferredSize(new java.awt.Dimension(10, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        timeAspectsPanel.add(timeInstantField, gridBagConstraints);

        timeInstanceHelpLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        timeInstanceHelpLabel1.setForeground(new java.awt.Color(255, 51, 51));
        timeInstanceHelpLabel1.setText("Use this field for methods done at one moment in time");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        timeAspectsPanel.add(timeInstanceHelpLabel1, gridBagConstraints);

        timePeriodLabel1.setForeground(java.awt.SystemColor.textHighlight);
        timePeriodLabel1.setText("Time Period");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        timeAspectsPanel.add(timePeriodLabel1, gridBagConstraints);

        timePeriodField.setPreferredSize(new java.awt.Dimension(10, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        timeAspectsPanel.add(timePeriodField, gridBagConstraints);

        timePeriodHelpLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        timePeriodHelpLabel1.setForeground(new java.awt.Color(255, 51, 51));
        timePeriodHelpLabel1.setText("Use this field for methods done over a period of time");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        timeAspectsPanel.add(timePeriodHelpLabel1, gridBagConstraints);

        timeAspectsLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        timeAspectsLabel1.setForeground(new java.awt.Color(102, 102, 255));
        timeAspectsLabel1.setText("Use these fields if the timing of the test is important for interpretation of the result.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        timeAspectsPanel.add(timeAspectsLabel1, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel2.setForeground(new java.awt.Color(102, 102, 255));
        jLabel2.setText("Only one of the fields can be filled in.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        timeAspectsPanel.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 3, 2, 3);
        add(timeAspectsPanel, gridBagConstraints);

        keywordsPanel.setLayout(new java.awt.GridBagLayout());

        keywordsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Keywords"));
        keywordsLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        keywordsLabel1.setForeground(new java.awt.Color(102, 102, 255));
        keywordsLabel1.setText("Keywords associated with this Phenotype Method");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        keywordsPanel.add(keywordsLabel1, gridBagConstraints);

        keywordsScrollPane1.setPreferredSize(new java.awt.Dimension(300, 100));
        keywordList.setBackground(new java.awt.Color(255, 255, 204));
        keywordsScrollPane1.setViewportView(keywordList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        keywordsPanel.add(keywordsScrollPane1, gridBagConstraints);

        keywordButtonPanel.setLayout(new java.awt.BorderLayout());

        keywordDeleteButton.setText("Delete");
        keywordDeleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                keywordDeleteButtonActionPerformed(evt);
            }
        });

        keywordButtonPanelEast.add(keywordDeleteButton);

        keywordAddButton.setText("Add");
        keywordAddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                keywordAddButtonActionPerformed(evt);
            }
        });

        keywordButtonPanelEast.add(keywordAddButton);

        keywordButtonPanel.add(keywordButtonPanelEast, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        keywordsPanel.add(keywordButtonPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 3, 2, 3);
        add(keywordsPanel, gridBagConstraints);

        navigationPanel.setLayout(new java.awt.BorderLayout());

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        generalInformationButton.setIcon(new javax.swing.ImageIcon("C:\\hgvbasePics\\left30.gif"));
        generalInformationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                generalInformationButtonActionPerformed(evt);
            }
        });

        westNavigationPanel.add(generalInformationButton);

        jLabel1.setText("Go to General Information");
        westNavigationPanel.add(jLabel1);

        navigationPanel.add(westNavigationPanel, java.awt.BorderLayout.WEST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void citationsdeleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_citationsdeleteButtonActionPerformed
        int selectedIndex = citationList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteCitation(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a citation to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_citationsdeleteButtonActionPerformed

    private void citationsAddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_citationsAddButtonActionPerformed
        CitationsFrame cf = new CitationsFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());
    }//GEN-LAST:event_citationsAddButtonActionPerformed

    private void keywordDeleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_keywordDeleteButtonActionPerformed
        int selectedIndex = keywordList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteKeyword(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a keyword to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_keywordDeleteButtonActionPerformed

    private void keywordAddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_keywordAddButtonActionPerformed
        KeywordFrame keywordFrame = new KeywordFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());
    }//GEN-LAST:event_keywordAddButtonActionPerformed

    private void generalInformationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_generalInformationButtonActionPerformed
        parent.switchPanel(PhenotypeMethodPanel.GENERAL);
    }//GEN-LAST:event_generalInformationButtonActionPerformed
        
    private PhenotypeMethodPanel parent;
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList citationList;
    private javax.swing.JButton citationsAddButton;
    private javax.swing.JPanel citationsPanel;
    private javax.swing.JScrollPane citationsScrollPane1;
    private javax.swing.JButton citationsdeleteButton;
    private javax.swing.JButton generalInformationButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JButton keywordAddButton;
    private javax.swing.JPanel keywordButtonPanel;
    private javax.swing.JPanel keywordButtonPanelEast;
    private javax.swing.JButton keywordDeleteButton;
    private javax.swing.JList keywordList;
    private javax.swing.JLabel keywordsLabel1;
    private javax.swing.JPanel keywordsPanel;
    private javax.swing.JScrollPane keywordsScrollPane1;
    private javax.swing.JPanel navigationPanel;
    private javax.swing.JLabel timeAspectsLabel1;
    private javax.swing.JPanel timeAspectsPanel;
    private javax.swing.JLabel timeInstanceHelpLabel1;
    private javax.swing.JLabel timeInstanceLabel1;
    private javax.swing.JTextField timeInstantField;
    private javax.swing.JTextField timePeriodField;
    private javax.swing.JLabel timePeriodHelpLabel1;
    private javax.swing.JLabel timePeriodLabel1;
    private javax.swing.JPanel westNavigationPanel;
    // End of variables declaration//GEN-END:variables
    
}
