/*
 * PhenotypePanel.java
 *
 * Created on den 2 februari 2005, 11:43
 */

package phenobase.gui;

import phenobase.data.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author  fresjo 
 */
public class PhenotypeProperty_GeneralInformationPanel extends javax.swing.JPanel {
    
    /** Creates new form PhenotypePanel */
    public PhenotypeProperty_GeneralInformationPanel(HGVbaseSubmissionTool mf, PhenotypePropertyPanel pg) {
        mainFrame = mf;
        parent = pg;
        initComponents();
    }
    
    public void fillForm(PhenotypeProperty pg) {
        propertyNameField.setText(pg.getPropertyName());
        commentField.setText(pg.getComment());
        Object[] subphenotypes = pg.getSubphenotypes();
        subphenotypeList.setListData(subphenotypes);
    }
    
    public void clearForm() {
        propertyNameField.setText("");
        commentField.setText("");
        subphenotypeList.setListData(new PhenotypeProperty[0]);
        validate();
        repaint();
    }
    
    public String getPropertyName() {
        return propertyNameField.getText();
    }
    
    public String getComment() {
        return commentField.getText();
    }

    public Object[] getPhenotypeTraits() {
        return mainFrame.getCurrentStudy().getPhenotypePropertyArray();
    }
    
    public String[] getPhenotypeNames() {
        if(parent.getSelectedPhenotype() != null) {
            return mainFrame.getCurrentStudy().getPossibleSubphenotypeNames(parent.getSelectedPhenotype());
        }
        else {
            Object[] phenotypes = getPhenotypeTraits();
            String[] res = new String[phenotypes.length];
            for(int i = 0; i < phenotypes.length; i++) {
                res[i] = ((PhenotypeProperty)phenotypes[i]).getPropertyName();
            }
            return res;
        }
    }
    
    public void addSubphenotypeName(String name) {
        ListModel lm = subphenotypeList.getModel();
        String[] subphenotypeNameArray = new String[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            subphenotypeNameArray[i] = (String)lm.getElementAt(i);
        }
        subphenotypeNameArray[lm.getSize()] = name;
        subphenotypeList.setListData(subphenotypeNameArray);
        validate();
        repaint();
    }
    
    public void addSubphenotype(PhenotypeProperty pg) {
        ListModel lm = subphenotypeList.getModel();
        PhenotypeProperty[] subphenotypeArray = new PhenotypeProperty[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            subphenotypeArray[i] = (PhenotypeProperty)lm.getElementAt(i);
        }
        subphenotypeArray[lm.getSize()] = pg;
        subphenotypeList.setListData(subphenotypeArray);
        validate();
        repaint();
    }
    
    private void deleteSubphenotype(int index) {
        ListModel lm = subphenotypeList.getModel();
        String[] subphenotypeArray = new String[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            String tmp = (String)lm.getElementAt(i);
            if(i != index) {
                subphenotypeArray[count] = tmp;
                count++;
            }
        }
        subphenotypeList.setListData(subphenotypeArray);
        validate();
        repaint();
    }
    
    public String[] getAddedSubphenotypes() {
        ListModel lm = subphenotypeList.getModel();
        String[] subphenotypeArray = new String[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            subphenotypeArray[i] = (String)lm.getElementAt(i);
        }
        return subphenotypeArray;
    }
        
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        phenotypeNameHelpLabel = new javax.swing.JLabel();
        propertyNameField = new javax.swing.JTextField();
        phenotypeNameLabel = new javax.swing.JLabel();
        freeTextLabel = new javax.swing.JLabel();
        freeTextHelpLabel = new javax.swing.JLabel();
        subphenotypePanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        subphenotypeScrollPane = new javax.swing.JScrollPane();
        subphenotypeList = new javax.swing.JList();
        subphenotypeButtonPanel = new javax.swing.JPanel();
        subphenotypeEastButtonPanel = new javax.swing.JPanel();
        deleteSubphenotypeButton = new javax.swing.JButton();
        addSubphenotypeButton = new javax.swing.JButton();
        navigationPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        commentField = new javax.swing.JTextArea();

        setLayout(new java.awt.GridBagLayout());

        phenotypeNameHelpLabel.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        phenotypeNameHelpLabel.setForeground(new java.awt.Color(255, 51, 51));
        phenotypeNameHelpLabel.setText("A descriptive name, e.g., \u2018Alzheimers Disease\u2019, \u2018body weight\u2019, \u2018skin color\u2019");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 12;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(phenotypeNameHelpLabel, gridBagConstraints);

        propertyNameField.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        propertyNameField.setPreferredSize(new java.awt.Dimension(300, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 12;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(propertyNameField, gridBagConstraints);

        phenotypeNameLabel.setForeground(java.awt.SystemColor.textHighlight);
        phenotypeNameLabel.setText("Name of Phenotype Entity");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 6;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(phenotypeNameLabel, gridBagConstraints);

        freeTextLabel.setForeground(java.awt.SystemColor.textHighlight);
        freeTextLabel.setText("Comment");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 12;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(freeTextLabel, gridBagConstraints);

        freeTextHelpLabel.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        freeTextHelpLabel.setForeground(new java.awt.Color(255, 51, 51));
        freeTextHelpLabel.setText("Free text comments");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 12;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(freeTextHelpLabel, gridBagConstraints);

        subphenotypePanel.setLayout(new java.awt.GridBagLayout());

        subphenotypePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Sub/Endo-Phenotypes For This Phenotype Entity"));
        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel1.setForeground(new java.awt.Color(102, 102, 255));
        jLabel1.setText("List Phenotype Entities are sub/endo-phenotypes of the current Phenotype Entity");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        subphenotypePanel.add(jLabel1, gridBagConstraints);

        subphenotypeScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        subphenotypeList.setBackground(new java.awt.Color(255, 255, 204));
        subphenotypeScrollPane.setViewportView(subphenotypeList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        subphenotypePanel.add(subphenotypeScrollPane, gridBagConstraints);

        subphenotypeButtonPanel.setLayout(new java.awt.BorderLayout());

        deleteSubphenotypeButton.setText("Discard Subphenotype for this Phenotype Entity");
        deleteSubphenotypeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteSubphenotypeButtonActionPerformed(evt);
            }
        });

        subphenotypeEastButtonPanel.add(deleteSubphenotypeButton);

        addSubphenotypeButton.setText("Choose new Subphenotype for this Phenotype Entity");
        addSubphenotypeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addSubphenotypeButtonActionPerformed(evt);
            }
        });

        subphenotypeEastButtonPanel.add(addSubphenotypeButton);

        subphenotypeButtonPanel.add(subphenotypeEastButtonPanel, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        subphenotypePanel.add(subphenotypeButtonPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 12;
        gridBagConstraints.gridheight = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(subphenotypePanel, gridBagConstraints);

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.red, 2));
        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14));
        jLabel2.setForeground(java.awt.Color.red);
        jLabel2.setText("1/2");
        jPanel1.add(jLabel2);

        jPanel2.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray, 2));
        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14));
        jLabel3.setForeground(java.awt.Color.gray);
        jLabel3.setText("2/2");
        jPanel2.add(jLabel3);

        jButton1.setIcon(new javax.swing.ImageIcon("C:\\Documents and Settings\\fredrik\\phenobase\\right30.gif"));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel4.setText("Go to Other Information");

        org.jdesktop.layout.GroupLayout navigationPanelLayout = new org.jdesktop.layout.GroupLayout(navigationPanel);
        navigationPanel.setLayout(navigationPanelLayout);
        navigationPanelLayout.setHorizontalGroup(
            navigationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, navigationPanelLayout.createSequentialGroup()
                .addContainerGap(76, Short.MAX_VALUE)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(100, 100, 100)
                .add(jLabel4)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton1))
        );
        navigationPanelLayout.setVerticalGroup(
            navigationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.BASELINE, jButton1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.BASELINE, jLabel4)
            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
        );
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 19;
        gridBagConstraints.gridwidth = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

        commentField.setColumns(20);
        commentField.setLineWrap(true);
        commentField.setRows(2);
        commentField.setWrapStyleWord(true);
        jScrollPane1.setViewportView(commentField);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 12;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(jScrollPane1, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        parent.switchPanel(PhenotypePropertyPanel.OTHER);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void deleteSubphenotypeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteSubphenotypeButtonActionPerformed
        int selectedIndex = subphenotypeList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteSubphenotype(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a Subphenotype to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_deleteSubphenotypeButtonActionPerformed

    private void addSubphenotypeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addSubphenotypeButtonActionPerformed
         SubphenotypeFrame cf = new SubphenotypeFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());        
    }//GEN-LAST:event_addSubphenotypeButtonActionPerformed
    
    private PhenotypePropertyPanel parent;
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addSubphenotypeButton;
    private javax.swing.JTextArea commentField;
    private javax.swing.JButton deleteSubphenotypeButton;
    private javax.swing.JLabel freeTextHelpLabel;
    private javax.swing.JLabel freeTextLabel;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JPanel navigationPanel;
    private javax.swing.JLabel phenotypeNameHelpLabel;
    private javax.swing.JLabel phenotypeNameLabel;
    private javax.swing.JTextField propertyNameField;
    private javax.swing.JPanel subphenotypeButtonPanel;
    private javax.swing.JPanel subphenotypeEastButtonPanel;
    private javax.swing.JList subphenotypeList;
    private javax.swing.JPanel subphenotypePanel;
    private javax.swing.JScrollPane subphenotypeScrollPane;
    // End of variables declaration//GEN-END:variables
    
}
