/*
 * PhenotypeHierarchiesPanel.java
 *
 * Created on den 20 mars 2006, 12:07
 */

package phenobase.gui;

import phenobase.data.*;

import javax.swing.*;

/**
 *
 * @author  fresjo
 */
public class PhenotypeProperty_OtherInformationPanel extends javax.swing.JPanel implements PhenotypePanel {
    
    /** Creates new form PhenotypeHierarchiesPanel */
    public PhenotypeProperty_OtherInformationPanel(HGVbaseSubmissionTool mf, PhenotypePropertyPanel pg) {
        mainFrame = mf;
        parent = pg;
        initComponents();
    }
    
    public void fillForm(PhenotypeProperty pg) {
        Object[] diseaseAreas = pg.getDiseaseAreas();
        diseaseAreaList.setListData(diseaseAreas);
        Object[] keywords = pg.getKeywords();
        keywordList.setListData(keywords);
        Object[] anatomicScales = pg.getAnatomicScales();
        anatomicScaleList.setListData(anatomicScales);
        Object[] citations = pg.getCitations();
        citationsList.setListData(citations);
    }
    
    public void clearForm() {
        diseaseAreaList.setListData(new String[0]);
        anatomicScaleList.setListData(new String[0]);
        citationsList.setListData(new Citation[0]);
        keywordList.setListData(new String[0]);
        validate();
        repaint();
    }

    public void addKeyword(String keyword) {
        ListModel lm = keywordList.getModel();
        String[] keywordArray = new String[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            keywordArray[i] = (String)lm.getElementAt(i);
        }
        keywordArray[lm.getSize()] = keyword;
        keywordList.setListData(keywordArray);
        validate();
        repaint();
    }
    
    private void deleteKeyword(int index) {
        ListModel lm = keywordList.getModel();
        String[] keywordArray = new String[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            String tmpKeyword = (String)lm.getElementAt(i);
            if(i != index) {
                keywordArray[count] = tmpKeyword;
                count++;
            }
        }
        keywordList.setListData(keywordArray);
        validate();
        repaint();
    }
    
    public String[] getAddedKeywords() {
        ListModel lm = keywordList.getModel();
        String[] keywordArray = new String[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            keywordArray[i] = (String)lm.getElementAt(i);
        }
        return keywordArray;
    }
    
    public void addAnatomicScale(String as) {
        ListModel lm = anatomicScaleList.getModel();
        String[] anatomicScaleArray = new String[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            anatomicScaleArray[i] = (String)lm.getElementAt(i);
        }
        anatomicScaleArray[lm.getSize()] = as;
        anatomicScaleList.setListData(anatomicScaleArray);
        validate();
        repaint();
    }
    
    private void deleteAnatomicScale(int index) {
        ListModel lm = anatomicScaleList.getModel();
        String[] anatomicScaleArray = new String[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            String tmp = (String)lm.getElementAt(i);
            if(i != index) {
                anatomicScaleArray[count] = tmp;
                count++;
            }
        }
        anatomicScaleList.setListData(anatomicScaleArray);
        validate();
        repaint();
    }
    
    public String[] getAddedAnatomicScales() {
        ListModel lm = anatomicScaleList.getModel();
        String[] anatomicScaleArray = new String[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            anatomicScaleArray[i] = (String)lm.getElementAt(i);
        }
        return anatomicScaleArray;
    } 

    public void addDiseaseArea(String da) {
        ListModel lm = diseaseAreaList.getModel();
        String[] diseaseAreaArray = new String[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            diseaseAreaArray[i] = (String)lm.getElementAt(i);
        }
        diseaseAreaArray[lm.getSize()] = da;
        diseaseAreaList.setListData(diseaseAreaArray);
        validate();
        repaint();
    }
    
    private void deleteDiseaseArea(int index) {
        ListModel lm = diseaseAreaList.getModel();
        String[] diseaseAreaArray = new String[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            String tmpDiseaseArea = (String)lm.getElementAt(i);
            if(i != index) {
                diseaseAreaArray[count] = tmpDiseaseArea;
                count++;
            }
        }
        diseaseAreaList.setListData(diseaseAreaArray);
        validate();
        repaint();
    }
    
    public String[] getAddedDiseaseAreas() {
        ListModel lm = diseaseAreaList.getModel();
        String[] diseaseAreaArray = new String[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            diseaseAreaArray[i] = (String)lm.getElementAt(i);
        }
        return diseaseAreaArray;
    }
    
    public void addCitation(Citation c) {
        ListModel lm = citationsList.getModel();
        Citation[] citationArray = new Citation[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            citationArray[i] = (Citation)lm.getElementAt(i);
        }
        citationArray[lm.getSize()] = c;
        citationsList.setListData(citationArray);
        validate();
        repaint();
    }
    
    private void deleteCitation(int index) {
        ListModel lm = citationsList.getModel();
        Citation[] citationArray = new Citation[lm.getSize() - 1];
        int count = 0;
        for(int i = 0; i < lm.getSize(); i++) {
            Citation tmpCitation = (Citation)lm.getElementAt(i);
            if(i != index) {
                citationArray[count] = tmpCitation;
                count++;
            }
        }
        citationsList.setListData(citationArray);
        validate();
        repaint();
    }
    
    public Citation[] getAddedCitations() {
        ListModel lm = citationsList.getModel();
        Citation[] citationArray = new Citation[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            citationArray[i] = (Citation)lm.getElementAt(i);
        }
        return citationArray;
    }
    
    public Object[] getCitations() {
        return mainFrame.getCurrentStudy().getCitationArray();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        citationsPanel = new javax.swing.JPanel();
        citationsScrollPane = new javax.swing.JScrollPane();
        citationsList = new javax.swing.JList();
        citationButtonPanel = new javax.swing.JPanel();
        citationEastButtonPanel = new javax.swing.JPanel();
        deleteCitationButton = new javax.swing.JButton();
        addCitationButton = new javax.swing.JButton();
        diseaseAreasPanel = new javax.swing.JPanel();
        diseaseAreaScrollPane = new javax.swing.JScrollPane();
        diseaseAreaList = new javax.swing.JList();
        diseaseAreaButtonPanel = new javax.swing.JPanel();
        diseaseAreaButtonPanelEast = new javax.swing.JPanel();
        deleteDiseaseAreaButton = new javax.swing.JButton();
        addDiseaseAreaButton = new javax.swing.JButton();
        anatomicScalesPanel = new javax.swing.JPanel();
        anatomicScaleScrollPane = new javax.swing.JScrollPane();
        anatomicScaleList = new javax.swing.JList();
        anatomicScaleButtonPanel = new javax.swing.JPanel();
        anatomicScaleButtonPanelEast = new javax.swing.JPanel();
        deleteAnatomicScaleButton = new javax.swing.JButton();
        addAnatomicScaleButton = new javax.swing.JButton();
        keywordsPanel = new javax.swing.JPanel();
        keywordScrollPane = new javax.swing.JScrollPane();
        keywordList = new javax.swing.JList();
        keywordButtonPanel = new javax.swing.JPanel();
        keywordButtonPanelEast = new javax.swing.JPanel();
        deleteKeywordButton = new javax.swing.JButton();
        addKeywordButton = new javax.swing.JButton();
        navigationPanel = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();

        setLayout(new java.awt.GridBagLayout());

        citationsPanel.setLayout(new java.awt.GridBagLayout());

        citationsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Citations Concerning The Phenotype Entity"));
        citationsScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        citationsList.setBackground(new java.awt.Color(255, 255, 204));
        citationsScrollPane.setViewportView(citationsList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        citationsPanel.add(citationsScrollPane, gridBagConstraints);

        citationButtonPanel.setLayout(new java.awt.BorderLayout());

        deleteCitationButton.setText("Discard Citation for this Phenotype Property");
        deleteCitationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteCitationButtonActionPerformed(evt);
            }
        });

        citationEastButtonPanel.add(deleteCitationButton);

        addCitationButton.setText("Choose new Citation for this Phenotype Property");
        addCitationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addCitationButtonActionPerformed(evt);
            }
        });

        citationEastButtonPanel.add(addCitationButton);

        citationButtonPanel.add(citationEastButtonPanel, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        citationsPanel.add(citationButtonPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(citationsPanel, gridBagConstraints);

        diseaseAreasPanel.setLayout(new java.awt.GridBagLayout());

        diseaseAreasPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Disease Areas"));
        diseaseAreaScrollPane.setPreferredSize(new java.awt.Dimension(250, 80));
        diseaseAreaList.setBackground(new java.awt.Color(255, 255, 204));
        diseaseAreaScrollPane.setViewportView(diseaseAreaList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        diseaseAreasPanel.add(diseaseAreaScrollPane, gridBagConstraints);

        diseaseAreaButtonPanel.setLayout(new java.awt.BorderLayout());

        deleteDiseaseAreaButton.setText("Delete");
        deleteDiseaseAreaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteDiseaseAreaButtonActionPerformed(evt);
            }
        });

        diseaseAreaButtonPanelEast.add(deleteDiseaseAreaButton);

        addDiseaseAreaButton.setText("Add");
        addDiseaseAreaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addDiseaseAreaButtonActionPerformed(evt);
            }
        });

        diseaseAreaButtonPanelEast.add(addDiseaseAreaButton);

        diseaseAreaButtonPanel.add(diseaseAreaButtonPanelEast, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        diseaseAreasPanel.add(diseaseAreaButtonPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(diseaseAreasPanel, gridBagConstraints);

        anatomicScalesPanel.setLayout(new java.awt.GridBagLayout());

        anatomicScalesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Anatomic Scales"));
        anatomicScaleScrollPane.setPreferredSize(new java.awt.Dimension(250, 80));
        anatomicScaleList.setBackground(new java.awt.Color(255, 255, 204));
        anatomicScaleScrollPane.setViewportView(anatomicScaleList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        anatomicScalesPanel.add(anatomicScaleScrollPane, gridBagConstraints);

        anatomicScaleButtonPanel.setLayout(new java.awt.BorderLayout());

        deleteAnatomicScaleButton.setText("Delete");
        deleteAnatomicScaleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteAnatomicScaleButtonActionPerformed(evt);
            }
        });

        anatomicScaleButtonPanelEast.add(deleteAnatomicScaleButton);

        addAnatomicScaleButton.setText("Add");
        addAnatomicScaleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAnatomicScaleButtonActionPerformed(evt);
            }
        });

        anatomicScaleButtonPanelEast.add(addAnatomicScaleButton);

        anatomicScaleButtonPanel.add(anatomicScaleButtonPanelEast, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        anatomicScalesPanel.add(anatomicScaleButtonPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(anatomicScalesPanel, gridBagConstraints);

        keywordsPanel.setLayout(new java.awt.GridBagLayout());

        keywordsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Keywords"));
        keywordScrollPane.setPreferredSize(new java.awt.Dimension(250, 80));
        keywordList.setBackground(new java.awt.Color(255, 255, 204));
        keywordScrollPane.setViewportView(keywordList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        keywordsPanel.add(keywordScrollPane, gridBagConstraints);

        keywordButtonPanel.setLayout(new java.awt.BorderLayout());

        deleteKeywordButton.setText("Delete");
        deleteKeywordButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteKeywordButtonActionPerformed(evt);
            }
        });

        keywordButtonPanelEast.add(deleteKeywordButton);

        addKeywordButton.setText("Add");
        addKeywordButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addKeywordButtonActionPerformed(evt);
            }
        });

        keywordButtonPanelEast.add(addKeywordButton);

        keywordButtonPanel.add(keywordButtonPanelEast, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        keywordsPanel.add(keywordButtonPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(keywordsPanel, gridBagConstraints);

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jButton1.setIcon(new javax.swing.ImageIcon("C:\\Documents and Settings\\fredrik\\phenobase\\left30.gif"));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel1.setText("Go to General Information");

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray, 2));
        jLabel7.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14));
        jLabel7.setForeground(java.awt.Color.gray);
        jLabel7.setText("1/2");
        jPanel1.add(jLabel7);

        jPanel2.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.red, 2));
        jLabel8.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14));
        jLabel8.setForeground(java.awt.Color.red);
        jLabel8.setText("2/2");
        jPanel2.add(jLabel8);

        org.jdesktop.layout.GroupLayout navigationPanelLayout = new org.jdesktop.layout.GroupLayout(navigationPanel);
        navigationPanel.setLayout(navigationPanelLayout);
        navigationPanelLayout.setHorizontalGroup(
            navigationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(navigationPanelLayout.createSequentialGroup()
                .add(jButton1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel1)
                .add(107, 107, 107)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(16, Short.MAX_VALUE))
        );
        navigationPanelLayout.setVerticalGroup(
            navigationPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.BASELINE, jButton1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.BASELINE, jLabel1)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void deleteAnatomicScaleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteAnatomicScaleButtonActionPerformed
        int selectedIndex = anatomicScaleList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteAnatomicScale(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a Category to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_deleteAnatomicScaleButtonActionPerformed

    private void deleteDiseaseAreaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteDiseaseAreaButtonActionPerformed
        int selectedIndex = diseaseAreaList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteDiseaseArea(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a Disease Area to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_deleteDiseaseAreaButtonActionPerformed

    private void deleteCitationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteCitationButtonActionPerformed
        int selectedIndex = citationsList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteCitation(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a Publication to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_deleteCitationButtonActionPerformed

    private void deleteKeywordButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteKeywordButtonActionPerformed
        int selectedIndex = keywordList.getSelectedIndex();
        if(selectedIndex != -1) {
            deleteKeyword(selectedIndex);
        }
        else {
            JOptionPane.showMessageDialog(this,
                "You have to select a keyword to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_deleteKeywordButtonActionPerformed

    private void addKeywordButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addKeywordButtonActionPerformed
         KeywordFrame cf = new KeywordFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());
    }//GEN-LAST:event_addKeywordButtonActionPerformed

    private void addAnatomicScaleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAnatomicScaleButtonActionPerformed
         AnatomicScaleFrame cf = new AnatomicScaleFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());
    }//GEN-LAST:event_addAnatomicScaleButtonActionPerformed

    private void addDiseaseAreaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addDiseaseAreaButtonActionPerformed
         DiseaseAreaFrame cf = new DiseaseAreaFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());
    }//GEN-LAST:event_addDiseaseAreaButtonActionPerformed

    private void addCitationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addCitationButtonActionPerformed
        CitationsFrame cf = new CitationsFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY());
    }//GEN-LAST:event_addCitationButtonActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        parent.switchPanel(PhenotypePropertyPanel.GENERAL);
    }//GEN-LAST:event_jButton1ActionPerformed

    
    private HGVbaseSubmissionTool mainFrame;
    private PhenotypePropertyPanel parent;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addAnatomicScaleButton;
    private javax.swing.JButton addCitationButton;
    private javax.swing.JButton addDiseaseAreaButton;
    private javax.swing.JButton addKeywordButton;
    private javax.swing.JPanel anatomicScaleButtonPanel;
    private javax.swing.JPanel anatomicScaleButtonPanelEast;
    private javax.swing.JList anatomicScaleList;
    private javax.swing.JScrollPane anatomicScaleScrollPane;
    private javax.swing.JPanel anatomicScalesPanel;
    private javax.swing.JPanel citationButtonPanel;
    private javax.swing.JPanel citationEastButtonPanel;
    private javax.swing.JList citationsList;
    private javax.swing.JPanel citationsPanel;
    private javax.swing.JScrollPane citationsScrollPane;
    private javax.swing.JButton deleteAnatomicScaleButton;
    private javax.swing.JButton deleteCitationButton;
    private javax.swing.JButton deleteDiseaseAreaButton;
    private javax.swing.JButton deleteKeywordButton;
    private javax.swing.JPanel diseaseAreaButtonPanel;
    private javax.swing.JPanel diseaseAreaButtonPanelEast;
    private javax.swing.JList diseaseAreaList;
    private javax.swing.JScrollPane diseaseAreaScrollPane;
    private javax.swing.JPanel diseaseAreasPanel;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel keywordButtonPanel;
    private javax.swing.JPanel keywordButtonPanelEast;
    private javax.swing.JList keywordList;
    private javax.swing.JScrollPane keywordScrollPane;
    private javax.swing.JPanel keywordsPanel;
    private javax.swing.JPanel navigationPanel;
    // End of variables declaration//GEN-END:variables
    
}
