/*
 * ObservationPanel.java
 *
 * Created on den 20 mars 2006, 16:12
 */

package phenobase.gui;

import phenobase.data.*;
import phenobase.handling.*;
import phenobase.storage.*;
import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 *
 * @author  fresjo
 */
public class PhenotypeValuePanel extends javax.swing.JPanel implements Observer {
    
    /** Creates new form ObservationPanel */
    public PhenotypeValuePanel(HGVbaseSubmissionTool mf) {
        mainFrame = mf;
        mainFrame.getCurrentStudy().addObserver(this);
        initComponents();
    }
    
    public void update(Observable o, Object arg) {
        Study s = (Study)o;
        addedPhenotypeValuesList.setListData(s.getPhenotypeValueArray());
        setPhenotypeMethods(s.getMethodNames());
        validate();
        repaint();
    }
    
    public void clearForm() {
        addedPhenotypeValuesList.clearSelection();
        if(phenotypeMethodComboBox.getItemCount() > 0) {
            phenotypeMethodComboBox.setSelectedIndex(0);
        }
        phenotypeValueField.setText("");
        PhenotypeValueDetailTableModel model = (PhenotypeValueDetailTableModel)addedPhenotypeValueDetailsTable.getModel();
        model.removeAllPhenotypeValueDetails();
    }
    
    public void fillForm(PhenotypeValue pv) {
        phenotypeMethodComboBox.setSelectedItem(pv.getPhenotypeMethod());
        phenotypeValueField.setText(pv.getPhenotypeValue());
        Object[] valueDetails = pv.getPhenotypeValueDetailArray();
        PhenotypeValueDetailTableModel model = (PhenotypeValueDetailTableModel)addedPhenotypeValueDetailsTable.getModel();
        model.setPhenotypeValueDetails(valueDetails);
    }
    
    public void addPhenotypeValueDetail(PhenotypeValueDetail v) {
        int selectedRow = addedPhenotypeValueDetailsTable.getSelectedRow();
        PhenotypeValueDetailTableModel model = (PhenotypeValueDetailTableModel)addedPhenotypeValueDetailsTable.getModel();
        if(selectedRow == -1) {
            model.addPhenotypeValueDetail(v);
        }
        else {
            model.replacePhenotypeValueDetail(v, selectedRow);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        addedPhenotypeValuesPanel = new javax.swing.JPanel();
        addedPhenotypeValuesScrollPane = new javax.swing.JScrollPane();
        addedPhenotypeValuesList = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        phenotypeValuePanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        phenotypeMethodComboBox = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        phenotypeValueField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        phenotypeValueDetailPanel = new javax.swing.JPanel();
        addedPhenotypeValueDetailsScrollPane = new javax.swing.JScrollPane();
        addedPhenotypeValueDetailsTable = new javax.swing.JTable();
        addedPhenotypeValueDetailsTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jLabel13 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        deletePhenotypeValueDetailButton = new javax.swing.JButton();
        addModifyPhenotypeValueDetailButton = new javax.swing.JButton();
        buttonPanel = new javax.swing.JPanel();
        eastButtonPanel = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        addModifyButton = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        setBorder(javax.swing.BorderFactory.createTitledBorder("Phenotype Values: enter group-level Phenotype Values, and later assign these to Sample-Panels (not to individuals)"));
        addedPhenotypeValuesPanel.setLayout(new java.awt.GridBagLayout());

        addedPhenotypeValuesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Phenotype Values"));
        addedPhenotypeValuesScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        addedPhenotypeValuesList.setBackground(new java.awt.Color(255, 255, 204));
        addedPhenotypeValuesList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                addedPhenotypeValuesListValueChanged(evt);
            }
        });

        addedPhenotypeValuesScrollPane.setViewportView(addedPhenotypeValuesList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        addedPhenotypeValuesPanel.add(addedPhenotypeValuesScrollPane, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel2.setForeground(new java.awt.Color(255, 51, 51));
        jLabel2.setText("Phenotype Values already entered (click entries to view and edit)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        addedPhenotypeValuesPanel.add(jLabel2, gridBagConstraints);

        add(addedPhenotypeValuesPanel, java.awt.BorderLayout.NORTH);

        phenotypeValuePanel.setLayout(new java.awt.GridBagLayout());

        phenotypeValuePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Phenotype Value Details"));
        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel3.setForeground(new java.awt.Color(102, 102, 255));
        jLabel3.setText("Note: one Phenotype Value is that which is created by applying one Phenotype Method to a Sample-Panel of one or more individuals");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        phenotypeValuePanel.add(jLabel3, gridBagConstraints);

        jLabel4.setForeground(java.awt.SystemColor.textHighlight);
        jLabel4.setText("Phenotype Method That Generated the Phenotype Value");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        phenotypeValuePanel.add(jLabel4, gridBagConstraints);

        phenotypeMethodComboBox.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        phenotypeMethodComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        phenotypeValuePanel.add(phenotypeMethodComboBox, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel5.setForeground(new java.awt.Color(255, 51, 51));
        jLabel5.setText("The Phenotype Method used");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        phenotypeValuePanel.add(jLabel5, gridBagConstraints);

        jLabel8.setForeground(java.awt.SystemColor.textHighlight);
        jLabel8.setText("Phenotype Value");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        phenotypeValuePanel.add(jLabel8, gridBagConstraints);

        phenotypeValueField.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        phenotypeValuePanel.add(phenotypeValueField, gridBagConstraints);

        jLabel9.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel9.setForeground(new java.awt.Color(255, 51, 51));
        jLabel9.setText("Overall phenotype finding: a high-level statement that describes the group phenotype (e.g., \u2018blue eyes\u2019 or \u2018Diabetic\u2019 or \u2018over 2m tall\u2019 or \u2018very tall\u2019)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        phenotypeValuePanel.add(jLabel9, gridBagConstraints);

        phenotypeValueDetailPanel.setLayout(new java.awt.GridBagLayout());

        phenotypeValueDetailPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Phenotype Value \u2013 Details (optional)"));
        addedPhenotypeValueDetailsScrollPane.setPreferredSize(new java.awt.Dimension(750, 80));
        addedPhenotypeValueDetailsTable.setModel(new PhenotypeValueDetailTableModel());
        addedPhenotypeValueDetailsTable.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                addedPhenotypeValueDetailsTableKeyPressed(evt);
            }
        });

        addedPhenotypeValueDetailsScrollPane.setViewportView(addedPhenotypeValueDetailsTable);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        phenotypeValueDetailPanel.add(addedPhenotypeValueDetailsScrollPane, gridBagConstraints);

        jLabel13.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel13.setForeground(new java.awt.Color(255, 51, 51));
        jLabel13.setText("Fine-grain specification of the group phenotype (e.g., mean, median, max, min, SD, and percentile values for a distribution, or hourly measurements for a glucose tolerance test)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        phenotypeValueDetailPanel.add(jLabel13, gridBagConstraints);

        jPanel1.setLayout(new java.awt.BorderLayout());

        deletePhenotypeValueDetailButton.setText("Delete Phenotype Value Detail");
        deletePhenotypeValueDetailButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deletePhenotypeValueDetailButtonActionPerformed(evt);
            }
        });

        jPanel2.add(deletePhenotypeValueDetailButton);

        addModifyPhenotypeValueDetailButton.setText("Add/Modify Phenotype Value Detail");
        addModifyPhenotypeValueDetailButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyPhenotypeValueDetailButtonActionPerformed(evt);
            }
        });

        jPanel2.add(addModifyPhenotypeValueDetailButton);

        jPanel1.add(jPanel2, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        phenotypeValueDetailPanel.add(jPanel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        phenotypeValuePanel.add(phenotypeValueDetailPanel, gridBagConstraints);

        add(phenotypeValuePanel, java.awt.BorderLayout.CENTER);

        buttonPanel.setLayout(new java.awt.BorderLayout());

        clearButton.setText("New Phenotype Value");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        eastButtonPanel.add(clearButton);

        deleteButton.setText("Delete Phenotype Value");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        eastButtonPanel.add(deleteButton);

        addModifyButton.setText("Save Phenotype Value");
        addModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyButtonActionPerformed(evt);
            }
        });

        eastButtonPanel.add(addModifyButton);

        buttonPanel.add(eastButtonPanel, java.awt.BorderLayout.EAST);

        add(buttonPanel, java.awt.BorderLayout.SOUTH);

    }// </editor-fold>//GEN-END:initComponents

    private void addedPhenotypeValuesListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_addedPhenotypeValuesListValueChanged
        PhenotypeValue pv = (PhenotypeValue)addedPhenotypeValuesList.getSelectedValue();
        if(pv != null) {
            fillForm(pv);
        }
    }//GEN-LAST:event_addedPhenotypeValuesListValueChanged

    private void addModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyButtonActionPerformed
        PhenotypeValue pv = new PhenotypeValue();
        pv.setPhenotypeMethod("" + phenotypeMethodComboBox.getSelectedItem());
        pv.setPhenotypeValue(phenotypeValueField.getText());
        PhenotypeValueDetailTableModel model = (PhenotypeValueDetailTableModel)addedPhenotypeValueDetailsTable.getModel();
        DataArray valueDetails = model.getAllPhenotypeValueDetails();
        for(int i = 0; i < valueDetails.nrOfElements(); i++) {
            pv.addPhenotypeValueDetail((PhenotypeValueDetail)valueDetails.get(i));
        }
        if(addedPhenotypeValuesList.getSelectedValue() == null) {
            mainFrame.getCurrentStudy().addPhenotypeValue(pv);
            clearForm();
        }
        else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to update the selected phenotype value?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                PhenotypeValue selectedPhenotypeValue = (PhenotypeValue)addedPhenotypeValuesList.getSelectedValue();
                int id = selectedPhenotypeValue.getID();
                mainFrame.getCurrentStudy().updatePhenotypeValue(pv, id);
                clearForm(); 
            }
        }
    }//GEN-LAST:event_addModifyButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void addedPhenotypeValueDetailsTableKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_addedPhenotypeValueDetailsTableKeyPressed
        if(evt.getKeyCode() == java.awt.event.KeyEvent.VK_DELETE) {
            deletePhenotypeValueDetail();
        }
    }//GEN-LAST:event_addedPhenotypeValueDetailsTableKeyPressed

    private void deletePhenotypeValueDetailButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deletePhenotypeValueDetailButtonActionPerformed
        deletePhenotypeValueDetail();
    }//GEN-LAST:event_deletePhenotypeValueDetailButtonActionPerformed

    private void addModifyPhenotypeValueDetailButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyPhenotypeValueDetailButtonActionPerformed
        if(addedPhenotypeValueDetailsTable.getSelectedRow() == -1) {
            PhenotypeValueDetailFrame frame = new PhenotypeValueDetailFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY(), new PhenotypeValueDetail());
        }
        else {
            PhenotypeValueDetailTableModel model = (PhenotypeValueDetailTableModel)addedPhenotypeValueDetailsTable.getModel();
            int row = addedPhenotypeValueDetailsTable.getSelectedRow();
            PhenotypeValueDetailFrame frame = new PhenotypeValueDetailFrame(this, (int)(getLocationOnScreen()).getX(), (int)(getLocationOnScreen()).getY(), model.getPhenotypeValueDetail(row));
        }
    }//GEN-LAST:event_addModifyPhenotypeValueDetailButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        deletePhenotypeValue();
    }//GEN-LAST:event_deleteButtonActionPerformed
    
    private void setPhenotypeMethods(String[] names) {
        DefaultComboBoxModel model = (DefaultComboBoxModel)phenotypeMethodComboBox.getModel();
        model.removeAllElements();
        for(int i = 0; i < names.length; i++) {
            model.addElement(names[i]);
        }
    }
        
    private void deletePhenotypeValueDetail() {
        if(addedPhenotypeValueDetailsTable.getSelectedRow() == -1) {
            JOptionPane.showMessageDialog(this,
                "You have to select a phenotype value detial to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
        else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to delete the selected phenotype value detail?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                int row = addedPhenotypeValueDetailsTable.getSelectedRow();
                PhenotypeValueDetailTableModel model = (PhenotypeValueDetailTableModel)addedPhenotypeValueDetailsTable.getModel();
                model.deletePhenotypeValueDetail(row);
                clearForm(); 
            }
        }
    }
    
    private void deletePhenotypeValue() {
        PhenotypeValue pv = (PhenotypeValue)addedPhenotypeValuesList.getSelectedValue();
        if(pv == null) {
            JOptionPane.showMessageDialog(this,
                "You have to select a phenotype value to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the selected phenotype value from the study?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                mainFrame.getCurrentStudy().deletePhenotypeValue(pv.getID());
                clearForm();    
            }
        }
    }
    
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addModifyButton;
    private javax.swing.JButton addModifyPhenotypeValueDetailButton;
    private javax.swing.JScrollPane addedPhenotypeValueDetailsScrollPane;
    private javax.swing.JTable addedPhenotypeValueDetailsTable;
    private javax.swing.JList addedPhenotypeValuesList;
    private javax.swing.JPanel addedPhenotypeValuesPanel;
    private javax.swing.JScrollPane addedPhenotypeValuesScrollPane;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton deleteButton;
    private javax.swing.JButton deletePhenotypeValueDetailButton;
    private javax.swing.JPanel eastButtonPanel;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JComboBox phenotypeMethodComboBox;
    private javax.swing.JPanel phenotypeValueDetailPanel;
    private javax.swing.JTextField phenotypeValueField;
    private javax.swing.JPanel phenotypeValuePanel;
    // End of variables declaration//GEN-END:variables
    
}
