/*
 * PhenotypesPanel.java
 *
 * Created on den 7 december 2005, 11:33
 */

package phenobase.gui;

/**
 * This is the panel representing the second major step in the data entering process.
 * The three substeps of this step is Properties, Methods and Valuess. This, and all the
 * other panels representing the main steps are created by the <code>MainPanel</code>.
 *
 * @author  fresjo
 */
public class PhenotypesPanel extends javax.swing.JPanel {
    
    /** 
     * Creates a new instance of <code>PhenotypesPanel</code>.
     *
     * @param t     The <code>HGVbaseSubmissionTool</code> that this 
     *              <code>PhenotypesPanel</code> is a part of.
     */
    public PhenotypesPanel(HGVbaseSubmissionTool t) {
        mainFrame = t;
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jTabbedPane1 = new javax.swing.JTabbedPane();
        samplesetPanel = new PhenotypePropertyPanel(mainFrame);
        phenotypeGeneralPanel = new PhenotypeMethodPanel(mainFrame);
        phenotypeMethodPanel = new PhenotypeValuePanel(mainFrame);
        jLabel1 = new javax.swing.JLabel();

        jTabbedPane1.addTab("Step 3: Phenotype Entities", samplesetPanel);

        jTabbedPane1.addTab("Step 4: Phenotype Methods", phenotypeGeneralPanel);

        jTabbedPane1.addTab("Step 5: Phenotype Values", phenotypeMethodPanel);

        jLabel1.setFont(new java.awt.Font("Times New Roman", 1, 18));
        jLabel1.setForeground(java.awt.Color.blue);
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Boxes with a thick blue border MUST be filled in");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 454, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 444, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 261, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private HGVbaseSubmissionTool mainFrame;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JPanel phenotypeGeneralPanel;
    private javax.swing.JPanel phenotypeMethodPanel;
    private javax.swing.JPanel samplesetPanel;
    // End of variables declaration//GEN-END:variables
    
}
