/*
 * SamplesetPanel.java
 *
 * Created on den 26 oktober 2005, 14:53
 */

package phenobase.gui;

import phenobase.data.*;
import phenobase.handling.*;
import phenobase.storage.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 * @author  fresjo
 */
public class Samplepanel_GeneralInformationPanel extends javax.swing.JPanel {
    
    /** Creates new form SamplesetPanel */
    public Samplepanel_GeneralInformationPanel(SamplepanelPanel sp) {
        parent = sp; 
        initComponents();
    }
    
    public void clearForm() {
        labIDField.setText("");
        compositionComboBox.setSelectedIndex(0);
        sourceOfDNAComboBox.setSelectedIndex(0);
        dnaIsPooledComboBox.setSelectedIndex(0);
        dnaIsWGAComboBox.setSelectedIndex(0);
        nrOfIndividualsField.setText("");
        nrOfMalesField.setText("");
        nrOfFemalesField.setText("");
        nrOfParentsField.setEnabled(false);
        nrOfProbandsField.setEnabled(false);
        summaryDescriptionField.setText("");
    }
    
    public void fillForm(Samplepanel s) {
        setLabID(s.getLabID());
        setComposition(s.getComposition());
        setSourceOfDNA(s.getSourceOfDNA());
        setDNAIsPooled(s.getDnasArePooled());
        setDNAIsWGA(s.getDnasAreWGA());
        setNrOfIndividuals(s.getNrOfIndividuals());
        setNrOfMales(s.getNrOfMales());
        setNrOfFemales(s.getNrOfFemales());
        if(s.getComposition().equals("Trios")) {
            setNrOfProbands(s.getNrOfProbands());
            setNrOfParents(s.getNrOfParents());
        }
        setSummaryDescription(s.getSummaryDescription());
    }
      
    public String getLabID() {
        return labIDField.getText();
    }
    
    public void setLabID(String s) {
        labIDField.setText(s);
    }
    
    public String getComposition() {
        return (String)compositionComboBox.getSelectedItem();
    }
    
    public void setComposition(String s) {
        compositionComboBox.setSelectedItem(s);
    }
    
    public String getSourceOfDNA() {
        return (String)sourceOfDNAComboBox.getSelectedItem();
    }
    
    public void setSourceOfDNA(String s) {
        sourceOfDNAComboBox.setSelectedItem(s);
    }
    
    public String getDNAIsPooled() {
        return (String)dnaIsPooledComboBox.getSelectedItem();
    }
    
    public void setDNAIsPooled(String s) {
        dnaIsPooledComboBox.setSelectedItem(s);
    }
    
    public String getDNAIsWGA() {
        return (String)dnaIsWGAComboBox.getSelectedItem();
    }
    
    public void setDNAIsWGA(String s) {
        dnaIsWGAComboBox.setSelectedItem(s);
    }
    
    public int getNrOfIndividuals() throws FormatingException {
        int res = 0;
        try {
            if(!nrOfIndividualsField.getText().equals("")) {
                res = Integer.parseInt(nrOfIndividualsField.getText());
            }
            else {
                res = -1;
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Individuals field");
        }
        return res;
    }
    
    public void setNrOfIndividuals(int i) {
        if(i != -1) {
            nrOfIndividualsField.setText("" + i);
        }
        else {
            nrOfIndividualsField.setText("");
        }
    }
    
    public int getNrOfMales() throws FormatingException {
        int res = 0;
        try {
            if(!nrOfMalesField.getText().equals("")) {
                res = Integer.parseInt(nrOfMalesField.getText());
            }
            else {
                res = -1;
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Males field");
        }
        return res;
    }
    
    public void setNrOfMales(int i) {
        if(i != -1) {
            nrOfMalesField.setText("" + i);
        }
        else {
            nrOfMalesField.setText("");
        }
    }
    
    public int getNrOfFemales() throws FormatingException {
        int res = 0;
        try {
            if(!nrOfFemalesField.getText().equals("")) {
                res = Integer.parseInt(nrOfFemalesField.getText());
            }
            else {
                res = -1;
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Females field");
        }
        return res;
    }
    
    public void setNrOfFemales(int i) {
        if(i != -1) {
            nrOfFemalesField.setText("" + i);
        }
        else {
            nrOfFemalesField.setText("");
        }
    }
    
    public int getNrOfProbands() throws FormatingException {
        int res = 0;
        try {
            if((compositionComboBox.getSelectedItem()).equals("Trios")) {
                if(!nrOfProbandsField.getText().equals("")) {
                    res = Integer.parseInt(nrOfProbandsField.getText());
                }
                else {
                    res = -1;
                }
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Probands field");
        }
        return res;
    }
    
    public void setNrOfProbands(int i) {
        if(i != -1) {
            nrOfProbandsField.setText("" + i);
            nrOfProbandsField.setEnabled(true);
        }
        else {
            nrOfProbandsField.setText("");
        }
    }
    
    public int getNrOfParents() throws FormatingException {
        int res = 0;
        try {
            if((compositionComboBox.getSelectedItem()).equals("Trios")) {
                if(!nrOfParentsField.getText().equals("")) {
                    res =  Integer.parseInt(nrOfParentsField.getText());
                }
                else {
                    res = -1;
                }
            }
        }
        catch(NumberFormatException nfe) {
            throw new FormatingException("Invalid entry in the Nr Of Parents field");
        }
        return res;
    }
    
    public void setNrOfParents(int i) {
        if(i != -1) {
            nrOfParentsField.setEnabled(true);
            nrOfParentsField.setText("" + i);
        }
        else {
            nrOfParentsField.setText("");
        }
    }
    
    public String getSummaryDescription() {
        return summaryDescriptionField.getText();
    }
    
    public void setSummaryDescription(String s) {
        summaryDescriptionField.setText(s);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel3 = new javax.swing.JLabel();
        jLabel68 = new javax.swing.JLabel();
        labIDField = new javax.swing.JTextField();
        jLabel69 = new javax.swing.JLabel();
        jLabel70 = new javax.swing.JLabel();
        jLabel71 = new javax.swing.JLabel();
        String[] sourcesOfDNA = {"-", "Blood Sample", "Cultured cells", "Tissue biopsy", "Cheek swab", "Saliva", "Hair root", "Semen"};
        sourceOfDNAComboBox = new javax.swing.JComboBox(sourcesOfDNA);
        String[] compositions = {"-", "Undefined", "Unrelated Cases", "Unrelated Controls", "Trios"};
        compositionComboBox = new javax.swing.JComboBox(compositions);
        jLabel72 = new javax.swing.JLabel();
        jLabel73 = new javax.swing.JLabel();
        jLabel74 = new javax.swing.JLabel();
        jLabel75 = new javax.swing.JLabel();
        String[] pooling = {"-", "No", "Yes: Pre-prep", "Yes: Post-prep"};
        dnaIsPooledComboBox = new javax.swing.JComboBox(pooling);
        String[] wgas = {"-", "None of the samples", "Some of the samples", "All of the samples"};
        dnaIsWGAComboBox = new javax.swing.JComboBox(wgas);
        jLabel76 = new javax.swing.JLabel();
        jLabel77 = new javax.swing.JLabel();
        distributionPanel = new javax.swing.JPanel();
        jLabel79 = new javax.swing.JLabel();
        nrOfIndividualsField = new javax.swing.JTextField();
        jLabel80 = new javax.swing.JLabel();
        nrOfMalesField = new javax.swing.JTextField();
        jLabel81 = new javax.swing.JLabel();
        nrOfFemalesField = new javax.swing.JTextField();
        triosPanel = new javax.swing.JPanel();
        jLabel83 = new javax.swing.JLabel();
        nrOfProbandsField = new javax.swing.JTextField();
        jLabel84 = new javax.swing.JLabel();
        nrOfParentsField = new javax.swing.JTextField();
        jLabel85 = new javax.swing.JLabel();
        jLabel86 = new javax.swing.JLabel();
        navigationPanel = new javax.swing.JPanel();
        navigationButtonBanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        goToPopulationInfoButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        summaryDescriptionField = new javax.swing.JTextArea();

        jLabel3.setText("jLabel3");

        setLayout(new java.awt.GridBagLayout());

        jLabel68.setForeground(java.awt.SystemColor.textHighlight);
        jLabel68.setText("Name or ID");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel68, gridBagConstraints);

        labIDField.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        labIDField.setPreferredSize(new java.awt.Dimension(820, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(labIDField, gridBagConstraints);

        jLabel69.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel69.setForeground(new java.awt.Color(255, 51, 51));
        jLabel69.setText("Short, convenient, and unique name for the Sample-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel69, gridBagConstraints);

        jLabel70.setForeground(java.awt.SystemColor.textHighlight);
        jLabel70.setText("Composition");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel70, gridBagConstraints);

        jLabel71.setForeground(java.awt.SystemColor.textHighlight);
        jLabel71.setText("Source of DNA");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel71, gridBagConstraints);

        sourceOfDNAComboBox.setEditable(true);
        sourceOfDNAComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(sourceOfDNAComboBox, gridBagConstraints);

        compositionComboBox.setEditable(true);
        compositionComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        compositionComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compositionComboBoxActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(compositionComboBox, gridBagConstraints);

        jLabel72.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel72.setForeground(new java.awt.Color(255, 51, 51));
        jLabel72.setText("The composition of the Sample-Panel. To enter a composition not available in the list simply type it in the field");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel72, gridBagConstraints);

        jLabel73.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel73.setForeground(new java.awt.Color(255, 51, 51));
        jLabel73.setText("The source of the DNA in this Sample-Panel. To enter a source not available in the list simply type it in the field");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel73, gridBagConstraints);

        jLabel74.setForeground(java.awt.SystemColor.textHighlight);
        jLabel74.setText("DNA is whole genome amplified");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel74, gridBagConstraints);

        jLabel75.setForeground(java.awt.SystemColor.textHighlight);
        jLabel75.setText("DNA is pooled");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel75, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(dnaIsPooledComboBox, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 13;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(dnaIsWGAComboBox, gridBagConstraints);

        jLabel76.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel76.setForeground(new java.awt.Color(255, 51, 51));
        jLabel76.setText("Information about whole genome amplification");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 15;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel76, gridBagConstraints);

        jLabel77.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel77.setForeground(new java.awt.Color(255, 51, 51));
        jLabel77.setText("Information about DNA pooling");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 15;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel77, gridBagConstraints);

        distributionPanel.setLayout(new java.awt.GridBagLayout());

        distributionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Size of Sample-Panel"));
        jLabel79.setForeground(java.awt.SystemColor.textHighlight);
        jLabel79.setText("Nr of individuals:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(jLabel79, gridBagConstraints);

        nrOfIndividualsField.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(51, 51, 255), 2));
        nrOfIndividualsField.setPreferredSize(new java.awt.Dimension(170, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(nrOfIndividualsField, gridBagConstraints);

        jLabel80.setForeground(java.awt.SystemColor.textHighlight);
        jLabel80.setText("Nr of males:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(jLabel80, gridBagConstraints);

        nrOfMalesField.setPreferredSize(new java.awt.Dimension(170, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(nrOfMalesField, gridBagConstraints);

        jLabel81.setForeground(java.awt.SystemColor.textHighlight);
        jLabel81.setText("Nr of females:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(jLabel81, gridBagConstraints);

        nrOfFemalesField.setPreferredSize(new java.awt.Dimension(170, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        distributionPanel.add(nrOfFemalesField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 16;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(distributionPanel, gridBagConstraints);

        triosPanel.setLayout(new java.awt.GridBagLayout());

        triosPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Size of Trios panel (only available if \u2018Composition\u2019 is set to \u201cTrios\u201d)"));
        jLabel83.setForeground(java.awt.SystemColor.textHighlight);
        jLabel83.setText("Nr of probands:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        triosPanel.add(jLabel83, gridBagConstraints);

        nrOfProbandsField.setEnabled(false);
        nrOfProbandsField.setPreferredSize(new java.awt.Dimension(300, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        triosPanel.add(nrOfProbandsField, gridBagConstraints);

        jLabel84.setForeground(java.awt.SystemColor.textHighlight);
        jLabel84.setText("Nr of parents:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        triosPanel.add(jLabel84, gridBagConstraints);

        nrOfParentsField.setEnabled(false);
        nrOfParentsField.setPreferredSize(new java.awt.Dimension(300, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        triosPanel.add(nrOfParentsField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 18;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(triosPanel, gridBagConstraints);

        jLabel85.setForeground(java.awt.SystemColor.textHighlight);
        jLabel85.setText("Summary Description");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 20;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(jLabel85, gridBagConstraints);

        jLabel86.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel86.setForeground(new java.awt.Color(255, 51, 51));
        jLabel86.setText("Summary description of this Sample-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 24;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        add(jLabel86, gridBagConstraints);

        navigationPanel.setLayout(new java.awt.BorderLayout());

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel1.setText("Go to Overlapping Samplepanels");
        navigationButtonBanel.add(jLabel1);

        goToPopulationInfoButton.setIcon(new javax.swing.ImageIcon("C:\\hgvbasePics\\right30.gif"));
        goToPopulationInfoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                goToPopulationInfoButtonActionPerformed(evt);
            }
        });

        navigationButtonBanel.add(goToPopulationInfoButton);

        navigationPanel.add(navigationButtonBanel, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 25;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

        summaryDescriptionField.setColumns(20);
        summaryDescriptionField.setLineWrap(true);
        summaryDescriptionField.setRows(2);
        summaryDescriptionField.setWrapStyleWord(true);
        jScrollPane1.setViewportView(summaryDescriptionField);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 22;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        add(jScrollPane1, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void compositionComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compositionComboBoxActionPerformed
        if(compositionComboBox.getSelectedItem() == "Trios") {
            nrOfProbandsField.setEnabled(true);
            nrOfParentsField.setEnabled(true);
        }
        else {
            nrOfProbandsField.setEnabled(false);
            nrOfParentsField.setEnabled(false);
            nrOfProbandsField.setText("");
            nrOfParentsField.setText("");
        }
    }//GEN-LAST:event_compositionComboBoxActionPerformed

    private void goToPopulationInfoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_goToPopulationInfoButtonActionPerformed
        parent.switchPanel(SamplepanelPanel.OVERLAP);
    }//GEN-LAST:event_goToPopulationInfoButtonActionPerformed
    

    private SamplepanelPanel parent;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox compositionComboBox;
    private javax.swing.JPanel distributionPanel;
    private javax.swing.JComboBox dnaIsPooledComboBox;
    private javax.swing.JComboBox dnaIsWGAComboBox;
    private javax.swing.JButton goToPopulationInfoButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel68;
    private javax.swing.JLabel jLabel69;
    private javax.swing.JLabel jLabel70;
    private javax.swing.JLabel jLabel71;
    private javax.swing.JLabel jLabel72;
    private javax.swing.JLabel jLabel73;
    private javax.swing.JLabel jLabel74;
    private javax.swing.JLabel jLabel75;
    private javax.swing.JLabel jLabel76;
    private javax.swing.JLabel jLabel77;
    private javax.swing.JLabel jLabel79;
    private javax.swing.JLabel jLabel80;
    private javax.swing.JLabel jLabel81;
    private javax.swing.JLabel jLabel83;
    private javax.swing.JLabel jLabel84;
    private javax.swing.JLabel jLabel85;
    private javax.swing.JLabel jLabel86;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField labIDField;
    private javax.swing.JPanel navigationButtonBanel;
    private javax.swing.JPanel navigationPanel;
    private javax.swing.JTextField nrOfFemalesField;
    private javax.swing.JTextField nrOfIndividualsField;
    private javax.swing.JTextField nrOfMalesField;
    private javax.swing.JTextField nrOfParentsField;
    private javax.swing.JTextField nrOfProbandsField;
    private javax.swing.JComboBox sourceOfDNAComboBox;
    private javax.swing.JTextArea summaryDescriptionField;
    private javax.swing.JPanel triosPanel;
    // End of variables declaration//GEN-END:variables
}
