/*
 * Samplepanel_NumberWithPhenotypePanel.java
 *
 * Created on den 11 december 2006, 13:48
 */

package phenobase.gui;

import phenobase.data.*;
import javax.swing.*;

/**
 *
 * @author  fresjo
 */
public class Samplepanel_NumberWithPhenotypePanel extends javax.swing.JPanel {
    
    /** Creates new form Samplepanel_NumberWithPhenotypePanel */
    public Samplepanel_NumberWithPhenotypePanel(SamplepanelPanel p) {
        parent = p;
        initComponents();
    }
    
    public void addNumberWithPhenotype(NumberWithPhenotype np) {
        ListModel lm = numberWithPhenotypeList.getModel();
        NumberWithPhenotype[] numberWithPhenotypeArray = new NumberWithPhenotype[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            numberWithPhenotypeArray[i] = (NumberWithPhenotype)lm.getElementAt(i);
        }
        numberWithPhenotypeArray[lm.getSize()] = np;
        numberWithPhenotypeList.setListData(numberWithPhenotypeArray);
        validate();
        repaint();
    }
    
    public void setPhenotypeValues(String[] ids) {
        phenotypeValueComboBox.setModel(new javax.swing.DefaultComboBoxModel(ids));
    }
    
    public void clearEntireForm() {
        numberWithPhenotypeList.setListData(new PhenotypeValue[0]);
        clearForm();
    }
    
    public void clearForm() {
        phenotypeValueComboBox.setSelectedIndex(0);
        nrOfIndividualsField.setText("");
        numberWithPhenotypeList.clearSelection();
    }
    
    public void fillForm(Samplepanel s) {
        Object[] numberWithPhenotypes = s.getNumberWithPhenotypes();
        NumberWithPhenotype[] array = new NumberWithPhenotype[numberWithPhenotypes.length];
        for(int i = 0; i < numberWithPhenotypes.length; i++) {
            array[i] = (NumberWithPhenotype)numberWithPhenotypes[i];
        }
        numberWithPhenotypeList.setListData(array);
        validate();
        repaint();
    }
    
    public void fillForm(NumberWithPhenotype np) {
        phenotypeValueComboBox.setSelectedItem(np.getPhenotypeValue());
        nrOfIndividualsField.setText("" + np.getNrOfIndividuals());
        validate();
        repaint();
    }
    
    public NumberWithPhenotype[] getNumberWithPhenotypes() {
        ListModel lm = numberWithPhenotypeList.getModel();
        NumberWithPhenotype[] array = new NumberWithPhenotype[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            array[i] = (NumberWithPhenotype)lm.getElementAt(i);
        }
        return array;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        NumberWithPhenotypePanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        phenotypeValueScrollPane = new javax.swing.JScrollPane();
        numberWithPhenotypeList = new javax.swing.JList();
        associatePhenotypeValuePanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        phenotypeValueComboBox = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        nrOfIndividualsField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        buttonPanel = new javax.swing.JPanel();
        buttonPanelEast = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        addModifyButton = new javax.swing.JButton();
        navigationPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        leftNavigationButton = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        rightNavigationButton = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        NumberWithPhenotypePanel.setLayout(new java.awt.GridBagLayout());

        NumberWithPhenotypePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Sample-Panel Phenotype Values"));
        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel1.setForeground(new java.awt.Color(255, 51, 51));
        jLabel1.setText("Sample-Panel Phenotype Values already entered (click entries to view and edit)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        NumberWithPhenotypePanel.add(jLabel1, gridBagConstraints);

        phenotypeValueScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        numberWithPhenotypeList.setBackground(new java.awt.Color(255, 255, 204));
        numberWithPhenotypeList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                numberWithPhenotypeListValueChanged(evt);
            }
        });

        phenotypeValueScrollPane.setViewportView(numberWithPhenotypeList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        NumberWithPhenotypePanel.add(phenotypeValueScrollPane, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(NumberWithPhenotypePanel, gridBagConstraints);

        associatePhenotypeValuePanel.setLayout(new java.awt.GridBagLayout());

        associatePhenotypeValuePanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Associate Phenotype Value"));
        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        jLabel3.setForeground(new java.awt.Color(102, 102, 255));
        jLabel3.setText("Specify each of the Phenotype Values that belong to the selected Sample-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        associatePhenotypeValuePanel.add(jLabel3, gridBagConstraints);

        jLabel4.setForeground(java.awt.SystemColor.textHighlight);
        jLabel4.setText("Phenotype Value");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        associatePhenotypeValuePanel.add(jLabel4, gridBagConstraints);

        phenotypeValueComboBox.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.blue, 2));
        phenotypeValueComboBox.setPreferredSize(new java.awt.Dimension(400, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 2, 3);
        associatePhenotypeValuePanel.add(phenotypeValueComboBox, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel5.setForeground(new java.awt.Color(255, 51, 51));
        jLabel5.setText("The previously entered Phenotype Value that is relevant to (describes) the selected Sample-Panel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        associatePhenotypeValuePanel.add(jLabel5, gridBagConstraints);

        jLabel6.setForeground(java.awt.SystemColor.textHighlight);
        jLabel6.setText("Nr of Individuals");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        associatePhenotypeValuePanel.add(jLabel6, gridBagConstraints);

        nrOfIndividualsField.setPreferredSize(new java.awt.Dimension(400, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 2, 3);
        associatePhenotypeValuePanel.add(nrOfIndividualsField, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel7.setForeground(new java.awt.Color(255, 51, 51));
        jLabel7.setText("Number of persons in the Sample-Panel that this Phenotype Value is relevant to");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        associatePhenotypeValuePanel.add(jLabel7, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(associatePhenotypeValuePanel, gridBagConstraints);

        buttonPanel.setLayout(new java.awt.BorderLayout());

        clearButton.setText("New Sample-Panel Phenotype Value");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        buttonPanelEast.add(clearButton);

        deleteButton.setText("Delete Sample-Panel Phenotype Value");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        buttonPanelEast.add(deleteButton);

        addModifyButton.setText("Save Sample-Panel Phenotype Value");
        addModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyButtonActionPerformed(evt);
            }
        });

        buttonPanelEast.add(addModifyButton);

        buttonPanel.add(buttonPanelEast, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(buttonPanel, gridBagConstraints);

        navigationPanel.setLayout(new java.awt.BorderLayout());

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        leftNavigationButton.setIcon(new javax.swing.ImageIcon("C:\\hgvbasePics\\left30.gif"));
        leftNavigationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                leftNavigationButtonActionPerformed(evt);
            }
        });

        jPanel1.add(leftNavigationButton);

        jLabel8.setText("Go to Overlapping Samplepanels");
        jPanel1.add(jLabel8);

        navigationPanel.add(jPanel1, java.awt.BorderLayout.WEST);

        jLabel9.setText("Go to Population Information");
        jPanel2.add(jLabel9);

        rightNavigationButton.setIcon(new javax.swing.ImageIcon("C:\\hgvbasePics\\right30.gif"));
        rightNavigationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rightNavigationButtonActionPerformed(evt);
            }
        });

        jPanel2.add(rightNavigationButton);

        navigationPanel.add(jPanel2, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void addModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyButtonActionPerformed
        NumberWithPhenotype np = new NumberWithPhenotype();
        String value = (String)phenotypeValueComboBox.getSelectedItem();
        np.setPhenotypeValue(value);
        np.setNrOfIndividuals(Integer.parseInt(nrOfIndividualsField.getText()));
        if(numberWithPhenotypeList.getSelectedValue() == null) {
            addNumberWithPhenotype(np);
            clearForm();
        }
        else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to update the selected associated Phenotype Value?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                NumberWithPhenotype selectedPhenotype = (NumberWithPhenotype)numberWithPhenotypeList.getSelectedValue();
                selectedPhenotype.setPhenotypeValue(np.getPhenotypeValue());
                selectedPhenotype.setNrOfIndividuals(np.getNrOfIndividuals());
            }
            clearForm();
        }
    }//GEN-LAST:event_addModifyButtonActionPerformed

    private void numberWithPhenotypeListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_numberWithPhenotypeListValueChanged
        NumberWithPhenotype selectedPhenotype = (NumberWithPhenotype)numberWithPhenotypeList.getSelectedValue();
        if(selectedPhenotype != null) {
            fillForm(selectedPhenotype);
        }
        else {
            clearForm();
        }
    }//GEN-LAST:event_numberWithPhenotypeListValueChanged

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        NumberWithPhenotype np = (NumberWithPhenotype)numberWithPhenotypeList.getSelectedValue();
        if(np == null) {
            JOptionPane.showMessageDialog(this,
                "You have to select a associated Phenotype Value to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the associated Phenotype Value from the Samplepanel?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                ListModel lm = numberWithPhenotypeList.getModel();
                int removeIndex = numberWithPhenotypeList.getSelectedIndex();
                NumberWithPhenotype[] phenotypeArray = new NumberWithPhenotype[lm.getSize() - 1];
                int index = 0;
                for(int i = 0; i < lm.getSize(); i++) {
                    if(i != removeIndex) {
                        phenotypeArray[index] = (NumberWithPhenotype)lm.getElementAt(i);
                        index++;
                    }
                }
                numberWithPhenotypeList.setListData(phenotypeArray);
                validate();
                repaint();
                clearForm();
            }
        }
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void rightNavigationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rightNavigationButtonActionPerformed
        parent.switchPanel(SamplepanelPanel.POPULATION);
    }//GEN-LAST:event_rightNavigationButtonActionPerformed

    private void leftNavigationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_leftNavigationButtonActionPerformed
        parent.switchPanel(SamplepanelPanel.OVERLAP);
    }//GEN-LAST:event_leftNavigationButtonActionPerformed
    
    
    private SamplepanelPanel parent;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel NumberWithPhenotypePanel;
    private javax.swing.JButton addModifyButton;
    private javax.swing.JPanel associatePhenotypeValuePanel;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel buttonPanelEast;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton deleteButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton leftNavigationButton;
    private javax.swing.JPanel navigationPanel;
    private javax.swing.JTextField nrOfIndividualsField;
    private javax.swing.JList numberWithPhenotypeList;
    private javax.swing.JComboBox phenotypeValueComboBox;
    private javax.swing.JScrollPane phenotypeValueScrollPane;
    private javax.swing.JButton rightNavigationButton;
    // End of variables declaration//GEN-END:variables
    
}
