/*
 * SamplesetOverlapPanel.java
 *
 * Created on den 5 april 2006, 13:13
 */

package phenobase.gui;

import phenobase.data.*;
import javax.swing.*;

/**
 *
 * @author  fresjo
 */
public class Samplepanel_OverlapPanel extends javax.swing.JPanel {
    
    /** Creates new form SamplesetOverlapPanel */
    public Samplepanel_OverlapPanel(SamplepanelPanel p) {
        parent = p;
        initComponents();
    }
    
    public void setSamplepanels(String[] ids) {
        samplepanelComboBox.setModel(new javax.swing.DefaultComboBoxModel(ids));
    }
    
    public void addSamplepanelOverlap(SamplepanelOverlap so) {
        ListModel lm = samplepanelList.getModel();
        SamplepanelOverlap[] samplepanelArray = new SamplepanelOverlap[lm.getSize() + 1];
        for(int i = 0; i < lm.getSize(); i++) {
            samplepanelArray[i] = (SamplepanelOverlap)lm.getElementAt(i);
        }
        samplepanelArray[lm.getSize()] = so;
        samplepanelList.setListData(samplepanelArray);
        validate();
        repaint();
    }
    
    public void clearEntireForm() {
        samplepanelList.setListData(new SamplepanelOverlap[0]);
        clearForm();
    }
    
    public void clearForm() {
        samplepanelComboBox.setSelectedIndex(0);
        overlapDetailsField.setText("");
        samplepanelList.clearSelection();
    }
    
    public void fillForm(Samplepanel s) {
        Object[] overlaps = s.getOverlaps();
        SamplepanelOverlap[] array = new SamplepanelOverlap[overlaps.length];
        for(int i = 0; i < overlaps.length; i++) {
            array[i] = (SamplepanelOverlap)overlaps[i];
        }
        samplepanelList.setListData(array);
        validate();
        repaint();
    }
    
    public void fillForm(SamplepanelOverlap so) {
        samplepanelComboBox.setSelectedItem(so.getLabID());
        overlapDetailsField.setText(so.getOverlapDetails());
        validate();
        repaint();
    }
    
    public SamplepanelOverlap[] getSamplesetOverlaps() {
        ListModel lm = samplepanelList.getModel();
        SamplepanelOverlap[] array = new SamplepanelOverlap[lm.getSize()];
        for(int i = 0; i < lm.getSize(); i++) {
            array[i] = (SamplepanelOverlap)lm.getElementAt(i);
        }
        return array;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        navigationPanel = new javax.swing.JPanel();
        navigationPanelWest = new javax.swing.JPanel();
        leftNavigationButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        navigationPanelEast = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        rightNavigationButton = new javax.swing.JButton();
        overlappingSamplepanelsPanel = new javax.swing.JPanel();
        samplepanelScrollPane = new javax.swing.JScrollPane();
        samplepanelList = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        overlappingSamplepanelPanel = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        Object[] array = parent.getCurrentSubmission().getSamplepanelArray();
        String[] ids = new String[array.length];
        for(int i = 0; i < array.length; i++) {
            ids[i] = ((Samplepanel)array[i]).getLabID();
        }
        samplepanelComboBox = new javax.swing.JComboBox(ids);
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        overlapDetailsScrollPane = new javax.swing.JScrollPane();
        overlapDetailsField = new javax.swing.JTextArea();
        buttonPanel = new javax.swing.JPanel();
        buttons = new javax.swing.JPanel();
        clearButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        addModifyButton = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        navigationPanel.setLayout(new java.awt.BorderLayout());

        navigationPanel.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        leftNavigationButton.setIcon(new javax.swing.ImageIcon("C:\\hgvbasePics\\left30.gif"));
        leftNavigationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                leftNavigationButtonActionPerformed(evt);
            }
        });

        navigationPanelWest.add(leftNavigationButton);

        jLabel1.setText("Go to General Information");
        navigationPanelWest.add(jLabel1);

        navigationPanel.add(navigationPanelWest, java.awt.BorderLayout.WEST);

        jLabel9.setText("Go to Associated Phenotype Values");
        navigationPanelEast.add(jLabel9);

        rightNavigationButton.setIcon(new javax.swing.ImageIcon("C:\\hgvbasePics\\right30.gif"));
        rightNavigationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rightNavigationButtonActionPerformed(evt);
            }
        });

        navigationPanelEast.add(rightNavigationButton);

        navigationPanel.add(navigationPanelEast, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(navigationPanel, gridBagConstraints);

        overlappingSamplepanelsPanel.setLayout(new java.awt.GridBagLayout());

        overlappingSamplepanelsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Added Overlapping Sample-Panels"));
        samplepanelScrollPane.setPreferredSize(new java.awt.Dimension(810, 80));
        samplepanelList.setBackground(new java.awt.Color(255, 255, 204));
        samplepanelList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                samplepanelListValueChanged(evt);
            }
        });

        samplepanelScrollPane.setViewportView(samplepanelList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        overlappingSamplepanelsPanel.add(samplepanelScrollPane, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setText("Overlapping Sample-Panels already entered (click entries to view and edit)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        overlappingSamplepanelsPanel.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(overlappingSamplepanelsPanel, gridBagConstraints);

        overlappingSamplepanelPanel.setLayout(new java.awt.GridBagLayout());

        overlappingSamplepanelPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Overlapping Sample-Panel Details"));
        jLabel4.setForeground(java.awt.SystemColor.textHighlight);
        jLabel4.setText("Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        overlappingSamplepanelPanel.add(jLabel4, gridBagConstraints);

        samplepanelComboBox.setPreferredSize(new java.awt.Dimension(750, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        overlappingSamplepanelPanel.add(samplepanelComboBox, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel5.setForeground(new java.awt.Color(255, 51, 51));
        jLabel5.setText("The name of the Sample-Panel which has an overlap with the selected \u2018Added Sample-Panel\u2019");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        overlappingSamplepanelPanel.add(jLabel5, gridBagConstraints);

        jLabel6.setForeground(java.awt.SystemColor.textHighlight);
        jLabel6.setText("Overlap Details");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        overlappingSamplepanelPanel.add(jLabel6, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 9));
        jLabel7.setForeground(new java.awt.Color(255, 51, 51));
        jLabel7.setText("A description of the overlap between the two Sample-Panels");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 3, 3);
        overlappingSamplepanelPanel.add(jLabel7, gridBagConstraints);

        overlapDetailsField.setColumns(20);
        overlapDetailsField.setLineWrap(true);
        overlapDetailsField.setRows(2);
        overlapDetailsField.setWrapStyleWord(true);
        overlapDetailsScrollPane.setViewportView(overlapDetailsField);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        overlappingSamplepanelPanel.add(overlapDetailsScrollPane, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(overlappingSamplepanelPanel, gridBagConstraints);

        buttonPanel.setLayout(new java.awt.BorderLayout());

        clearButton.setText("New Overlapping Sample-Panel");
        clearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearButtonActionPerformed(evt);
            }
        });

        buttons.add(clearButton);

        deleteButton.setText("Delete Overlapping Sample-Panel");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        buttons.add(deleteButton);

        addModifyButton.setText("Save Overlapping Sample-Panel");
        addModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addModifyButtonActionPerformed(evt);
            }
        });

        buttons.add(addModifyButton);

        buttonPanel.add(buttons, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        add(buttonPanel, gridBagConstraints);

    }// </editor-fold>//GEN-END:initComponents

    private void rightNavigationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rightNavigationButtonActionPerformed
        parent.switchPanel(SamplepanelPanel.PHENOTYPE_VALUES);
    }//GEN-LAST:event_rightNavigationButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        SamplepanelOverlap so = (SamplepanelOverlap)samplepanelList.getSelectedValue();
        if(so == null) {
            JOptionPane.showMessageDialog(this,
                "You have to select a samplepanel overlap to be able to delete it.",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        } else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to permanently delete the selected samplepanel overlap from the submission?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                ListModel lm = samplepanelList.getModel();
                int removeIndex = samplepanelList.getSelectedIndex();
                SamplepanelOverlap[] overlapArray = new SamplepanelOverlap[lm.getSize() - 1];
                int index = 0;
                for(int i = 0; i < lm.getSize(); i++) {
                    if(i != removeIndex) {
                        overlapArray[index] = (SamplepanelOverlap)lm.getElementAt(i);
                        index++;
                    }
                }
                samplepanelList.setListData(overlapArray);
                validate();
                repaint();
                clearForm();
            }
        }
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
        clearForm();
    }//GEN-LAST:event_clearButtonActionPerformed

    private void samplepanelListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_samplepanelListValueChanged
        SamplepanelOverlap selectedOverlap = (SamplepanelOverlap)samplepanelList.getSelectedValue();
        if(selectedOverlap != null) {
            fillForm(selectedOverlap);
        }
        else {
            clearForm();
        }
    }//GEN-LAST:event_samplepanelListValueChanged

    private void addModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addModifyButtonActionPerformed
        SamplepanelOverlap so = new SamplepanelOverlap();
        String id = (String)samplepanelComboBox.getSelectedItem();
        so.setLabID(id);
        so.setOverlapDetails(overlapDetailsField.getText());
        if(samplepanelList.getSelectedValue() == null) {
            addSamplepanelOverlap(so);
            clearForm();
        }
        else {
            int answer = JOptionPane.showConfirmDialog(this,
                    "Do you wish to update the selected samplepanel overlap?",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE,
                    JOptionPane.YES_NO_OPTION);
            if(answer == JOptionPane.YES_OPTION) {
                SamplepanelOverlap selectedOverlap = (SamplepanelOverlap)samplepanelList.getSelectedValue();
                selectedOverlap.setLabID(so.getLabID());
                selectedOverlap.setOverlapDetails(so.getOverlapDetails());
            }
            clearForm();
        }
    }//GEN-LAST:event_addModifyButtonActionPerformed

    private void leftNavigationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_leftNavigationButtonActionPerformed
        parent.switchPanel(SamplepanelPanel.GENERAL);
    }//GEN-LAST:event_leftNavigationButtonActionPerformed
    
    private SamplepanelPanel parent;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addModifyButton;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel buttons;
    private javax.swing.JButton clearButton;
    private javax.swing.JButton deleteButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JButton leftNavigationButton;
    private javax.swing.JPanel navigationPanel;
    private javax.swing.JPanel navigationPanelEast;
    private javax.swing.JPanel navigationPanelWest;
    private javax.swing.JTextArea overlapDetailsField;
    private javax.swing.JScrollPane overlapDetailsScrollPane;
    private javax.swing.JPanel overlappingSamplepanelPanel;
    private javax.swing.JPanel overlappingSamplepanelsPanel;
    private javax.swing.JButton rightNavigationButton;
    private javax.swing.JComboBox samplepanelComboBox;
    private javax.swing.JList samplepanelList;
    private javax.swing.JScrollPane samplepanelScrollPane;
    // End of variables declaration//GEN-END:variables
    
}
