/*
 * AlleleTableModel.java
 *
 * Created on den 13 juli 2006, 13:48
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.handling;

import phenobase.storage.*;
import phenobase.data.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author fresjo
 */
public class AlleleTableModel extends AbstractTableModel {
    
    /** Creates a new instance of AlleleTableModel */
    public AlleleTableModel() {
        data = new DataArray();
    }
    
    public AlleleTableModel(DataArray d) {
        data = d;
    }
    
    public int getColumnCount() {
        return columnNames.length;
    }

    public int getRowCount() {
        return data.nrOfElements();
    }

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        Allele a = (Allele)data.get(row);
        if(col == 0) {
            return a.getAlleleID();
        }
        else if(col == 1) {
            return a.getUpstream30bp();
        }
        else if(col == 2) {
            return a.getAlleleSequence();
        }
        else if(col == 3) {
            return a.getDownstream30bp();
        }
        return null;
    }
    
    public void addAllele(Allele a) {
        data.add(a);
        fireTableDataChanged();
    }
    
    public void setAlleles(Object[] alleles) {
        data = new DataArray();
        for(int i = 0; i < alleles.length; i++) {
            data.add(alleles[i]);
        }
        fireTableDataChanged();
    }
    
    public void removeAllAlleles() {
        data = new DataArray();
        fireTableDataChanged();
    }
    
    public DataArray getAllAlleles() {
        return data;
    }
    
    public Allele getAllele(int row) {
        Allele res = new Allele();
        res = (Allele)data.get(row);
        return res;
    }
    
    public void deleteAllele(int row) {
        try {
            data.remove(row);
            fireTableDataChanged();
        }
        catch(StorageException se) {
            System.err.println("Trying to remove a allele that dosen't exist");
        }
    }

    public Class getColumnClass(int c) {
        return new String().getClass();
    }
    
    private String[] columnNames = {"AlleleID", "Upstream sequence", "Allele", "Downstream sequence"};
    private DataArray data;    
}
