/*
 * DatabaseAdapter.java
 *
 * Created on den 10 maj 2006, 11:52
 */

package phenobase.handling;

import java.sql.*;
import javax.sql.*;
import phenobase.data.*;

/**
 *
 * @author fresjo
 */
public class DatabaseAdapter {
    
    
    private Connection con;
    
    /** Creates a new instance of DatabaseAdapter */
    public DatabaseAdapter() {
    }
    
    public void connect() {
        try {
            Class.forName("com.mysql.jdbc.Driver").newInstance();
            con = DriverManager.getConnection("jdbc:mysql://aatt.cgb.ki.se/HGVbaseG2P", "submitter", "submitter");
        }
        catch(IllegalAccessException iae) {
            System.err.println("IllegalAccessException: " + iae.getMessage());
        }
        catch(ClassNotFoundException cnfe) {
            System.err.println("ClassNotFoundException: " + cnfe.getMessage());
        }
        catch(InstantiationException ie) {
            System.err.println("InstantiationException: " + ie.getMessage());
        }
        catch(SQLException sqle) {
            System.err.println("SQLException: " + sqle.getMessage());
        }
    }
    
    public Marker getMarker(String rsID) throws MarkerException {
        Marker res = new Marker();
        res.setRsID(rsID);
        String query = "";
        int autoMarkerID = 0;
        try {
            Statement stm = con.createStatement();
            stm = con.createStatement();
            query = "select * from Marker_tmp where dbSNPrsID = '" + rsID + "'";
            ResultSet rs = stm.executeQuery(query);
            rs.next();
            autoMarkerID = rs.getInt("AutoMarkerID");
            res.setMarkerID(rs.getString("MarkerID"));
            int validationCode = rs.getInt("ValidationCode");
            query = "select Definition from dbSNPValidationCode where ValidationCode = " + validationCode;
            rs = stm.executeQuery(query);
            rs.next();
            res.setValidation(rs.getString("Definition"));
        }
        catch(SQLException sqle) {
            throw new MarkerException(rsID +  " not found in database");
        }
        try {
            Statement stm = con.createStatement();
            query = "select * from Allele_tmp where AutoMarkerID = " + autoMarkerID;
            ResultSet rs = stm.executeQuery(query);
            while(rs.next()) {
                Allele a = new Allele();
                a.setAlleleID(rs.getString("AlleleID"));
                a.setUpstream30bp(rs.getString("Upstream30bp"));
                a.setDownstream30bp(rs.getString("Downstream30bp"));
                a.setSequenceType(rs.getString("SeqType"));
                if(rs.getString("SeqType").equals("G")) {
                    res.setSequenceType("Genomic");
                }
                else {
                    res.setSequenceType("cDNA");
                }
                a.setAlleleSequence(rs.getString("AlleleSeq"));
                res.addAllele(a);
            }
            stm.close();
        }
        catch(SQLException sqle) {
            throw new MarkerException("No alleles found for " + rsID);
        }
        catch(InputDataException ide) {
            throw new MarkerException("There was a problem with the format of the allele data added");
        }
        return res;
    }
    
    public void disconnect() {
        try {
            con.close();
        }
        catch(SQLException sqle) {
            System.err.println("SQLException: " + sqle.getMessage());
        }
    }
    
}
