/*
 * FrequencyTableModel.java
 *
 * Created on den 18 juli 2006, 13:46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.handling;

import phenobase.storage.*;
import phenobase.data.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author fresjo
 */
public class FrequencyTableModel extends AbstractTableModel {
    
    String[] columnNames = {"Study Group Subset", "Marker", "Assay", "Allele", "Frequency"};
    DataArray data;
    
    /** Creates a new instance of FrequencyTableModel */
    public FrequencyTableModel() {
        data = new DataArray();
    }
    
    public FrequencyTableModel(DataArray d) {
        data = d;
    }
    
    public int getColumnCount() {
        return columnNames.length;
    }

    public int getRowCount() {
        return data.nrOfElements();
    }

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        PhenotypeValueDetail v = (PhenotypeValueDetail)data.get(row);
        if(col == 0) {
            return v.getAttribute();
        }
        else if(col == 1) {
            return v.getQualifier();
        }
        else if(col == 2) {
            return v.getPhenotypeValueDetail();
        }
        else if(col == 3) {
            return v.getUnitOfMeasurement();
        }
        return null;
    }
    
    public void addValue(PhenotypeValueDetail v) {
        data.add(v);
        fireTableDataChanged();
    }
    
    public void setValues(Object[] values) {
        data = new DataArray();
        for(int i = 0; i < values.length; i++) {
            data.add(values[i]);
        }
        fireTableDataChanged();
    }
    
    public void replaceValue(PhenotypeValueDetail v, int row) {
        try {
            data.replace(v, row);
            fireTableDataChanged();
        }
        catch(StorageException se) {
            System.err.println("Trying to replace value that doesn't exist");
        }
    }
    
    public void removeAllValues() {
        data = new DataArray();
        fireTableDataChanged();
    }
    
    public DataArray getAllValues() {
        return data;
    }
    
    public PhenotypeValueDetail getValue(int row) {
        PhenotypeValueDetail res = new PhenotypeValueDetail();
        res = (PhenotypeValueDetail)data.get(row);
        return res;
    }
    
    public void deleteValue(int row) {
        try {
            data.remove(row);
            fireTableDataChanged();
        }
        catch(StorageException se) {
            System.err.println("Trying to remove a value that dosen't exist");
        }
    }

    public Class getColumnClass(int c) {
        return new String().getClass();
    }
    
}
