/*
 * GenotypeDetailTableModel.java
 *
 * Created on den 22 december 2006, 11:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.handling;

import javax.swing.*;
import javax.swing.table.*;
import phenobase.storage.*;
import phenobase.data.*;
import phenobase.gui.*;

/**
 *
 * @author fresjo
 */
public class GenotypeDetailTableModel extends AbstractTableModel {
    
    /** Creates a new instance of GenotypeDetailTableModel */
    public GenotypeDetailTableModel(GenotypeFrequencyClusterPanel p) {
        data = new DataArray();
        parent = p;
    }
    
    public GenotypeDetailTableModel(DataArray d, GenotypeFrequencyClusterPanel p) {
        data = d;
        parent = p;
    }
    
    public int getColumnCount() {
        return columnNames.length;
    }

    public int getRowCount() {
        return data.nrOfElements();
    }

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        AlleleData ad = (AlleleData)data.get(row);
        if(col == 0) {
            return ad.getAllele();
        }
        else if(col == 1) {
            if(ad.getRatio() == 0) {
                return "-";
            }
            else {
                return ad.getRatio();
            }
        }
        else if(col == 2) {
            if(ad.getCount() == 0) {
                return "-";
            }
            else {
                return ad.getCount();
            }
        }
        return null;
    }
    
    public boolean isCellEditable(int row, int col) {
        if(parent.getGenotypeType().equals("Ratio")) {
            if(col == 1) {
                return true;
            }
            else return false;
        }
        else if(parent.getGenotypeType().equals("Count")) {
            if(col == 2) {
                return true;
            }
            else return false;
        }
        else return false;
    }
    
    public void setValueAt(Object value, int row, int col) {
        try {
            AlleleData ad = (AlleleData)data.get(row);
            if(col == 1) {
                if(((String)value).equals("-")) {
                    ad.setRatio(0);
                }
                else {
                    int i = Integer.parseInt((String)value);
                    ad.setRatio(i);
                }
            }
            else if(col == 2) {
                if(((String)value).equals("-")) {
                    ad.setCount(0);
                }
                else {
                    float f = Float.parseFloat((String)value);
                    ad.setCount(f);
                }
            }
            fireTableCellUpdated(row, col);
        }
        catch(NumberFormatException e) {
            JOptionPane.showMessageDialog(parent,
                "The value you tried to enter is not in the right format",
                "Error",
                JOptionPane.ERROR_MESSAGE);
        }
    }

    public void addAlleleData(AlleleData ad) {
        data.add(ad);
        fireTableDataChanged();
    }
    
    public void setAlleleDatas(Object[] array) {
        data = new DataArray();
        for(int i = 0; i < array.length; i++) {
            data.add(array[i]);
        }
        fireTableDataChanged();
    }
    
    public void removeAllAlleleDatas() {
        data = new DataArray();
        fireTableDataChanged();
    }
    
    public DataArray getAllAlleleData() {
        return data;
    }
    
    public Class getColumnClass(int c) {
        return new String().getClass();
    }
    
    private GenotypeFrequencyClusterPanel parent;
    private String[] columnNames = {"Allele", "Ratio", "Count"};
    private DataArray data;    
    
    
}
