/*
 * GenotypeFrequencyTableModel.java
 *
 * Created on den 18 december 2006, 17:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.handling;

import phenobase.storage.*;
import phenobase.data.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author fresjo
 */
public class GenotypeFrequencyTableModel extends AbstractTableModel {
    
    
    
    /** Creates a new instance of GenotypeFrequencyTableModel */
    public GenotypeFrequencyTableModel() {
        data = new DataArray();
    }
    
    public GenotypeFrequencyTableModel(DataArray d) {
        data = d;
    }
    
    public int getColumnCount() {
        return columnNames.length;
    }

    public int getRowCount() {
        return data.nrOfElements();
    }

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        GenotypeFrequency gf = (GenotypeFrequency)data.get(row);
        if(col == 0) {
            return gf.getGenotypeCombo();
        }
        else if(col == 1) {
            return gf.getFrequency();
        }
        else if(col == 2) {
            return gf.getNrSamples();
        }
        return null;
    }
    
    public void addGenotypeFrequency(GenotypeFrequency gf) {
        data.add(gf);
        fireTableDataChanged();
    }
    
    public void updateGenotypeFrequency(int row, GenotypeFrequency gf) {
        try {
            data.replace(gf, row);
        }
        catch(StorageException se) {
            
        }
    }
    
    public void setGenotypeFrequencies(Object[] genotypeFrequencies) {
        data = new DataArray();
        for(int i = 0; i < genotypeFrequencies.length; i++) {
            data.add(genotypeFrequencies[i]);
        }
        fireTableDataChanged();
    }
    
    public void removeAllGenotypeFrequencies() {
        data = new DataArray();
        fireTableDataChanged();
    }
    
    public DataArray getAllGenotypeFrequencies() {
        return data;
    }
    
    public GenotypeFrequency getGenotypeFrequency(int row) {
        GenotypeFrequency res = new GenotypeFrequency();
        res = (GenotypeFrequency)data.get(row);
        return res;
    }
    
    public void deleteGenotypeFrequency(int row) {
        try {
            data.remove(row);
            fireTableDataChanged();
        }
        catch(StorageException se) {
            System.err.println("Trying to remove a Genotype Frequency that dosen't exist");
        }
    }

    public Class getColumnClass(int c) {
        return new String().getClass();
    }
    
    private String[] columnNames = {"Genotype Combo", "Frequency", "Number Samples with Genotype"};
    private DataArray data;    
    
}
