/*
 * AssaysetTableModel.java
 *
 * Created on den 10 november 2005, 14:43
 */

package phenobase.handling;

import phenobase.storage.*;
import phenobase.data.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author fresjo
 */
public class PhenotypeValueDetailTableModel extends AbstractTableModel {
    
    String[] columnNames = {"Detail", "Value", "Unit", "Qualifier"};
    DataArray data;
    
    /** Creates a new instance of AssaysetTableModel */
    public PhenotypeValueDetailTableModel() {
        data = new DataArray();
    }
    
    public PhenotypeValueDetailTableModel(DataArray d) {
        data = d;
    }
    
    public int getColumnCount() {
        return columnNames.length;
    }

    public int getRowCount() {
        return data.nrOfElements();
    }

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        PhenotypeValueDetail v = (PhenotypeValueDetail)data.get(row);
        if(col == 0) {
            return v.getAttribute();
        }
        else if(col == 1) {
            return v.getPhenotypeValueDetail();
        }
        else if(col == 2) {
            return v.getUnitOfMeasurement();
        }
        else if(col == 3) {
            return v.getQualifier();
        }
        return null;
    }
    
    public void addPhenotypeValueDetail(PhenotypeValueDetail v) {
        data.add(v);
        fireTableDataChanged();
    }
    
    public void setPhenotypeValueDetails(Object[] values) {
        data = new DataArray();
        for(int i = 0; i < values.length; i++) {
            data.add(values[i]);
        }
        fireTableDataChanged();
    }
    
    public void replacePhenotypeValueDetail(PhenotypeValueDetail v, int row) {
        try {
            data.replace(v, row);
            fireTableDataChanged();
        }
        catch(StorageException se) {
            System.err.println("Trying to replace value that doesn't exist");
        }
    }
    
    public void removeAllPhenotypeValueDetails() {
        data = new DataArray();
        fireTableDataChanged();
    }
    
    public DataArray getAllPhenotypeValueDetails() {
        return data;
    }
    
    public PhenotypeValueDetail getPhenotypeValueDetail(int row) {
        PhenotypeValueDetail res = new PhenotypeValueDetail();
        res = (PhenotypeValueDetail)data.get(row);
        return res;
    }
    
    public void deletePhenotypeValueDetail(int row) {
        try {
            data.remove(row);
            fireTableDataChanged();
        }
        catch(StorageException se) {
            System.err.println("Trying to remove a value that dosen't exist");
        }
    }

    public Class getColumnClass(int c) {
        return new String().getClass();
    }
}
