/*
 * PubMedAdapter.java
 *
 * Created on den 6 juli 2006, 17:59
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.handling;

import phenobase.data.*;
import java.net.*;
import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import phenobase.data.pubmed.*;
import phenobase.storage.*;


/**
 *
 * @author fresjo
 */
public class PubMedAdapter {
    
    /** Creates a new instance of PubMedAdapter */
    public PubMedAdapter() {
    }
    
    public Citation getCitation(int pubMedID) {
        Citation res = new Citation();
        res.setPubMedID(pubMedID);
        try {
            String address = "http://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?db=pubmed&id=" + pubMedID + "&retmode=xml";
            URL url = new URL(address);
            URLConnection urlC = url.openConnection();
            InputStream is = url.openStream();
            BufferedReader reader = new BufferedReader(new InputStreamReader(is));
            StudyDOMParser parser = new StudyDOMParser();
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            Document doc = builder.parse(is);
            PubMedCitation cit = parser.unmarshallPubmedCitaion(doc.getDocumentElement());
            res.setMeshTerms(cit.getMeshTerms());
            DataArray a = cit.getMeshTerms();
            PubMedArticle article = cit.getArticle();
            res.setAuthors(article.getAuthors());
            res.setTitle(article.getTitle());
            PubMedJournal journal = article.getJournal();
            PubMedIssue issue = journal.getIssue();
            PubMedDate date = issue.getDate();
            String dateString;
            if(date.getMedlineDate().equals("")) {
                dateString = date.getYear() + " " + date.getMonth() + " " + date.getDay();
            }
            else {
                dateString = date.getMedlineDate();
            }
            String citationDetail = journal.getAbbreviation() + " " + dateString + ";" + issue.getVolume() + "(" + issue.getIssue() + ")";
            res.setCitationDetail(citationDetail);
        }
        catch(NullPointerException npe) {
            res = new Citation();
        }
        catch(XMLException xmle) {
            System.err.println("XMLException: " + xmle.getMessage());
        }
        catch(MalformedURLException urle) {
            System.err.println("MalformedURLException: " + urle.getMessage());
        }
        catch(IOException ioe) {
            System.err.println("IOException: " + ioe.getMessage());
        }
        catch(ParserConfigurationException pce) {
            System.err.println("ParserConfigurationException: " + pce.getMessage());
        }
        catch(SAXException saxe) {
            System.err.println("SAXException: " + saxe.getMessage());
        }
        return res;
    }
}
