/*
 * RegularExpressionHandler.java
 *
 * Created on den 6 oktober 2006, 14:05
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package phenobase.handling;

import java.util.*;
import java.util.regex.*;

/**
 *
 * @author fresjo
 */
public class RegularExpressionHandler {
    
    /** Creates a new instance of RegularExpressionHandler */
    public RegularExpressionHandler() {
    }
    
    public boolean verify(String input, String pattern) {
        Pattern p = Pattern.compile(pattern);
        Matcher m = p.matcher(input);
        return m.matches();
    }
    
    public boolean isMarkerID(String s) {
        return verify(s, "^(SNP|IND|STR|GEN|MXD|MNP)\\d{9}$");
    }
    
    public boolean isAlleleID(String s) {
        StringTokenizer strTok = new StringTokenizer(s, ".");
        if(strTok.countTokens() != 2) {
            return false;
        }
        return (isMarkerID(strTok.nextToken()) && verify(strTok.nextToken(), "^\\d{3}$"));
    }
    
}
