/*
 * XMLFileHandler.java
 *
 * Created on den 25 november 2005, 11:35
 */

package phenobase.handling;

import phenobase.data.*;

import java.io.*;
import java.util.*;

/**
 *
 * @author fresjo
 */
public class XMLFileHandler implements Observer {
    
    /** Creates a new instance of XMLFileHandler */
    public XMLFileHandler() {
        isSaved = true;
    }
    
    public static String getRandomName() {
        Random rndGenerator = new Random();
        int rndNr;
        String rndName = "";
        for(int i = 0; i < 10; i++) {
            rndNr = rndGenerator.nextInt(62);
            if(rndNr < 10) { //Numbers
                rndNr = rndNr + 48;
            }
            else if(rndNr < 36) { //Big letters
                rndNr = rndNr + 55;
            }
            else { //Small letters
                rndNr = rndNr + 61;
            }
            char c = (char)rndNr;
            rndName = rndName + c;
        }
        return rndName;
    }
    
    public void update(Observable o, Object arg) {
        isSaved = false;
    }

    public void saveFile() {
        isSaved = true;
    }
    
    public boolean isSaved() {
        return isSaved;
    }
    
    public void writeToFile(File xmlFile, Study currentSubmission) throws FileNotFoundException, IOException{
        try {
            String path = xmlFile.getAbsolutePath();
            xmlFile.delete();
            xmlFile = new File(path);
            PrintStream ps = new PrintStream(xmlFile);
            printHeader(ps);
            currentSubmission.writeXML(ps, 0);
        }
        catch(FileNotFoundException fnfe) {
            throw fnfe;
        }
        catch(IOException ioe) {
            throw ioe;
        }
    }
    
    private void printHeader(PrintStream ps) {
        ps.println("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\" ?>");
    }
    
    private boolean isSaved;
    
}
