create table HGVmart_test.TEMP0 as select a.StudyID,a.Conclusions,a.Background,a.TimeCreated,a.ResearcherID,a.Title,a.Objectives,a.KeyResults,a.Abstract,a.AutoStudyID as AutoStudyID_key from test999_rcf8.Study as a;
create index I_0 on HGVmart_test.TEMP0(AutoStudyID_key);
create table HGVmart_test.TEMP1 as select a.*,b.CrossrefID,b.StudyCrossrefID from HGVmart_test.TEMP0 as a left join test999_rcf8.StudyCrossref as b on a.AutoStudyID_key=b.AutoStudyID;
drop table HGVmart_test.TEMP0;
create index I_1 on HGVmart_test.TEMP1(AutoStudyID_key);
create table HGVmart_test.TEMP2 as select a.*,b.Type,b.Outcome,b.Objective,b.HotlinkID,b.AutoPhenotypeMethodID,b.TotalMarkersTested,b.Title as Title_Experiment,b.IndividualDataStatement,b.ExperimentID as ExperimentID_key from HGVmart_test.TEMP1 as a left join test999_rcf8.Experiment as b on a.AutoStudyID_key=b.AutoStudyID;
drop table HGVmart_test.TEMP1;
create index I_2 on HGVmart_test.TEMP2(CrossrefID);
create table HGVmart_test.TEMP3 as select a.*,b.UrlID,b.HotlinkID as HotlinkID_Crossref from HGVmart_test.TEMP2 as a left join test999_rcf8.Crossref as b on a.CrossrefID=b.CrossrefID;
drop table HGVmart_test.TEMP2;
create index I_3 on HGVmart_test.TEMP3(HotlinkID);
create table HGVmart_test.TEMP4 as select a.*,b.UrlPrefix,b.UrlSuffix,b.HotlinkLabel from HGVmart_test.TEMP3 as a left join test999_rcf8.Hotlink as b on a.HotlinkID=b.HotlinkID;
drop table HGVmart_test.TEMP3;
create index I_4 on HGVmart_test.TEMP4(HotlinkID_Crossref);
create table HGVmart_test.TEMP5 as select a.*,b.UrlPrefix as UrlPrefix_Hotlink,b.UrlSuffix as UrlSuffix_Hotlink,b.HotlinkLabel as HotlinkLabel_Hotlink from HGVmart_test.TEMP4 as a left join test999_rcf8.Hotlink as b on a.HotlinkID_Crossref=b.HotlinkID;
drop table HGVmart_test.TEMP4;
create table HGVmart_test.TEMP6 as select Type,Outcome,UrlPrefix_Hotlink,AutoStudyID_key,TotalMarkersTested,Abstract,HotlinkLabel,UrlPrefix,HotlinkID_Crossref,Conclusions,AutoPhenotypeMethodID,KeyResults,ExperimentID_key,StudyCrossrefID,CrossrefID,Objective,HotlinkID,TimeCreated,Background,ResearcherID,HotlinkLabel_Hotlink,UrlID,StudyID,UrlSuffix_Hotlink,UrlSuffix,Title_Experiment,Title,Objectives,IndividualDataStatement,MONTH(TimeCreated) as TimeCreated_month,YEAR(TimeCreated) as TimeCreated_year from HGVmart_test.TEMP5;
drop table HGVmart_test.TEMP5;
create index I_5 on HGVmart_test.TEMP6(AutoStudyID_key);
create index I_6 on HGVmart_test.TEMP6(ExperimentID_key);
create index I_7 on HGVmart_test.TEMP6(StudyID);
rename table HGVmart_test.TEMP6 to HGVmart_test.study__Study__main;
create index I_8 on HGVmart_test.study__Study__main(AutoStudyID_key);
create table HGVmart_test.TEMP7 as select a.AutoStudyID_key from HGVmart_test.study__Study__main as a;
create index I_9 on HGVmart_test.TEMP7(AutoStudyID_key);
create table HGVmart_test.TEMP8 as select a.*,b.StudyCitationID,b.CitationID from HGVmart_test.TEMP7 as a left join test999_rcf8.StudyCitation as b on a.AutoStudyID_key=b.AutoStudyID;
drop table HGVmart_test.TEMP7;
create index I_10 on HGVmart_test.TEMP8(CitationID);
create table HGVmart_test.TEMP9 as select a.*,b.MeshTerms,b.Authors,b.Title,b.PubmedID,b.Detail from HGVmart_test.TEMP8 as a left join test999_rcf8.Citation as b on a.CitationID=b.CitationID;
drop table HGVmart_test.TEMP8;
rename table HGVmart_test.TEMP9 to HGVmart_test.study__StudyCitation__dm;
create index I_11 on HGVmart_test.study__StudyCitation__dm(AutoStudyID_key);
alter table HGVmart_test.study__Study__main add column (StudyCitation_count integer default 0);
update HGVmart_test.study__Study__main a set StudyCitation_count=(select count(1) from HGVmart_test.study__StudyCitation__dm b where a.AutoStudyID_key=b.AutoStudyID_key and not (b.MeshTerms is null and b.Authors is null and b.Title is null and b.StudyCitationID is null and b.PubmedID is null and b.Detail is null and b.CitationID is null));
create table HGVmart_test.TEMP10 as select a.AutoStudyID_key from HGVmart_test.study__Study__main as a;
create index I_12 on HGVmart_test.TEMP10(AutoStudyID_key);
create table HGVmart_test.TEMP11 as select a.*,b.Type,b.Objective,b.Outcome,b.HotlinkID,b.TotalMarkersTested,b.FrequencySummary,b.ExperimentID,b.ExperimentSignificanceSummary,b.SignificanceSummary,b.Comments,b.AutoPhenotypeMethodID,b.Title,b.IndividualDataStatement from HGVmart_test.TEMP10 as a left join test999_rcf8.Experiment as b on a.AutoStudyID_key=b.AutoStudyID;
drop table HGVmart_test.TEMP10;
create index I_13 on HGVmart_test.TEMP11(HotlinkID);
create table HGVmart_test.TEMP12 as select a.*,b.UrlPrefix,b.UrlSuffix,b.HotlinkLabel from HGVmart_test.TEMP11 as a left join test999_rcf8.Hotlink as b on a.HotlinkID=b.HotlinkID;
drop table HGVmart_test.TEMP11;
rename table HGVmart_test.TEMP12 to HGVmart_test.study__Experiment__dm;
create index I_14 on HGVmart_test.study__Experiment__dm(AutoStudyID_key);
alter table HGVmart_test.study__Study__main add column (Experiment_count integer default 0);
update HGVmart_test.study__Study__main a set Experiment_count=(select count(1) from HGVmart_test.study__Experiment__dm b where a.AutoStudyID_key=b.AutoStudyID_key and not (b.Type is null and b.Objective is null and b.Outcome is null and b.HotlinkID is null and b.TotalMarkersTested is null and b.FrequencySummary is null and b.HotlinkLabel is null and b.ExperimentID is null and b.UrlPrefix is null and b.ExperimentSignificanceSummary is null and b.UrlSuffix is null and b.SignificanceSummary is null and b.Comments is null and b.AutoPhenotypeMethodID is null and b.Title is null and b.IndividualDataStatement is null));
create table HGVmart_test.TEMP13 as select a.AutoStudyID_key from HGVmart_test.study__Study__main as a;
create index I_15 on HGVmart_test.TEMP13(AutoStudyID_key);
create table HGVmart_test.TEMP14 as select a.*,b.ResearcherID,b.AuthorID from HGVmart_test.TEMP13 as a left join test999_rcf8.Author as b on a.AutoStudyID_key=b.AutoStudyID;
drop table HGVmart_test.TEMP13;
create index I_16 on HGVmart_test.TEMP14(ResearcherID);
create table HGVmart_test.TEMP15 as select a.*,b.SubmitterHandle,b.Email,b.Fax,b.FullName,b.ShortName,b.Institution,b.Address,b.Department,b.WWW,b.Phone from HGVmart_test.TEMP14 as a left join test999_rcf8.Researcher as b on a.ResearcherID=b.ResearcherID;
drop table HGVmart_test.TEMP14;
rename table HGVmart_test.TEMP15 to HGVmart_test.study__Author__dm;
create index I_17 on HGVmart_test.study__Author__dm(AutoStudyID_key);
alter table HGVmart_test.study__Study__main add column (Author_count integer default 0);
update HGVmart_test.study__Study__main a set Author_count=(select count(1) from HGVmart_test.study__Author__dm b where a.AutoStudyID_key=b.AutoStudyID_key and not (b.FullName is null and b.ResearcherID is null and b.Phone is null and b.SubmitterHandle is null and b.Email is null and b.Fax is null and b.ShortName is null and b.Institution is null and b.Address is null and b.AuthorID is null and b.Department is null and b.WWW is null));
