drop table if exists HGVmart_test.study__AlleleAssociation__dm;

create table HGVmart_test.TEMP0 as select a.AutoPhenotypeMethodID,a.ExperimentID as ExperimentID_key,a.AutoStudyID from test999_rcf8.Experiment as a;
create index I_0 on TEMP0(AutoPhenotypeMethodID);
create index I_1 on TEMP0(ExperimentID_key);
create index I_2 on TEMP0(AutoStudyID);

create table HGVmart_test.TEMP1 as select a.*, b.MethodName as Phenotype
from TEMP0 as a inner join test999_rcf8.PhenotypeMethod as b using(AutoPhenotypeMethodID);
drop table HGVmart_test.TEMP0;

create table HGVmart_test.TEMP2 as select a.*,b.StudyID 
from TEMP1 as a inner join test999_rcf8.Study as b on a.AutoStudyID=b.AutoStudyID and (StudyID='<replace_id>');
drop table HGVmart_test.TEMP1;

create table HGVmart_test.TEMP3 as select a.*, b.AssayedpanelCollectionID
from TEMP2 as a join test999_rcf8.AssayedpanelCollection as b on a.ExperimentID_key = b.ExperimentID;
drop table HGVmart_test.TEMP2;
create index I_3 on TEMP3(AssayedpanelCollectionID);

create table HGVmart_test.TEMP4 as select a.*, b.UnadjustedPValue, b.AnalysisMethodID, b.SignificanceID as SignificanceID_key 
from TEMP3 as a join test999_rcf8.Significance as b using(AssayedpanelCollectionID);
drop table HGVmart_test.TEMP3;
create index I_4 on TEMP4(AnalysisMethodID);
create index I_5 on TEMP5(SignificanceID_key);

create table HGVmart_test.TEMP5 as select a.*, b.AssayedpanelID
from TEMP4 as a join test999_rcf8.APAPC as b using(AssayedpanelCollectionID);
drop table HGVmart_test.TEMP4;
create index I_6 on TEMP6(AssayedpanelID);

create table HGVmart_test.TEMP6 as select a.*, b.LocalID as LocalID_Assayedpanel
from TEMP5 as a join test999_rcf8.Assayedpanel as b using(AssayedpanelID);
drop table HGVmart_test.TEMP5;

create table HGVmart_test.TEMP7 as select a.*, b.AlleleFrequencyClusterID
from TEMP6 as a inner join test999_rcf8.AFCS as b on a.SignificanceID_key = b.SignificanceID;
drop table HGVmart_test.TEMP6;
create index I_7 on TEMP7(AlleleFrequencyClusterID);

create table HGVmart_test.TEMP8 as select a.*, b.NumberOfGenotypedSamples
from TEMP7 as a inner join test999_rcf8.AlleleFrequencyCluster as b on a.AssayedpanelID=b.AssayedpanelID and a.AlleleFrequencyClusterID=b.AlleleFrequencyClusterID;
drop table HGVmart_test.TEMP7;

create table HGVmart_test.TEMP9 as select a.*, b.MethodName as AnalysisMethod
from TEMP8 as a left join test999_rcf8.AnalysisMethod as b using (AnalysisMethodID);
drop table HGVmart_test.TEMP8;

create table HGVmart_test.TEMP10 as select a.*, b.FrequencyAsProportion, b.AlleleFrequencyID
from TEMP9 as a left join test999_rcf8.AlleleFrequency as b using(AlleleFrequencyClusterID);
drop table HGVmart_test.TEMP9;
create index I_8 on TEMP10(AlleleFrequencyID);

create table HGVmart_test.TEMP11 as select a.*, b.AutoAlleleID
from TEMP10 as a left join test999_rcf8.AlleleCombo as b using(AlleleFrequencyID);
drop table HGVmart_test.TEMP10;
create index I_9 on TEMP11(AutoAlleleID);

create table HGVmart_test.TEMP12 as select a.*, b.AutoMarkerID, b.AlleleSeq
from TEMP11 as a left join test999_rcf8.Allele as b on a.AutoAlleleID=b.AutoAlleleID and (Status='active');
drop table HGVmart_test.TEMP11;
create index I_10 on TEMP12(AutoMarkerID);

create table HGVmart_test.TEMP13 as select a.*, b.MarkerID, b.LocalID, b.AlleleSeqsShorthand AS AlleleSet, b.Upstream30bp, b.Downstream30bp, RIGHT(b.Upstream30bp,10) AS Upstream10bp, LEFT(b.Downstream30bp,10) AS Downstream10bp, b.VariationType, b.Source
from TEMP12 as a left join test999_rcf8.Marker as b on a.AutoMarkerID=b.AutoMarkerID and (Status='active');
drop table HGVmart_test.TEMP12;

create table HGVmart_test.TEMP14 as select a.*, b.Chr, b.Start, b.Stop, b.MarkerCoordID
from TEMP13 as a left join test999_rcf8.MarkerCoord as b on a.AutoMarkerID=b.AutoMarkerID and (AssemblyName='reference');
drop table HGVmart_test.TEMP13;

create table HGVmart_test.TEMP15 as select a.*, IF(a.MarkerCoordID IS NULL, CONCAT(a.SignificanceID_key,"M",a.AutoMarkerID), CONCAT(a.SignificanceID_key,"C",a.MarkerCoordID)) AS UniqueID
from TEMP14 as a;
drop table HGVmart_test.TEMP14;

rename table TEMP15 to HGVmart_test.study_aa__Experiment__main;