var log = new Log(Log.WARN, Log.popupLogger);

var genomeViewURL = "http://143.210.155.214/cgi-bin/hgvbrowse_karyotype/Homo_sapiens?";
var regionViewURL = "http://143.210.155.214/cgi-bin/hgvbrowse/region?";
var hgvbaseUrlPrefix="/hgvbaseg2p";
var gSettingsChanged=0;
var rSettingsChanged=0;
//add or remove studies from browser (action is 'add' or other)
function browserAction(identifier, action) {
	
	if (action == 'add') {
		$.get(hgvbaseUrlPrefix + "/study/resultsets/"+identifier, null, 
			function (data, textStatus) {
		      document.getElementById('dialog').style.display="";
		      
		      if (data.substring(0,2) == 'rs') {
                 var temp = data.split("=");
                 
		      	 showDialog('info', function() {
		      	    $("#dialog").dialog("close");
				 	addStudy(identifier,false);
				 },"There is a single Result Set present in this study. This will be added to the browser. <input checked='ON' type='checkbox' id='rs" + temp[1] + "' name='rs_check'>");
			  }
			  else {
			  	showDialog('accept', function() {
                    $("#dialog").dialog("close");
			  		addStudy(identifier,true);
			    },data);
			  }
			  	
		  },'html');
	}
	else {
		removeStudy(identifier);
		var tagElement =  document.getElementById("action_" + identifier)
		var tagImage =  document.getElementById("image_" + identifier)
        tagElement.innerHTML="<span>Add to Browser</span>";
        tagElement.href="javascript:browserAction('" + identifier + "','add')";
        tagImage.src = hgvbaseUrlPrefix + "/images/add.png";
        studiesAdded--;
        updateStudiesAdded();
	}
  }
  
  function showDialog(type, buttonFunction,content, params) {
	  // if 'content' begins with a / then get using AJAX and use the params hash
	  if (content.substring(0,1)=='/') {
	   //show dialog before getting content and display a loader image
     var dialog = document.getElementById('dialog');
     dialog.style.display="";
     showAjaxLoader('dialog');
        doShowDialog(type,buttonFunction);
	  	$.get(content, params, 
				function (data, textStatus) {
				  //replace loader image with data content
				  document.getElementById('dialog').innerHTML=data;
			      
			    });
	  }
	  else {
		  	document.getElementById('dialog').innerHTML=content;
			doShowDialog(type,buttonFunction);	       
	  	
	  }
  }
  
  function doShowDialog(type, buttonFunction) {
    var buttonHash;
    var cancelFunction = function() {
    			$("#dialog").dialog("close"); 
    		};
    if (type=='info') {
    	buttonHash = {
    		'Ok': buttonFunction
    	}
    }
    else if (type=='accept') {
    	buttonHash = {
    		'Accept': buttonFunction,
    		'Cancel': cancelFunction
    	}
    }
    
    
  	$("#dialog").dialog({
					modal: true,
					draggable: false,
					resizable: false,
				    overlay: { 
				        opacity: 0.5, 
				        background: "black" 
				    },
				    buttons: buttonHash,
				    width: 600,
				    height: 400
				}); 
  }
 
  function addResultsetsToServer(study) {

  	var resultsetElements = document.getElementsByName('rs_check');
	var rsList = new Array();
  	for(var i=0;i<resultsetElements.length;i++) {
  	  	var rs = resultsetElements[i];
		if (rs.checked) { rsList.push(rs.id.substring(2)); }
  	}
  	if (rsList.length > 0) {
	  	var text = 
	  		$.get(hgvbaseUrlPrefix + "/browser/add",{ resultsetid: rsList, study: study }, 
	  				function (data, textStatus) {
	  			},'text');
		return true;
	}

  	return false;
  }
 
  function addStudy(study,single) {
	  if (addResultsetsToServer(study)==true || single==true) {
          var tagElement =  document.getElementById("action_" + study)
          var tagImage =  document.getElementById("image_" + study)
          tagElement.innerHTML="<span>Remove from Browser</span>";
          tagImage.src = hgvbaseUrlPrefix + "/images/remove.png";
          tagElement.href="javascript:browserAction('" + study + "','remove')";
          studiesAdded++;
          updateStudiesAdded();
      }
  }
  
  function updateStudiesAdded() {
    var addedStudies = document.getElementById('added_studies');
    
    if (studiesAdded == 1) {
      addedStudies.nextSibling.nextSibling.innerHTML="Study";
    }
    else {
      addedStudies.nextSibling.nextSibling.innerHTML="Studies";
    }
    
    if (studiesAdded == 0) {
      addedStudies.innerHTML="No"
    }
    else {
      addedStudies.innerHTML=studiesAdded;
    }
    
    
  }
  
  //remove study from session
  function removeStudy(study_identifier) {
	  		$.get(hgvbaseUrlPrefix + "/browser/remove/" + study_identifier,null, 
	  				function (data, textStatus) {
  						setResultsets(data);
	  			},'text');		
  }

function setResultsets(resultsetids) {
	document.getElementById('resultsetids').value=resultsetids;
}

//set all aspects of browser to update
function setBrowserToUpdate() {
	refreshGenomeView=1;
	refreshRegionView=1;
}

//update browser
function updateBrowser(tab) {
	checkSettings();
	doUpdate(tab);
}

//carry out update based on tab
function doUpdate(tab) {
	if(tab == 'genome') {
		updateGenomeView();
	}
	else if(tab=='region') {
		updateRegionView();
	}
}

//check if settings have been changed and set different aspects to be updated
function checkSettings() {

	//if no changes then return
	if (rSettingsChanged==0 && gSettingsChanged==0) return;
	//get settings elements by retrieving all with a name of 'settings'
	var settingElements = document.getElementsByName('settings');

	//loop through each element and push the id and value into an array
	var settingList=new Array();
	for(var i=0;i<settingElements.length;i++) {
		var setting = settingElements[i].id + "|" + settingElements[i].value;
		log.info("Added setting:" + setting);
		settingList.push(setting);
		
	}
	//get tracks elements by retrieving all with a name of 'tracks'
	var trackElements = document.getElementsByName('tracks');
	log.info("tracks:" + trackElements.length);
	var tracksList=new Array();

	//loop through each element and push the id into an array if it is checked
	for(var i=0;i<trackElements.length;i++) {
		var track = trackElements[i];
		if (track.checked) {
			log.info("Added checked track:" + track.id);
			tracksList.push(track.id);
		}
	}
	
	//store settings and tracks in the page
	setSettings(settingList);
	setTracks(tracksList);
	storeSession();
    if (rSettingsChanged==1) refreshRegionView=1;
    if (gSettingsChanged==1) refreshGenomeView=1;
    rSettingsChanged=0;
    gSettingsChanged=0;
}

function setSettings(settingsList) {
	var settings = settingsList.join(",");
	document.getElementById('settings').value=settings;
}

function setTracks(tracksList) {
	var tracks = tracksList.join(",");
	document.getElementById('tracks').value=tracks;
}

function getSettings() {
	//get settings elements by retrieving all with a name of 'settings'
	var settingElements = document.getElementsByName('settings');

	//loop through each element and push the id and value into an array
	var settingList=new Array();
	for(var i=0;i<settingElements.length;i++) {
		var setting = settingElements[i].id + "|" + settingElements[i].value;
		settingList.push(setting);
	}
	
	return settingList.join(",");
}

function getTracks() {
	//get tracks elements by retrieving all with a name of 'tracks'
	var trackElements = document.getElementsByName('tracks');
	log.info("tracks:" + trackElements.length);
	var tracksList=new Array();

	//loop through each element and push the id into an array if it is checked
	for(var i=0;i<trackElements.length;i++) {
		var track = trackElements[i];
		if (track.checked) {
			log.info("Added checked track:" + track.id);
			tracksList.push(track.id);
		}
	}
	return tracksList.join(",");
}

function switchTab(tabName) {
	
	
	var hideClass = "report_mainpanel ui-tabs-container ui-tabs-hide";
	var showClass = "report_mainpanel ui-tabs-container";
	var tabs = new Array('genomeview', 'regionview', 'settings');
	
	for (var t=0;t<tabs.length;t++) {
		if (tabs[t] == tabName) {
			top.document.getElementById('browser_' + tabName).className=showClass;
			top.document.getElementById('browser_' + tabName).style.display="block";
			top.document.getElementById('tab_' + tabName).className="ui-tabs-selected";
		}
		else {
			top.document.getElementById('browser_' + tabs[t]).style.display="none";
			top.document.getElementById('tab_' + tabs[t]).className=""
		}
	}
}
function e(elementID) {
	return document.getElementById(elementID);
}
function showAjaxLoader(elementID) {
  e(elementID).innerHTML="<center><img style='vertical-align:middle' src='" hgvbaseUrlPrefix + "/images/ajax-loader.gif'></center>";
}

function doUpdateGenomeView() {
	showAjaxLoader('genomeview_display');

	var resultsetids="";
	var threshold=e('threshold').value;
	var chr=e('chromosome').value;

	selectedResultsets = getSelectedResultsets();
	resultsetids=selectedResultsets.join(',');
	
	if (resultsetids.length == 0) {
		e('genomeview_nostudies').style.display="block";
		e('genomeview_studies').style.display="none";
		e('genomeview_display').innerHTML="";
		return;
	}
	else {
		e('genomeview_nostudies').style.display="none";
		e('genomeview_studies').style.display="block";
	}
	
    var noRows = calculateRows();
	if(chr == 'ALL'){
		var rotate;
		
		if (e('rotate_multiple').checked) rotate=1; else rotate=0;
		var height = e('multiple_length').value;
		$.get(genomeViewURL + "band_labels=0&h=" + height + "&w=" + parseInt(height/30) + "&e=1&rows=" + noRows + "&rotate=" + rotate + "&fp=GenomeView~stackheight=10~threshold=" + threshold + "~resultsetid=" + resultsetids + "~settings=" + getSettings() + "~tracks=" + getTracks(), null, 
				function (data, textStatus) {
			 
			  document.getElementById('genomeview_display').innerHTML=data;
			  
			},'html');
	}
	else {
		if (e('rotate_single').checked) rotate=1; else rotate=0;
		var height = e('single_length').value;
	    $.get(genomeViewURL + "flip=1&c=" + chr + "&h=" + height + "&w=" + parseInt(height/50) + "&band_labels=0&e=1&rows=1&rotate=" + rotate + "&fp=GenomeView~stackheight=50~threshold=" + threshold + "~resultsetid=" + resultsetids + "~settings=" + getSettings() + "~tracks=" + getTracks(), null, 
			function (data, textStatus) {
		  document.getElementById('genomeview_display').innerHTML=data;
		  
		},'html');
	}			
}

function calculateRows() {
  var settingsRows = document.getElementById('rows_chromosomes').value;
  var noRows = Math.ceil(allChr/screenWidth);
  if (settingsRows !='auto') return settingsRows;
	  var screenWidth = screen.width-50;
	  if (e('rotate_multiple').checked) {
		var singleChr = parseInt(e('multiple_length').value) + 180;
		noRows = Math.ceil(screenWidth/singleChr);
	  }
	  else {
	    var singleChr = 80 + (getSelectedResultsets().length * e('genome_stacked_height').value);
	    var allChr = singleChr * 24;
	    noRows = Math.ceil(allChr/screenWidth);
	  }
	  
	  alert("singleChr:" + singleChr);
	  alert("noRows:" + noRows);
  //GBrowse_karyotype needs rows (not columns) if rotated (ie. 2 columns would be 12 rows)
  if (e('rotate_multiple').checked) return 24/noRows; else return noRows;

}

function updateGenomeView(refreshNow) {
	if ((refreshGenomeView==1) || (refreshNow==true)) {
		refreshGenomeView=0;
		doUpdateGenomeView();
	}
}

function getThreshold() {
	return document.getElementById('threshold').value;
}

function getChromosomes() {
	return document.getElementById('chromosome').value;
}

function storeSession() {
	var region = 
	$.get(hgvbaseUrlPrefix + "/browser/store",{ threshold: getThreshold(), chrs_to_display: getChromosomes(), region: region, tracks: getTracks(), settings:getSettings()}, 
			function (data, textStatus) {
		},'text');	
}

function getSelectedResultsets() {
	var resultsetArray = new Array();
	resultsetArray = document.getElementById('resultsetids').value.split(",");
	return resultsetArray;
}

function loadResultsets() {
	var rsets = getSelectedResultsets();
	$("#resultset_key").load(hgvbaseUrlPrefix + "/browser/key",{ resultsetid: rsets });
}

function updateRegionView() {
	if (refreshRegionView==0) return;
	
	
	var region = getRegion();

	if (region==null) return;
	refreshRegionView=0;

	var resultsetid = getSelectedResultsets().join(',');
	var threshold = document.getElementById('threshold').value;
	doUpdateRegionView(region,resultsetid,threshold);
}

function getRegion() {
	var gbrowse_region=null; 
	try {
		gbrowse_region = window.frames[0].document.getElementsByName('name')[0].value;
	}
	catch(ex) {
	}
	var gbrowse_region;
	var hgvbase_region = document.getElementById('region').value;
	if (hgvbase_region!=null) {
		return hgvbase_region;
	}
	if (gbrowse_region!=null) {
		return gbrowse_region;
	}
	return null;
}

function doUpdateRegionView(region, resultsetid, threshold) {
	if (resultsetid.length == 0) {
		document.getElementById('regionview_nostudies').style.display="block";
		document.getElementById('regionview_studies').style.display="none";
	}
	else {
		document.getElementById('regionview_nostudies').style.display="none";
		document.getElementById('regionview_studies').style.display="block";
	}
	
	document.getElementById('regionview_loader').style.display="";

	top.document.getElementById('regionview').style.height="0px";
	var regionURL = regionViewURL + "plugin=PValueData;plugin_action=Settings;plugin_config=1;";
	if (region==null) {
		region="";
	}
	regionURL = regionURL + "name=" + region + ";";
	regionURL = regionURL + "PValueData.resultsetid=" + resultsetid + ";";
	regionURL = regionURL + "PValueData.threshold=" + threshold + ";";
	regionURL = regionURL + "PValueData.settings=" + getSettings() + ";";
	regionURL = regionURL + "PValueData.tracks=" + getTracks();
	log.info("regionURL:" + regionURL);
	document.getElementById('regionview').src=regionURL;
}

function rView(chrLocation) {
	var locString = new Number(chrLocation).toString();
	var locInfo = locString.split(".",locString);
	if (locInfo[0]=='1') {
		locInfo[1] = locString.substr(2);
	}
	var chr = locInfo[0];
	var threshold = document.getElementById('threshold').value;
	var resultsetid = getSelectedResultsets().join(',');
	var compare = 'multi';
	
	if (chr == '24') {
		chr = 'X'
	};
	var actualStart = zeroSuffix(locInfo[1],3);
	var start;
	if (actualStart == '000') {
		start = 1;
	}
	else {
		start = (actualStart*1000000)+1;
	}
	var stop = start + 9000000-1;
	
	doUpdateRegionView("Chr" + chr + ":" + start + ".." + stop, resultsetid, threshold);
	switchTab('regionview');
	refreshRegionView=0;
}

function zeroSuffix(numberString,length) {
	var extraZeroes = length - numberString.length;
	var zeroes = '';
	for(var i=0; i<extraZeroes;i++) {
		zeroes = zeroes + '0';
	}
	return numberString + zeroes;
}


function showExperiment(identifier) {
	showDialog('info',function() {  $("#dialog").dialog("close"); }, hgvbaseUrlPrefix + "/study/experiment/"+identifier);
}

function removeStudyFromBrowser(identifier) {
	var text = 
	  		$.get(hgvbaseUrlPrefix + "/browser/remove/" + identifier,null, 
	  				function (data, textStatus) {
  						setResultsets(data);
	  			},'text');	
	var elementID = "study_" + identifier
	$("#" + elementID).hide('slow');
	var studyPanel = document.getElementById(elementID);
	studyPanel.parentNode.removeChild(studyPanel);
	var studyTable = document.getElementById('study_table');
	var studies = studyTable.rows.length;
	if (studies=='0') studies = 'no';
	if (studies==1) {
		studies = '1 study';
	}
	else {
		studies = studies + ' studies';
	}
		
	
	document.getElementById('study_no').innerHTML=studies;
    loadResultsets();
    setBrowserToUpdate();
}

function switchResultset(resultsetid,studyid) {
	log.info("running switchResultset");

	var type;
	if (document.getElementById("rs" + resultsetid).checked) {
		type ='add';
	}
	else {
		type='remove';
	}
	
	var count = countCheckedInStudy(studyid);
	if (count==0) {
		var isDeleted=confirm("This will remove the study from the list. Are you sure?");
		if (isDeleted==true) {
			removeStudyFromBrowser(studyid);
		}
		else {
			document.getElementById("rs" + resultsetid).checked=true;
			return;
		}
	}
	addResultsetToClient(resultsetid,type);	
	document.getElementById('study_'+studyid+'_count').innerHTML=count;
	loadResultsets();
	setBrowserToUpdate();
}

function countCheckedInStudy(studyid) {
	var selectedRs = document.getElementsByName('rs_check'+studyid);
	var count = 0;
	for(var i=0;i<selectedRs.length;i++) {
		if (selectedRs[i].checked) {
			count++;
		}
	}
	return count;
}

function addResultsetToClient(resultsetid, type) {
log.info("running addResultsetToClient");
	var current_rs = document.getElementById("resultsetids");
	var ids = current_rs.value.split(',');
	if (ids[0]=="") {
		ids=new Array();
	}
	if (type=='add') {
		ids.push(resultsetid);
	}
	else {
		var i =0;
		while (i<=ids.length) {
			if (parseInt(ids[i])==parseInt(resultsetid)) {
				ids.splice(i,1);
			}
			i++;
		}
	}
	document.getElementById("resultsetids").value = ids.join(',');
}

function toggle(identifier) {
	var image = document.getElementById("study_toggle" + identifier);
	log.info("running toggle with identifier:"+identifier);
	if (image.src.match(/plus/)) {
		log.info("clicked on plus: show");
		image.src=hgvbaseUrlPrefix + "/images/minus.png";
		$('#study_summary' + identifier).show('fast');
	}
	else {
	    log.info("clicked on minus: collapse");
		image.src=hgvbaseUrlPrefix + "/images/plus.png";
		$('#study_summary' + identifier).hide('fast');
	}
}