#!perl

# $Id: Database.pm 497 2008-04-15 14:51:03Z rcf8 $

=head1 NAME

HGVbaseG2Pmart::Test::Database - Test module for database access


=head1 SYNOPSIS

=head1 DESCRIPTION

This module is run by the Test harness. It tests BioMart database access

=head1 SUBROUTINES/METHODS 

=cut

package HGVbaseG2Pmart::Test::Database;
use strict;
use warnings;

use FindBin;
use lib "$FindBin::Bin/../lib";

use base qw(HGVbaseG2Pmart::Test);
use Test::More;

sub check_mart_connection : Test(3) {
	my $self = shift;
	my %testdata = $self->get_data;
	
	my ($dbh,$sth);

	ok($dbh=DBI->connect($testdata{dsn},$testdata{user},$testdata{password}),"Mart DB connection");
	
	ok($sth=$dbh->do($testdata{sqltest}),"Mart DB query");
	
	ok($dbh->disconnect,"Mart DB disconnection");
}
1;

=head1 SEE ALSO

=head1 BUGS AND LIMITATIONS

There are no known bugs in this module.
Please report problems to Rob Free <rcfree@gmail.com>

=head1 CONTACT

This module is part of the HGVbase-G2P project

=head1 AUTHOR

Rob Free <rcfree@gmail.com>

=head1 LICENCE AND COPYRIGHT

Copyright (c) <2007> University of Leicester, Leicester, UK. All rights reserved.

This module is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 

=head1 CVSINFO

$Id: Database.pm 497 2008-04-15 14:51:03Z rcf8 $

=cut
