#!perl

# $Id: PhenotypeMarker.pm 268 2008-01-09 16:01:16Z rcf8 $

=head1 NAME

HGVbaseG2Pmart::Test::PhenotypeMarker - Test module for link between phenotype and marker data


=head1 SYNOPSIS

The module uses HGVbaseG2Pmart::Test::Marker as a base class but overrides
the before_test method. This means the tests running from the base class return 
markers for a specific phenotype.

=head1 SUBROUTINES/METHODS 

=cut

package HGVbaseG2Pmart::Test::PhenotypeMarker;
use strict;
use warnings;

use base qw(HGVbaseG2Pmart::Test::Marker);
use Test::More;

#overrides method in HGVbaseG2Pmart::Test::Marker method to set up query and description
sub before_test : Test(setup) {
	my $self = shift;
	my %testdata = $self->get_data;
	my $query = $self->create_query;
	
	$query->setDataset("phenotype");
	$query->addAttribute("methodname");
	$query->addFilter("methodname",[$testdata{phenotype1}]);

	$self->set_query($query);
	$self->set_description("specific phenotype");
}
1;