#!perl

# $Id: SamplepanelStudyMarker.pm 268 2008-01-09 16:01:16Z rcf8 $

=head1 NAME

HGVbaseG2Pmart::Test::SamplepanelStudyMarker - Test module for link between study (via samplepanel) and marker data


=head1 SYNOPSIS

The module uses HGVbaseG2Pmart::Test::Marker as a base class but overrides
the before_test method. This means the tests running from the base class return 
markers for a specific study.

There are also test methods unique to the module which do not do this. 

=head1 SUBROUTINES/METHODS 

=cut

package HGVbaseG2Pmart::Test::SamplepanelStudyMarker;
use strict;
use warnings;

use base qw(HGVbaseG2Pmart::Test::Marker);
use Test::More;

#overrides method in HGVbaseG2Pmart::Test::Marker method to set up query and description
sub before_test : Test(setup) {
	my $self = shift;
	my %testdata = $self->get_data;
	my $query = $self->create_query;
	
	$query->setDataset("samplepanel");
	$query->addFilter("title",[$testdata{studytitle1}]);
	$query->addAttribute("geographicregioninfo");
	$query->addAttribute("localid");
	$query->addAttribute("ethnicityinfo");

	$self->set_query($query);
	$self->set_description("specific study (via samplepanel)");
}
1;