#!perl

# $Id: AlleleAssociation.pm 772 2008-06-23 17:37:28Z rcf8 $

=head1 NAME

HGVbaseG2Pmart::Test::Study::AlleleAssociation- Test module for study and marker data


=head1 SYNOPSIS

=head1 DESCRIPTION

This module is run by the Test harness. It tests queries linking studies to markers.

The module uses HGVbaseG2Pmart::Test::Marker as a base class but overrides
the before_test method. This means the tests running from the base class return 
markers for a specific study.

There are also test methods unique to the module which do not do this. 

=head1 SUBROUTINES/METHODS 

=cut

package HGVbaseG2Pmart::Test::Study::AlleleAssociation;
use strict;
use warnings;


use base qw(HGVbaseG2Pmart::Test::Study);
use Test::More;

#overrides Marker method to set up query and description
sub before_test : Test(setup) {
	my $self = shift;
	my $query = $self->create_query;
	
	$query->setDataset("study");
	$self->set_query($query);
	$self->add_attribute_page("study","study_allele_associations");
	$self->set_description("allele associations");
}
1;