#!perl

# $Id: StudyExperimentMarker.pm 268 2008-01-09 16:01:16Z rcf8 $

=head1 NAME

HGVbaseG2Pmart::Test::StudyExperimentMarker - Test module for link between experiment (via study) and marker data


=head1 SYNOPSIS

The module uses HGVbaseG2Pmart::Test::Marker as a base class but overrides
the before_test method. This means the tests running from the base class return 
markers for a specific experiment via the study dataset.

=head1 SUBROUTINES/METHODS

=cut

package HGVbaseG2Pmart::Test::StudyExperimentMarker;
use strict;
use warnings;

use base qw(HGVbaseG2Pmart::Test::Marker);
use Test::More;

sub before_test : Test(setup) {
	my $self = shift;
	my %testdata = $self->get_data;
	my $query = $self->create_query;

	$query->setDataset("study");
	$query->addFilter("experiment_type",[$testdata{experiment_type}]);
	$query->addAttribute("title");
	$query->addAttribute("type");
	$query->addAttribute("experiment_title");
	
	$self->set_query($query);
	$self->set_description("experiment (via study)");
}

1;