#!perl

# $Id: StudyMarker.pm 268 2008-01-09 16:01:16Z rcf8 $

=head1 NAME

HGVbaseG2Pmart::Test::StudyMarker - Test module for study and marker data


=head1 SYNOPSIS

=head1 DESCRIPTION

This module is run by the Test harness. It tests queries linking studies to markers.

The module uses HGVbaseG2Pmart::Test::Marker as a base class but overrides
the before_test method. This means the tests running from the base class return 
markers for a specific study.

There are also test methods unique to the module which do not do this. 

=head1 SUBROUTINES/METHODS 

=cut

package HGVbaseG2Pmart::Test::StudyMarker;
use strict;
use warnings;


use base qw(HGVbaseG2Pmart::Test::Marker);
use Test::More;

#overrides Marker method to set up query and description
sub before_test : Test(setup) {
	my $self = shift;
	my %testdata = $self->get_data;
	my $query = $self->create_query;
	
	$query->setDataset("study");
	$query->addFilter("title",[$testdata{studytitle1}]);
	$query->addAttribute("title");
	$query->addAttribute("submissiondate");
	$self->set_query($query);
	$self->set_description("specific study");
}

sub get_markers_for_all_studies : Test(1) {
	my $self = shift;
	my %testdata = $self->get_data;
	my $query = $self->create_query;
	
	$query->setDataset("study");
	$query->addAttribute("title");
	$query->addAttribute("submissiondate");
	
	$query->setDataset("marker");
	$query->addAttribute("localid");
	
	my $count = $self->get_executed_count;
	
	cmp_ok($count,'>=',1,"get markers for all studies ($count)");
}
1;