#!perl

# $Id: StudyPhenotypeMarker.pm 268 2008-01-09 16:01:16Z rcf8 $

=head1 NAME

HGVbaseG2Pmart::Test::StudyPhenotypeMarker - Test module for link between phenotype (via study) and marker data


=head1 SYNOPSIS

The module uses HGVbaseG2Pmart::Test::Marker as a base class but overrides
the before_test method. This means the tests running from the base class return 
markers for a specific study.

There are also test methods unique to the module which do not do this. 

=head1 SUBROUTINES/METHODS 

=cut

package HGVbaseG2Pmart::Test::StudyPhenotypeMarker;
use strict;
use warnings;

use base qw(HGVbaseG2Pmart::Test::Marker);
use Test::More;

#overrides Marker method to set up query and description
sub before_test : Test(setup) {
	my $self = shift;
	my %testdata = $self->get_data;
	my $query = $self->create_query;

	$query->setDataset("study");
	$query->addFilter("phenotype_methodname",[$testdata{phenotype1}]);
	$query->addAttribute("title");
	$query->addAttribute("type");
	$query->addAttribute("phenotype_methodname");
	
	$self->set_query($query);
	$self->set_description("phenotype (via study)");
}

1;