# $Id: Mart.pm 1192 2009-06-18 11:26:43Z rcf8 $

=head1 NAME

HGVbaseG2P::Database::Mart - Query data from HGVmart


=head1 SYNOPSIS

more to be written


=head1 DESCRIPTION

more to be written

=head1 SUBROUTINES/METHODS 

=cut

package HGVbaseG2P::Database::Mart; {
    
use strict;
use warnings;


# Use OIO inside-out object framework for our OO hierarachy
use Object::InsideOut qw( HGVbaseG2P::Database );
use Object::InsideOut::Metadata;

use FindBin;
use lib "$FindBin::Bin/../../";

use English qw( -no_match_vars );
use Data::Dumper;
use DBI;

sub init_data_source {
        my ($self)=@_;
        my $config = $self->config->{HGVmart};
        return DBI->connect($config->{dsn},$config->{dbuser},$config->{dbpassw});
    }

sub get_gt_for_exp {
		my ($self, $attrs) = @_;
	    my $sql = "SELECT Chr, AnalysisMethodID, StudyID, SignificanceID_key, LocalID, LocalID_Assayedpanel, GenotypeLabel, NumberSamplesWithGenotype,Start FROM study__GenotypeAssociation__dm WHERE ExperimentID_key=? LIMIT 999";
	    return $self->dbi_select(
	        $sql,
	        [
	            $attrs->{expid},
	        ],
	        $attrs
	    );
	}
	
sub get_genotypes_for_method {
		my ($self, $attrs) = @_;
	    my $sql = "SELECT Chr, AnalysisMethodID, StudyID, SignificanceID_key, LocalID, LocalID_Assayedpanel, GenotypeLabel, NumberSamplesWithGenotype,Start,PValueHWE,UnadjustedPValue FROM study__GenotypeAssociation__dm WHERE AnalysisMethodID=?";
	    return $self->dbi_select(
	        $sql,
	        [
	            $attrs->{methodid},
	        ],
	        $attrs
	    );
	}

}
1;

=head1 SEE ALSO

L<HGVbaseG2P::FileParser>, L<HGVbaseG2P::Database> and related classes

=head1 BUGS AND LIMITATIONS

There are no known bugs in this module.
Please report problems to Rob Free <rcfree@gmail.com>

=head1 CONTACT

This module is part of the HGVbase-G2P project

=head1 AUTHOR

Rob Free <rcfree@gmail.com>

=head1 LICENCE AND COPYRIGHT

Copyright (c) <2007> University of Leicester, Leicester, UK. All rights reserved.

This module is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 

=head1 CVSINFO

$Id: Mart.pm 1192 2009-06-18 11:26:43Z rcf8 $ 

=cut

