#!/usr/bin/perl

# $Id: Broad.pm 1098 2008-12-05 13:27:01Z rcf8 $

=head1 NAME

HGVbaseG2P::PreProcess::Split::Broad - PreProccessing splitting the broad file into individual chromosomes

=head1 SYNOPSIS

    
=head1 DESCRIPTION

  

=head1 SUBROUTINES/METHODS 

=cut



package HGVbaseG2P::PreProcess::Split::Broad;
{
	use strict;
	use warnings;
#ToDo
	use FindBin;
	use lib "$FindBin::Bin/../";
	# Use OIO inside-out object framework for our OO hierarachy
	use Object::InsideOut qw(HGVbaseG2P::PreProcess::Split);
	use Object::InsideOut::Metadata;
	use Carp qw(cluck croak confess);
	use Data::Dumper;
	use HGVbaseG2P::Util qw(load_config init_logger);

	# Private variables & constants
	my $logger;        # Reference to master logger
	my %config;        # Master configuration settings from config-file
my %chromosome;

	# Initialization method (see OIO docs for details)
	sub _init : Init {
		my ( $self, $args ) = @_;

		# Initialize logger
		my $log4perl_conf = $args->{log4perl_conf} || $config{log4perl_conf};
		$logger = init_logger( $log4perl_conf, __PACKAGE__ );
	}

	# some text here
	sub filetype        { return 'delimited'; }
	sub field_separator { return ' '; }


sub process_line
	{

		#set up some counters for processing
		my ( $self, $line) = @_;
		# Dont want the header lineif /^CHR/;
		my (
			 $chr,      $pos,      $rsid,    $z_pval,  $z_score,
			 $or_cmh,   $l95,      $u95,     $a1,      $a2,
			 $maf,      $f_a,      $f_u,     $geno,    $geno_a,
			 $geno_u,   $p_hwd,    $p_hwd_a, $p_hwd_u, $f_miss,
			 $f_miss_a, $f_miss_u, $p_miss,  $gene_list
		) = @$line;
		return if $chr =~ /^CHR/;


$chromosome{$chr}="";



	}
	
sub return_chr{
return \%chromosome;
}
 
	

sub reprocess_line
	{

		#set up some counters for processing
		my ( $self, $line,$ch) = @_;

		# Don't want the header lineif /^CHR/;
		my (
			 $chr,      $pos,      $rsid,    $z_pval,  $z_score,
			 $or_cmh,   $l95,      $u95,     $a1,      $a2,
			 $maf,      $f_a,      $f_u,     $geno,    $geno_a,
			 $geno_u,   $p_hwd,    $p_hwd_a, $p_hwd_u, $f_miss,
			 $f_miss_a, $f_miss_u, $p_miss,  $gene_list
		) = @$line;
		
		if ($chr =~ /^CHR/){
			
			
			my $fh_noimpute = $self->print_split_outfile;
			print $fh_noimpute "CHR POS SNP Z_PVAL ZSCORE OR_CMH L95 U95 A1 A2 MAF F_A F_U GENO GENO_A GENO_U P_HWD P_HWD_A P_HWD_U F_MISS F_MISS_A F_MISS_U P_MISS GENE_LIST\n";
			my $fh_imputed = $self->print_split_imputedoutfile;
			print $fh_imputed "CHR POS SNP Z_PVAL ZSCORE OR_CMH L95 U95 A1 A2 MAF F_A F_U GENO GENO_A GENO_U P_HWD P_HWD_A P_HWD_U F_MISS F_MISS_A F_MISS_U P_MISS GENE_LIST\n";
		}
			
			



if (($chr eq $ch)&&($rsid=~/^rs.*/)){
	
	my $fh_noimpute = $self->print_split_outfile;

	print $fh_noimpute "@$line\n";
	$self->increment_stat("chr".$chr."_count");
	
}elsif (($chr eq $ch)&&($rsid=~/SNP.*/)){
	
	my $fh_noimpute = $self->print_split_outfile;

	print $fh_noimpute "@$line\n";
	$self->increment_stat("chr".$chr."_count");
}elsif (($chr eq $ch)&&($rsid=~/i_rs.*/)){
	
	my $fh_imputed = $self->print_split_imputedoutfile;
$self->increment_stat("chr".$chr."_imputed_count");
	print $fh_imputed "@$line\n";
	
}
	

	
#$self->increment_stat("chrTotal_number_markers");




}

	
	
#sub _get_chr {
#		my ( $self, $line ) = @_;
##chrX    141008946       141008947       rs5907230
#		$chromosome{ $line->[0] } =  "";
#		
#		#print Dumper($line->[3]);
#		
#	}
#
#
#sub get_chr{
#		my ( $self, $chr ) = @_;    
#		my $ = $chromosome{$chr};
#
#		if ( !$pos ) {
#			$logger->error("no position");
#			$self->increment_stat('unmapped_error');
#			return;
#		}
#		return $pos;
#	}

}#package
1;