package HGVbaseG2P::Schema::Allele;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Allele");
__PACKAGE__->add_columns(
  "alleleid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "identifier",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 15,
  },
  "status",
  {
    data_type => "VARCHAR",
    default_value => "active",
    is_nullable => 0,
    size => 20,
  },
  "markerid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "upstream30bp",
  { data_type => "VARCHAR", default_value => "", is_nullable => 0, size => 30 },
  "alleleseq",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 0,
    size => 65535,
  },
  "alleleseqdigest",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 32,
  },
  "downstream30bp",
  { data_type => "VARCHAR", default_value => "", is_nullable => 0, size => 30 },
  "seqtype",
  { data_type => "ENUM", default_value => "G", is_nullable => 0, size => 1 },
);
__PACKAGE__->set_primary_key("alleleid");
__PACKAGE__->add_unique_constraint("MarkerID", ["markerid", "alleleseqdigest"]);
__PACKAGE__->belongs_to(
  "markerid",
  "HGVbaseG2P::Schema::Marker",
  { markerid => "markerid" },
);
__PACKAGE__->has_many(
  "genotypedefs",
  "HGVbaseG2P::Schema::Genotypedef",
  { "foreign.alleleid" => "self.alleleid" },
);
__PACKAGE__->has_many(
  "haplotypealleles",
  "HGVbaseG2P::Schema::Haplotypeallele",
  { "foreign.alleleid" => "self.alleleid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:eJy0+TNlyR6VRCBAuORl6Q


# You can replace this text with custom content, and it will be preserved on regeneration
1;
