package HGVbaseG2P::Schema::Assay;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Assay");
__PACKAGE__->add_columns(
  "assayid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "studyid",
  {
    data_type => "MEDIUMINT",
    default_value => undef,
    is_nullable => 0,
    size => 8,
  },
  "labid4assay",
  { data_type => "VARCHAR", default_value => "", is_nullable => 0, size => 100 },
  "type",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
  "method",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "conditions",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
);
__PACKAGE__->set_primary_key("assayid");
__PACKAGE__->belongs_to(
  "studyid",
  "HGVbaseG2P::Schema::Study",
  { studyid => "studyid" },
);
__PACKAGE__->has_many(
  "assaycitations",
  "HGVbaseG2P::Schema::Assaycitation",
  { "foreign.assayid" => "self.assayid" },
);
__PACKAGE__->has_many(
  "assaymarkers",
  "HGVbaseG2P::Schema::Assaymarker",
  { "foreign.assayid" => "self.assayid" },
);
__PACKAGE__->has_many(
  "oligoes",
  "HGVbaseG2P::Schema::Oligo",
  { "foreign.assayid" => "self.assayid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:hfXRVBMl1dzCR8oGZ6Zj/g


# You can replace this text with custom content, and it will be preserved on regeneration
1;
