package HGVbaseG2P::Schema::Assayedpanel;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Assayedpanel");
__PACKAGE__->add_columns(
  "assayedpanelid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "studyid",
  {
    data_type => "MEDIUMINT",
    default_value => undef,
    is_nullable => 0,
    size => 8,
  },
  "identifier",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 15,
  },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
  "description",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
  "totalnumberofindividuals",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofsexmale",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofsexfemale",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofsexunknown",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofprobands",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofparents",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
);
__PACKAGE__->set_primary_key("assayedpanelid");
__PACKAGE__->add_unique_constraint("Identifier", ["identifier"]);
__PACKAGE__->add_unique_constraint("Name", ["name", "studyid"]);
__PACKAGE__->belongs_to(
  "studyid",
  "HGVbaseG2P::Schema::Study",
  { studyid => "studyid" },
);
__PACKAGE__->has_many(
  "experimentassayedpanels",
  "HGVbaseG2P::Schema::Experimentassayedpanel",
  { "foreign.assayedpanelid" => "self.assayedpanelid" },
);
__PACKAGE__->has_many(
  "frequencyclusters",
  "HGVbaseG2P::Schema::Frequencycluster",
  { "foreign.assayedpanelid" => "self.assayedpanelid" },
);
__PACKAGE__->has_many(
  "selectioncriteria_assayedpanelids",
  "HGVbaseG2P::Schema::Selectioncriteria",
  { "foreign.assayedpanelid" => "self.assayedpanelid" },
);
__PACKAGE__->has_many(
  "selectioncriteria_sourceassayedpanelids",
  "HGVbaseG2P::Schema::Selectioncriteria",
  { "foreign.sourceassayedpanelid" => "self.assayedpanelid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:icypWtlIS784jCtjFdso7A


# You can replace this text with custom content, and it will be preserved on regeneration
*selectioncriteria = \&selectioncriteria_assayedpanelids;
*study = \&studyid;
__PACKAGE__->many_to_many(usedin => 'experimentassayedpanels', 'experimentid' );

sub to_jsonhash {
    my $self = shift;
    return { 
	label => $self->name,
	type  => 'assayedpanel',
        id    => $self->identifier,
	description => $self->description,
	study => $self->study->identifier,
    };
}
1;
