package HGVbaseG2P::Schema::Assaymarker;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("AssayMarker");
__PACKAGE__->add_columns(
  "assaymarkerid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "assayid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "markerid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
);
__PACKAGE__->set_primary_key("assaymarkerid");
__PACKAGE__->belongs_to(
  "markerid",
  "HGVbaseG2P::Schema::Marker",
  { markerid => "markerid" },
);
__PACKAGE__->belongs_to(
  "assayid",
  "HGVbaseG2P::Schema::Assay",
  { assayid => "assayid" },
);
__PACKAGE__->has_many(
  "assaymarkergenotypes",
  "HGVbaseG2P::Schema::Assaymarkergenotype",
  { "foreign.assaymarkerid" => "self.assaymarkerid" },
);
__PACKAGE__->has_many(
  "assayedgenotypes",
  "HGVbaseG2P::Schema::Assayedgenotype",
  { "foreign.assaymarkerid" => "self.assaymarkerid" },
);
__PACKAGE__->has_many(
  "fcams",
  "HGVbaseG2P::Schema::Fcam",
  { "foreign.assaymarkerid" => "self.assaymarkerid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:Sb/lGEeCFpG/bYbFYTufwA


# You can replace this text with custom content, and it will be preserved on regeneration
1;
