package HGVbaseG2P::Schema::Citation;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Citation");
__PACKAGE__->add_columns(
  "citationid",
  {
    data_type => "SMALLINT",
    default_value => undef,
    is_nullable => 0,
    size => 5,
  },
  "pubmedid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "authors",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "title",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "detail",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "meshterms",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
);
__PACKAGE__->set_primary_key("citationid");
__PACKAGE__->add_unique_constraint("PubmedID", ["pubmedid"]);
__PACKAGE__->has_many(
  "assaycitations",
  "HGVbaseG2P::Schema::Assaycitation",
  { "foreign.citationid" => "self.citationid" },
);
__PACKAGE__->has_many(
  "citationcrossrefs",
  "HGVbaseG2P::Schema::Citationcrossref",
  { "foreign.citationid" => "self.citationid" },
);
__PACKAGE__->has_many(
  "phenotypemethodcitations",
  "HGVbaseG2P::Schema::Phenotypemethodcitation",
  { "foreign.citationid" => "self.citationid" },
);
__PACKAGE__->has_many(
  "phenotypepropertycitations",
  "HGVbaseG2P::Schema::Phenotypepropertycitation",
  { "foreign.citationid" => "self.citationid" },
);
__PACKAGE__->has_many(
  "studycitations",
  "HGVbaseG2P::Schema::Studycitation",
  { "foreign.citationid" => "self.citationid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:3G/aNyTFmFnbgyg6BbQRLw


# You can replace this text with custom content, and it will be preserved on regeneration
1;
