package HGVbaseG2P::Schema::Citationcrossref;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("CitationCrossref");
__PACKAGE__->add_columns(
  "citationcrossrefid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "citationid",
  { data_type => "SMALLINT", default_value => 0, is_nullable => 0, size => 5 },
  "crossrefid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
);
__PACKAGE__->set_primary_key("citationcrossrefid");
__PACKAGE__->add_unique_constraint("CitationID", ["citationid", "crossrefid"]);
__PACKAGE__->belongs_to(
  "citationid",
  "HGVbaseG2P::Schema::Citation",
  { citationid => "citationid" },
);
__PACKAGE__->belongs_to(
  "crossrefid",
  "HGVbaseG2P::Schema::Crossref",
  { crossrefid => "crossrefid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:VoINtknh3SJvGica0weyIA


# You can replace this text with custom content, and it will be preserved on regeneration
1;
