package HGVbaseG2P::Schema::Contribution;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Contribution");
__PACKAGE__->add_columns(
  "contributionid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "researcherid",
  {
    data_type => "SMALLINT",
    default_value => undef,
    is_nullable => 0,
    size => 5,
  },
  "submissionid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "issubmitter",
  { data_type => "VARCHAR", default_value => undef, is_nullable => 1, size => 5 },
  "isauthor",
  { data_type => "VARCHAR", default_value => undef, is_nullable => 1, size => 5 },
   "issource",
  { data_type => "VARCHAR", default_value => undef, is_nullable => 1, size => 5 },
);
__PACKAGE__->set_primary_key("contributionid");
__PACKAGE__->belongs_to(
  "researcherid",
  "HGVbaseG2P::Schema::Researcher",
  { researcherid => "researcherid" },
);
__PACKAGE__->belongs_to(
  "submissionid",
  "HGVbaseG2P::Schema::Submission",
  { submissionid => "submissionid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:yBIOMmfzx4Hl4ALe9LFOIA

*researcher = \*researcherid;

# You can replace this text with custom content, and it will be preserved on regeneration
1;
