package HGVbaseG2P::Schema::Crossref;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Crossref");
__PACKAGE__->add_columns(
  "crossrefid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "hotlinkid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "urlid",
  { data_type => "VARCHAR", default_value => "", is_nullable => 1, size => 100 },
);
__PACKAGE__->set_primary_key("crossrefid");
__PACKAGE__->has_many(
  "citationcrossrefs",
  "HGVbaseG2P::Schema::Citationcrossref",
  { "foreign.crossrefid" => "self.crossrefid" },
);
__PACKAGE__->has_many(
  "phenotypemethodcrossrefs",
  "HGVbaseG2P::Schema::Phenotypemethodcrossref",
  { "foreign.crossrefid" => "self.crossrefid" },
);
__PACKAGE__->has_many(
  "resultsetcrossrefs",
  "HGVbaseG2P::Schema::Resultsetcrossref",
  { "foreign.crossrefid" => "self.crossrefid" },
);
__PACKAGE__->has_many(
  "samplepanelcrossrefs",
  "HGVbaseG2P::Schema::Samplepanelcrossref",
  { "foreign.crossrefid" => "self.crossrefid" },
);
__PACKAGE__->has_many(
  "studycrossrefs",
  "HGVbaseG2P::Schema::Studycrossref",
  { "foreign.crossrefid" => "self.crossrefid" },
);


# Created by DBIx::Class::Schema::Loader v0.04006 @ 2009-10-12 10:07:17
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:qF62earaUcyoCRhQne4erg


# You can replace this text with custom content, and it will be preserved on regeneration

*hotlink = \&hotlinkid;

__PACKAGE__->belongs_to(
  "hotlinkid",
  "HGVbaseG2P::Schema::Hotlink",
  { hotlinkid => "hotlinkid" },
);

# __PACKAGE__->has_one(
#   "hotlink",
#   "HGVbaseG2P::Schema::Hotlink",
#   { "foreign.hotlinkid" => "self.hotlinkid" },
# );
1;
