package HGVbaseG2P::Schema::Datasource;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("DataSource");
__PACKAGE__->add_columns(
  "datasourceid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 4 },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 100,
  },
  "uri",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 300,
  },
);
__PACKAGE__->set_primary_key("datasourceid");
__PACKAGE__->add_unique_constraint("URI", ["uri"]);
__PACKAGE__->add_unique_constraint("Name", ["name"]);
__PACKAGE__->has_many(
  "markers",
  "HGVbaseG2P::Schema::Marker",
  { "foreign.datasourceid" => "self.datasourceid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:otxdhw2xKEQCQsOcd6294A


# You can replace this text with custom content, and it will be preserved on regeneration
1;
