package HGVbaseG2P::Schema::Diseasecategory;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("DiseaseCategory");
__PACKAGE__->add_columns(
  "diseasecategoryid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 6 },
  "parentcategoryid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "meshtreeid",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 30,
  },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
  "description",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
);
__PACKAGE__->set_primary_key("diseasecategoryid");
__PACKAGE__->add_unique_constraint("Name", ["name"]);
__PACKAGE__->belongs_to(
  "parentcategoryid",
  "HGVbaseG2P::Schema::Diseasecategory",
  { diseasecategoryid => "parentcategoryid" },
);
__PACKAGE__->has_many(
  "diseasecategories",
  "HGVbaseG2P::Schema::Diseasecategory",
  { "foreign.parentcategoryid" => "self.diseasecategoryid" },
);
__PACKAGE__->has_many(
  "phenotypeproperties",
  "HGVbaseG2P::Schema::Phenotypeproperty",
  { "foreign.diseasecategoryid" => "self.diseasecategoryid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:HuVej4CGz0LbXOHBY9S6dQ


# You can replace this text with custom content, and it will be preserved on regeneration
*parentcategory = \&diseasecategories;
sub to_jsonhash {
    my $self = shift;
    my $parent_discat = $self->parentcategory;
    return { 
	'type'  => 'diseasecategory',
	'label' => $self->name,
	'description' => $self->description || '',
	'parentdiseasecategory' => undef # (defined($parent_discat) ? $parent_discat->name : undef),
    };
}
1;
