package HGVbaseG2P::Schema::Fcam;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("FCAM");
__PACKAGE__->add_columns(
  "fcamid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "frequencyclusterid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "assaymarkerid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
);
__PACKAGE__->set_primary_key("fcamid");
__PACKAGE__->add_unique_constraint("FrequencyClusterID", ["frequencyclusterid", "assaymarkerid"]);
__PACKAGE__->belongs_to(
  "frequencyclusterid",
  "HGVbaseG2P::Schema::Frequencycluster",
  { frequencyclusterid => "frequencyclusterid" },
);
__PACKAGE__->belongs_to(
  "assaymarkerid",
  "HGVbaseG2P::Schema::Assaymarker",
  { assaymarkerid => "assaymarkerid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:bWwznrBmh52GULufFs0+Qg


# You can replace this text with custom content, and it will be preserved on regeneration
1;
