package HGVbaseG2P::Schema::Fcs;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("FCS");
__PACKAGE__->add_columns(
  "fcsid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "significanceid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 12 },
  "frequencyclusterid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 12 },
);
__PACKAGE__->set_primary_key("fcsid");
__PACKAGE__->add_unique_constraint(
  "GenotypeSignificanceID",
  ["significanceid", "frequencyclusterid"],
);
__PACKAGE__->belongs_to(
  "significanceid",
  "HGVbaseG2P::Schema::Significance",
  { significanceid => "significanceid" },
);
__PACKAGE__->belongs_to(
  "frequencyclusterid",
  "HGVbaseG2P::Schema::Frequencycluster",
  { frequencyclusterid => "frequencyclusterid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:Br72N0dUBmOcWq62wfCCEA


# You can replace this text with custom content, and it will be preserved on regeneration
1;
