package HGVbaseG2P::Schema::Frequencycluster;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("FrequencyCluster");
__PACKAGE__->add_columns(
  "frequencyclusterid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 12 },
  "usedmarkersetid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 12 },
  "assayedpanelid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "numberofgenotypedsamples",
  {
    data_type => "SMALLINT",
    default_value => undef,
    is_nullable => 0,
    size => 5,
  },
  "pvaluehwe",
  { data_type => "DECIMAL", default_value => undef, is_nullable => 1, size => 6 },
);
__PACKAGE__->set_primary_key("frequencyclusterid");
__PACKAGE__->add_unique_constraint("UsedmarkersetID", ["usedmarkersetid", "assayedpanelid"]);
__PACKAGE__->has_many(
  "allelefrequencies",
  "HGVbaseG2P::Schema::Allelefrequency",
  { "foreign.frequencyclusterid" => "self.frequencyclusterid" },
);
__PACKAGE__->has_many(
  "fcams",
  "HGVbaseG2P::Schema::Fcam",
  { "foreign.frequencyclusterid" => "self.frequencyclusterid" },
);
__PACKAGE__->has_many(
  "fcs",
  "HGVbaseG2P::Schema::Fcs",
  { "foreign.frequencyclusterid" => "self.frequencyclusterid" },
);
__PACKAGE__->belongs_to(
  "assayedpanelid",
  "HGVbaseG2P::Schema::Assayedpanel",
  { assayedpanelid => "assayedpanelid" },
);
__PACKAGE__->belongs_to(
  "usedmarkersetid",
  "HGVbaseG2P::Schema::Usedmarkerset",
  { usedmarkersetid => "usedmarkersetid" },
);
__PACKAGE__->has_many(
  "genotypefrequencies",
  "HGVbaseG2P::Schema::Genotypefrequency",
  { "foreign.frequencyclusterid" => "self.frequencyclusterid" },
);
__PACKAGE__->has_many(
  "haplotypefrequencies",
  "HGVbaseG2P::Schema::Haplotypefrequency",
  { "foreign.frequencyclusterid" => "self.frequencyclusterid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:xX0/TUSs5GIWqN8pIVsenQ

# You can replace this text with custom content, and it will be preserved on regeneration
*assayedpanel = \&assayedpanelid;
*experiment = \*experimentid;
1;
