package HGVbaseG2P::Schema::Genotype;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Genotype");
__PACKAGE__->add_columns(
  "genotypeid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "markerid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "genotypelabel",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 100,
  },
);
__PACKAGE__->set_primary_key("genotypeid");
__PACKAGE__->add_unique_constraint("MarkerID_2", ["markerid", "genotypelabel"]);
__PACKAGE__->has_many(
  "assaymarkergenotypes",
  "HGVbaseG2P::Schema::Assaymarkergenotype",
  { "foreign.genotypeid" => "self.genotypeid" },
);
__PACKAGE__->has_many(
  "assayedgenotypes",
  "HGVbaseG2P::Schema::Assayedgenotype",
  { "foreign.genotypeid" => "self.genotypeid" },
);
__PACKAGE__->belongs_to(
  "markerid",
  "HGVbaseG2P::Schema::Marker",
  { markerid => "markerid" },
);
__PACKAGE__->has_many(
  "genotypedefs",
  "HGVbaseG2P::Schema::Genotypedef",
  { "foreign.genotypeid" => "self.genotypeid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:S1jWcAPRnDm79zj146srPw


# You can replace this text with custom content, and it will be preserved on regeneration
1;
