package HGVbaseG2P::Schema::Genotypedef;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Genotypedef");
__PACKAGE__->add_columns(
  "genotypedefid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "genotypeid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "alleleid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "type",
  { data_type => "ENUM", default_value => undef, is_nullable => 0, size => 8 },
  "value",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 50,
  },
);
__PACKAGE__->set_primary_key("genotypedefid");
__PACKAGE__->belongs_to(
  "alleleid",
  "HGVbaseG2P::Schema::Allele",
  { alleleid => "alleleid" },
);
__PACKAGE__->belongs_to(
  "genotypeid",
  "HGVbaseG2P::Schema::Genotype",
  { genotypeid => "genotypeid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:GGEIItsNf87Nt8jeIwHzgQ


# You can replace this text with custom content, and it will be preserved on regeneration
1;
