package HGVbaseG2P::Schema::Genotypingdetails;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("GenotypingDetails");
__PACKAGE__->add_columns(
  "genotypingdetailsid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "experimentid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "genotypingplatformid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "description",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
  "timecreated",
  {
    data_type => "TIMESTAMP",
    default_value => "CURRENT_TIMESTAMP",
    is_nullable => 0,
    size => 14,
  },
);
__PACKAGE__->set_primary_key("genotypingdetailsid");
__PACKAGE__->has_many(
  "frequencyclusters",
  "HGVbaseG2P::Schema::Frequencycluster",
  { "foreign.genotypingdetailsid" => "self.genotypingdetailsid" },
);
__PACKAGE__->belongs_to(
  "genotypingplatformid",
  "HGVbaseG2P::Schema::Genotypingplatform",
  { genotypingplatformid => "genotypingplatformid" },
);
__PACKAGE__->belongs_to(
  "experimentid",
  "HGVbaseG2P::Schema::Experiment",
  { experimentid => "experimentid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:ab4S+fhUN3H8pr6HPc7bwQ

*genotypingplatform = \*genotypingplatformid;
*experiment = \*experimentid;


# You can replace this text with custom content, and it will be preserved on regeneration
1;
