package HGVbaseG2P::Schema::Genotypingplatform;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("GenotypingPlatform");
__PACKAGE__->add_columns(
  "genotypingplatformid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 6 },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 100,
  },
  "description",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
);
__PACKAGE__->set_primary_key("genotypingplatformid");
__PACKAGE__->add_unique_constraint("Name", ["name"]);
__PACKAGE__->has_many(
  "genotypingdetails",
  "HGVbaseG2P::Schema::Genotypingdetails",
  { "foreign.genotypingplatformid" => "self.genotypingplatformid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:yCh+0ssEf9GhoflJWFw9Aw


# You can replace this text with custom content, and it will be preserved on regeneration
1;
