package HGVbaseG2P::Schema::Haplotype;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Haplotype");
__PACKAGE__->add_columns(
  "haplotypeid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "identifier",
  { data_type => "VARCHAR", default_value => "", is_nullable => 0, size => 14 },
  "markersetid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "localid",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 100,
  },
);
__PACKAGE__->set_primary_key("haplotypeid");
__PACKAGE__->add_unique_constraint("Identifier", ["identifier"]);
__PACKAGE__->has_many(
  "haplotypealleles",
  "HGVbaseG2P::Schema::Haplotypeallele",
  { "foreign.haplotypeid" => "self.haplotypeid" },
);
__PACKAGE__->has_many(
  "haplotypecrossrefs",
  "HGVbaseG2P::Schema::Haplotypecrossref",
  { "foreign.haplotypeid" => "self.haplotypeid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:zLD+SdIUTDZ79Iw1djmjPw


# You can replace this text with custom content, and it will be preserved on regeneration
1;
