package HGVbaseG2P::Schema::Haplotypeallele;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("HaplotypeAllele");
__PACKAGE__->add_columns(
  "haplotypealleleid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "haplotypeid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "alleleid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "pqorder",
  { data_type => "TINYINT", default_value => 0, is_nullable => 0, size => 3 },
);
__PACKAGE__->set_primary_key("haplotypealleleid");
__PACKAGE__->add_unique_constraint("HaplotypeID", ["haplotypeid", "alleleid"]);
__PACKAGE__->belongs_to(
  "haplotypeid",
  "HGVbaseG2P::Schema::Haplotype",
  { haplotypeid => "haplotypeid" },
);
__PACKAGE__->belongs_to(
  "alleleid",
  "HGVbaseG2P::Schema::Allele",
  { alleleid => "alleleid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:J/6Oh8vD9PpdoG/Z7BCvZw


# You can replace this text with custom content, and it will be preserved on regeneration
1;
