package HGVbaseG2P::Schema::Haplotypecrossref;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("HaplotypeCrossref");
__PACKAGE__->add_columns(
  "haplotypecrossrefid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "haplotypeid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "crossrefid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
);
__PACKAGE__->set_primary_key("haplotypecrossrefid");
__PACKAGE__->add_unique_constraint("HaplotypeID", ["haplotypeid", "crossrefid"]);
__PACKAGE__->belongs_to(
  "haplotypeid",
  "HGVbaseG2P::Schema::Haplotype",
  { haplotypeid => "haplotypeid" },
);
__PACKAGE__->belongs_to(
  "crossrefid",
  "HGVbaseG2P::Schema::Crossref",
  { crossrefid => "crossrefid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:KHWuAcNavNYPUeB+SWT1FA


# You can replace this text with custom content, and it will be preserved on regeneration
1;
