package HGVbaseG2P::Schema::Hotlink;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Hotlink");
__PACKAGE__->add_columns(
  "hotlinkid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "hotlinklabel",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 100,
  },
  "urlprefix",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 300,
  },
  "urlsuffix",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
);
__PACKAGE__->set_primary_key("hotlinkid");
__PACKAGE__->add_unique_constraint("HotlinkLabel", ["hotlinklabel"]);
__PACKAGE__->has_many(
  "crossrefs",
  "HGVbaseG2P::Schema::Crossref",
  { "foreign.hotlinkid" => "self.hotlinkid" },
);
__PACKAGE__->has_many(
  "experiments",
  "HGVbaseG2P::Schema::Experiment",
  { "foreign.hotlinkid" => "self.hotlinkid" },
);
__PACKAGE__->has_many(
  "markers",
  "HGVbaseG2P::Schema::Marker",
  { "foreign.hotlinkid" => "self.hotlinkid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:x1/5twqPaGhF7aUmJLKXSA


# You can replace this text with custom content, and it will be preserved on regeneration
1;
