package HGVbaseG2P::Schema::Markercoord;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("MarkerCoord");
__PACKAGE__->add_columns(
  "markercoordid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "markerid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "chr",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 20,
  },
  "start",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "stop",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "span",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 10,
  },
  "strand",
  { data_type => "SMALLINT", default_value => 0, is_nullable => 0, size => 1 },
  "mapweight",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 20,
  },
  "genomebuild",
  { data_type => "VARCHAR", default_value => "", is_nullable => 0, size => 5 },
  "assemblytype",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 30,
  },
  "assemblyname",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 30,
  },
);
__PACKAGE__->set_primary_key("markercoordid");
__PACKAGE__->belongs_to(
  "markerid",
  "HGVbaseG2P::Schema::Marker",
  { markerid => "markerid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:k80/R4vDKrnRh1XDqwt49Q


# You can replace this text with custom content, and it will be preserved on regeneration
1;
