package HGVbaseG2P::Schema::Markerrevision;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components(qw/Core InflateColumn::DateTime/);
__PACKAGE__->table("MarkerRevision");
__PACKAGE__->add_columns(
  "markerrevisionid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "markerid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "replacedbymarkerid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "strandflipped",
  { data_type => "VARCHAR", default_value => undef, is_nullable => 1, size => 5 },
  "changetype",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 100,
  },
  "changetrigger",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 100,
  },
  "timecreated",
  {
    data_type => "TIMESTAMP",
    default_value => "CURRENT_TIMESTAMP",
    is_nullable => 0,
    size => 14,
  },
  "comment",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
);
__PACKAGE__->set_primary_key("markerrevisionid");
__PACKAGE__->add_unique_constraint("MarkerID", ["markerid", "replacedbymarkerid"]);
__PACKAGE__->belongs_to(
  "markerid",
  "HGVbaseG2P::Schema::Marker",
  { markerid => "markerid" },
);
__PACKAGE__->belongs_to(
  "replacedbymarkerid",
  "HGVbaseG2P::Schema::Marker",
  { markerid => "replacedbymarkerid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:H6oF7DmHqB35PmRCGmhpPw


# You can replace this text with custom content, and it will be preserved on regeneration

*replacedbymarker = \&replacedbymarkerid;

1;
