package HGVbaseG2P::Schema::Oligo;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Oligo");
__PACKAGE__->add_columns(
  "oligoid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "assayid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
  "oligosequence",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 250,
  },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
  "modifications",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "role",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
);
__PACKAGE__->set_primary_key("oligoid");
__PACKAGE__->belongs_to(
  "assayid",
  "HGVbaseG2P::Schema::Assay",
  { assayid => "assayid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:ua4+nqRFm3hVaw1Oh1EJlQ


# You can replace this text with custom content, and it will be preserved on regeneration
1;
