package HGVbaseG2P::Schema::Phenotypeproperty;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("PhenotypeProperty");
__PACKAGE__->add_columns(
  "phenotypepropertyid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "diseasecategoryid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
  "description",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
);
__PACKAGE__->set_primary_key("phenotypepropertyid");
__PACKAGE__->add_unique_constraint("Name", ["name"]);
__PACKAGE__->has_many(
  "phenotypemethods",
  "HGVbaseG2P::Schema::Phenotypemethod",
  { "foreign.phenotypepropertyid" => "self.phenotypepropertyid" },
);
__PACKAGE__->belongs_to(
  "diseasecategoryid",
  "HGVbaseG2P::Schema::Diseasecategory",
  { diseasecategoryid => "diseasecategoryid" },
);
__PACKAGE__->has_many(
  "phenotypepropertycitations",
  "HGVbaseG2P::Schema::Phenotypepropertycitation",
  { "foreign.phenotypepropertyid" => "self.phenotypepropertyid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:rWlj3l8uwdvQHrygG4HwWg


# You can replace this text with custom content, and it will be preserved on regeneration
*diseasecategory = \&diseasecategoryid;
sub to_jsonhash {
    my $self = shift;
    my $discat = $self->diseasecategory;
    return {
	'type'  => 'phenotypeproperty',
	'label' => $self->name,
	'description' => $self->description || '',
	'diseasecategory' => (defined($discat) ? $discat->name : undef),
    };
}


1;
