package HGVbaseG2P::Schema::Phenotypevalue;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("PhenotypeValue");
__PACKAGE__->add_columns(
  "phenotypevalueid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "phenotypemethodid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "samplepanelid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "value",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 500,
  },
  "valuerank",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 3 },
  "valueismean",
  { data_type => "VARCHAR", default_value => undef, is_nullable => 1, size => 3 },
  "stddev",
  { data_type => "FLOAT", default_value => undef, is_nullable => 1, size => 32 },
  "median",
  { data_type => "FLOAT", default_value => undef, is_nullable => 1, size => 32 },
  "min",
  { data_type => "FLOAT", default_value => undef, is_nullable => 1, size => 32 },
  "max",
  { data_type => "FLOAT", default_value => undef, is_nullable => 1, size => 32 },
  "numberofindividuals",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "qualifier",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
);
__PACKAGE__->set_primary_key("phenotypevalueid");
__PACKAGE__->add_unique_constraint(
  "CombinedMethodID",
  ["phenotypemethodid", "samplepanelid", "value"],
);
__PACKAGE__->has_many(
  "pvscs",
  "HGVbaseG2P::Schema::Pvsc",
  { "foreign.phenotypevalueid" => "self.phenotypevalueid" },
);
__PACKAGE__->belongs_to(
  "phenotypemethodid",
  "HGVbaseG2P::Schema::Phenotypemethod",
  { phenotypemethodid => "phenotypemethodid" },
);
__PACKAGE__->belongs_to(
  "samplepanelid",
  "HGVbaseG2P::Schema::Samplepanel",
  { samplepanelid => "samplepanelid" },
);
__PACKAGE__->has_many(
  "phenotypevaluedetails",
  "HGVbaseG2P::Schema::Phenotypevaluedetail",
  { "foreign.phenotypevalueid" => "self.phenotypevalueid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:qjKp5D0xx/wUFaHd3ZicAA


# You can replace this text with custom content, and it will be preserved on regeneration
1;
