package HGVbaseG2P::Schema::Pvsc;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("PVSC");
__PACKAGE__->add_columns(
  "pvscid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "phenotypevalueid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "selectioncriteriaid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 8 },
);
__PACKAGE__->set_primary_key("pvscid");
__PACKAGE__->add_unique_constraint(
  "PhenotypeValueID",
  ["phenotypevalueid", "selectioncriteriaid"],
);
__PACKAGE__->belongs_to(
  "phenotypevalueid",
  "HGVbaseG2P::Schema::Phenotypevalue",
  { phenotypevalueid => "phenotypevalueid" },
);
__PACKAGE__->belongs_to(
  "selectioncriteriaid",
  "HGVbaseG2P::Schema::Selectioncriteria",
  { selectioncriteriaid => "selectioncriteriaid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:5IssJTlEN9Sy3X6vdOLHUA


# You can replace this text with custom content, and it will be preserved on regeneration
1;
