package HGVbaseG2P::Schema::Samplepanel;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Samplepanel");
__PACKAGE__->add_columns(
  "samplepanelid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "submittedinstudyid",
  {
    data_type => "MEDIUMINT",
    default_value => undef,
    is_nullable => 1,
    size => 8,
  },
  "parentsamplepanelid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "identifier",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 15,
  },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
  "label",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 10,
  },
  "accession",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 15,
  },
  "accessionversion",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 10,
  },
  "description",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
  "composition",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
  "totalnumberofindividuals",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofsexmale",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofsexfemale",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofsexunknown",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofprobands",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "numberofparents",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
  "modeofrecruitment",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "diagnosisagerange",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 150,
  },
  "diagnosisperiod",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 150,
  },
  "samplingagerange",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 150,
  },
  "samplingperiod",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 150,
  },
  "populationinfo",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "geographicregioninfo",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "ethnicityinfo",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "birthplaceinfo",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "admixtureinfo",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "environmentinfo",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
  "sourceofdna",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
  "dnasarepooled",
  {
    data_type => "ENUM",
    default_value => "Undefined",
    is_nullable => 0,
    size => 9,
  },
  "dnasarewga",
  {
    data_type => "ENUM",
    default_value => "Undefined",
    is_nullable => 0,
    size => 9,
  },
);
__PACKAGE__->set_primary_key("samplepanelid");
__PACKAGE__->add_unique_constraint("Identifier", ["identifier"]);
__PACKAGE__->add_unique_constraint("Name", ["name", "submittedinstudyid"]);
__PACKAGE__->has_many(
  "phenotypevalues",
  "HGVbaseG2P::Schema::Phenotypevalue",
  { "foreign.samplepanelid" => "self.samplepanelid" },
);
__PACKAGE__->belongs_to(
  "parentsamplepanelid",
  "HGVbaseG2P::Schema::Samplepanel",
  { samplepanelid => "parentsamplepanelid" },
);
__PACKAGE__->has_many(
  "samplepanels",
  "HGVbaseG2P::Schema::Samplepanel",
  { "foreign.parentsamplepanelid" => "self.samplepanelid" },
);
__PACKAGE__->belongs_to(
  "submittedinstudyid",
  "HGVbaseG2P::Schema::Study",
  { studyid => "submittedinstudyid" },
);
__PACKAGE__->has_many(
  "samplepanelcrossrefs",
  "HGVbaseG2P::Schema::Samplepanelcrossref",
  { "foreign.samplepanelid" => "self.samplepanelid" },
);
__PACKAGE__->has_many(
  "samplepaneloverlap_samplepanelid_news",
  "HGVbaseG2P::Schema::Samplepaneloverlap",
  { "foreign.samplepanelid_new" => "self.samplepanelid" },
);
__PACKAGE__->has_many(
  "samplepaneloverlap_samplepanelid_olds",
  "HGVbaseG2P::Schema::Samplepaneloverlap",
  { "foreign.samplepanelid_old" => "self.samplepanelid" },
);
__PACKAGE__->has_many(
  "selectioncriterias",
  "HGVbaseG2P::Schema::Selectioncriteria",
  { "foreign.samplepanelid" => "self.samplepanelid" },
);
__PACKAGE__->has_many(
  "studysamplepanels",
  "HGVbaseG2P::Schema::Studysamplepanel",
  { "foreign.samplepanelid" => "self.samplepanelid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:ObemP+EybaNCIujc9M/n9Q


# You can replace this text with custom content, and it will be preserved on regeneration

*submittedinstudy = \&submittedinstudyid;
__PACKAGE__->many_to_many(usedinstudies => 'studysamplepanels', 'studyid' );


1;
