package HGVbaseG2P::Schema::Selectioncriteria;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("SelectionCriteria");
__PACKAGE__->add_columns(
  "selectioncriteriaid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 8 },
  "assayedpanelid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "samplepanelid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "sourceassayedpanelid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "environmentcriteria",
  {
    data_type => "VARCHAR",
    default_value => "No selection",
    is_nullable => 1,
    size => 500,
  },
  "numberofindividuals",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 6 },
);
__PACKAGE__->set_primary_key("selectioncriteriaid");
__PACKAGE__->add_unique_constraint("AssayedpanelID", ["assayedpanelid", "samplepanelid"]);
__PACKAGE__->add_unique_constraint(
  "SourceAssayedpanelID",
  ["sourceassayedpanelid", "assayedpanelid"],
);
__PACKAGE__->has_many(
  "pvscs",
  "HGVbaseG2P::Schema::Pvsc",
  { "foreign.selectioncriteriaid" => "self.selectioncriteriaid" },
);
__PACKAGE__->belongs_to(
  "assayedpanelid",
  "HGVbaseG2P::Schema::Assayedpanel",
  { assayedpanelid => "assayedpanelid" },
);
__PACKAGE__->belongs_to(
  "samplepanelid",
  "HGVbaseG2P::Schema::Samplepanel",
  { samplepanelid => "samplepanelid" },
);
__PACKAGE__->belongs_to(
  "sourceassayedpanelid",
  "HGVbaseG2P::Schema::Assayedpanel",
  { assayedpanelid => "sourceassayedpanelid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:g1hb6mDXnXdac5B+gMK8GQ


# You can replace this text with custom content, and it will be preserved on regeneration
__PACKAGE__->many_to_many(phenotypevalues => 'pvscs', 'phenotypevalueid' );
*samplepanel = \&samplepanelid;
*assayedpanel = \&assayedpanelid;
1;
