package HGVbaseG2P::Schema::Significance;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Significance");
__PACKAGE__->add_columns(
  "significanceid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 12 },
  "resultsetid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "usedmarkersetid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 12 },
  "unadjustedpvalue",
  { data_type => "FLOAT", default_value => undef, is_nullable => 1, size => 32 },
  "adjustedpvalue",
  { data_type => "FLOAT", default_value => undef, is_nullable => 1, size => 32 },
  "oddsratiostatement",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
  "attributableriskstatement",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 250,
  },
);
__PACKAGE__->set_primary_key("significanceid");
__PACKAGE__->has_many(
  "fcs",
  "HGVbaseG2P::Schema::Fcs",
  { "foreign.significanceid" => "self.significanceid" },
);
__PACKAGE__->belongs_to(
  "usedmarkersetid",
  "HGVbaseG2P::Schema::Usedmarkerset",
  { usedmarkersetid => "usedmarkersetid" },
);
__PACKAGE__->belongs_to(
  "resultsetid",
  "HGVbaseG2P::Schema::Resultset",
  { resultsetid => "resultsetid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:07PcNS11ZneyL30Ig2yH1Q


# You can replace this text with custom content, and it will be preserved on regeneration

*usedmarkerset = \&usedmarkersetid;
__PACKAGE__->many_to_many(frequencyclusters => 'fcs', 'frequencyclusterid' );
*resultset = \&resultsetid;

1;
