package HGVbaseG2P::Schema::Studycitation;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("StudyCitation");
__PACKAGE__->add_columns(
  "studycitationid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "studyid",
  { data_type => "MEDIUMINT", default_value => 0, is_nullable => 0, size => 8 },
  "citationid",
  { data_type => "SMALLINT", default_value => 0, is_nullable => 0, size => 5 },
);
__PACKAGE__->set_primary_key("studycitationid");
__PACKAGE__->add_unique_constraint("StudyID", ["studyid", "citationid"]);
__PACKAGE__->belongs_to(
  "studyid",
  "HGVbaseG2P::Schema::Study",
  { studyid => "studyid" },
);
__PACKAGE__->belongs_to(
  "citationid",
  "HGVbaseG2P::Schema::Citation",
  { citationid => "citationid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:+yPXe4c2iJOApmuF1qGt5A


# You can replace this text with custom content, and it will be preserved on regeneration
1;
