package HGVbaseG2P::Schema::Studycrossref;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("StudyCrossref");
__PACKAGE__->add_columns(
  "studycrossrefid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "studyid",
  { data_type => "MEDIUMINT", default_value => 0, is_nullable => 0, size => 8 },
  "crossrefid",
  { data_type => "INT", default_value => 0, is_nullable => 0, size => 10 },
);
__PACKAGE__->set_primary_key("studycrossrefid");
__PACKAGE__->add_unique_constraint("StudyID", ["studyid", "crossrefid"]);
__PACKAGE__->belongs_to(
  "studyid",
  "HGVbaseG2P::Schema::Study",
  { studyid => "studyid" },
);
__PACKAGE__->belongs_to(
  "crossrefid",
  "HGVbaseG2P::Schema::Crossref",
  { crossrefid => "crossrefid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:/vltHruBmt9jJp1KQa0IrQ


# You can replace this text with custom content, and it will be preserved on regeneration
1;
