package HGVbaseG2P::Schema::Studyoverlap;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("StudyOverlap");
__PACKAGE__->add_columns(
  "studyoverlapid",
  {
    data_type => "SMALLINT",
    default_value => undef,
    is_nullable => 0,
    size => 5,
  },
  "studyid_new",
  {
    data_type => "MEDIUMINT",
    default_value => undef,
    is_nullable => 0,
    size => 8,
  },
  "studyid_old",
  {
    data_type => "MEDIUMINT",
    default_value => undef,
    is_nullable => 0,
    size => 8,
  },
  "overlapdetails",
  {
    data_type => "VARCHAR",
    default_value => "This Study overlaps with another",
    is_nullable => 0,
    size => 50,
  },
);
__PACKAGE__->set_primary_key("studyoverlapid");
__PACKAGE__->add_unique_constraint("StudyID_New", ["studyid_new", "studyid_old"]);
__PACKAGE__->belongs_to(
  "studyid_new",
  "HGVbaseG2P::Schema::Study",
  { studyid => "studyid_new" },
);
__PACKAGE__->belongs_to(
  "studyid_old",
  "HGVbaseG2P::Schema::Study",
  { studyid => "studyid_old" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:YKMCHY6vknzDramZaUDHQA


# You can replace this text with custom content, and it will be preserved on regeneration
1;
