package HGVbaseG2P::Schema::Submission;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Submission");
__PACKAGE__->add_columns(
  "submissionid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "studyid",
  {
    data_type => "MEDIUMINT",
    default_value => undef,
    is_nullable => 0,
    size => 8,
  },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 0,
    size => 100,
  },
  "description",
  {
    data_type => "TEXT",
    default_value => undef,
    is_nullable => 1,
    size => 65535,
  },
  "timecreated",
  {
    data_type => "TIMESTAMP",
    default_value => "CURRENT_TIMESTAMP",
    is_nullable => 0,
    size => 14,
  },
);
__PACKAGE__->set_primary_key("submissionid");
__PACKAGE__->add_unique_constraint("StudyID", ["studyid", "name"]);
__PACKAGE__->has_many(
  "contributions",
  "HGVbaseG2P::Schema::Contribution",
  { "foreign.submissionid" => "self.submissionid" },
);
__PACKAGE__->belongs_to(
  "studyid",
  "HGVbaseG2P::Schema::Study",
  { studyid => "studyid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2008-12-29 14:15:37
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:nQKdveEqL4aoKPCz0pySTg


# You can replace this text with custom content, and it will be preserved on regeneration
1;
