package HGVbaseG2P::Schema::Usedmarkerset;

use strict;
use warnings;

use base 'DBIx::Class';

__PACKAGE__->load_components("Core");
__PACKAGE__->table("Usedmarkerset");
__PACKAGE__->add_columns(
  "usedmarkersetid",
  { data_type => "INT", default_value => undef, is_nullable => 0, size => 10 },
  "experimentid",
  { data_type => "INT", default_value => undef, is_nullable => 1, size => 10 },
  "markeridentifier",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 15,
  },
  "name",
  {
    data_type => "VARCHAR",
    default_value => undef,
    is_nullable => 1,
    size => 100,
  },
);
__PACKAGE__->set_primary_key("usedmarkersetid");
__PACKAGE__->add_unique_constraint("ExperimentID", ["experimentid", "markeridentifier"]);
__PACKAGE__->add_unique_constraint("ExperimentID_2", ["experimentid", "name"]);
__PACKAGE__->has_many(
  "frequencyclusters",
  "HGVbaseG2P::Schema::Frequencycluster",
  { "foreign.usedmarkersetid" => "self.usedmarkersetid" },
);
__PACKAGE__->has_many(
  "significances",
  "HGVbaseG2P::Schema::Significance",
  { "foreign.usedmarkersetid" => "self.usedmarkersetid" },
);
__PACKAGE__->belongs_to(
  "experimentid",
  "HGVbaseG2P::Schema::Experiment",
  { experimentid => "experimentid" },
);


# Created by DBIx::Class::Schema::Loader v0.04005 @ 2009-03-31 14:57:34
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:E38J4x22FTULvk5zSYBbKw


# You can replace this text with custom content, and it will be preserved on regeneration
*experiment = \*experimentid;

1;
