#!perl
package HGVbaseG2P::Test::DataImport::Association::CGEMS;

# $Id: CGEMS.pm 644 2008-05-20 15:07:34Z rcf8 $

=head1 NAME

  HGVbaseG2P::Test::DataImport::Association::CGEMS - Module for testing CGEMS assoication data import

=head1 SYNOPSIS

	
=head1 DESCRIPTION

  This simple module inherits all frequency specific tests from the Association test class.
  The Association test class also inherits from DataImport and XMLdb to create a test db containing, study, marker and frequency data.
  
  The get_source method is used by the superclass to create the correct DataImport object and use/make the correct input/output files for the testing.
  Configurable frequency test data is stored in conf/test/hgvbase.conf within a <TestData [importclass]> element. 

  Any source specific tests are also present in this module.

=head1 SUBROUTINES/METHODS 

=cut




use strict;
use warnings;

use Data::Dumper;
use Test::More;
use Test::Exception;
use Data::Stag qw( :all );

use base qw(HGVbaseG2P::Test::DataImport::Association);

sub get_source {
	return "CGEMS";
}

1;
