#!perl
package HGVbaseG2P::Test::DataImport::Frequency::Broad;

# $Id: Broad.pm 644 2008-05-20 15:07:34Z rcf8 $

=head1 NAME

  HGVbaseG2P::Test::DataImport::Frequency::Broad - Module for testing Broad frequency data import

=head1 SYNOPSIS

	
=head1 DESCRIPTION

  This simple module inherits all frequency specific tests from the Frequency test class.
  The Frequency test class also inherits from DataImport and XMLdb to create a test db containing, study and marker data.
  
  The get_source method is used by the superclass to create the correct DataImport object and use/make the correct input/output files for the testing.
  Configurable frequency test data is stored in conf/test/hgvbase.conf within a <TestData [importclass]> element. 

  Any source specific tests are also present in this module.

=head1 SUBROUTINES/METHODS 

=cut


use strict;
use warnings;

use Data::Dumper;
use Test::More;
use Test::Exception;
use Data::Stag qw( :all );

use base qw(HGVbaseG2P::Test::DataImport::Frequency);

sub get_source {
	return "Broad";
}
1;

=head1 SEE ALSO

=head1 BUGS AND LIMITATIONS

There are no known bugs in this module.
Please report problems to Rob Free <rcfree@gmail.com>

=head1 CONTACT

This module is part of the HGVbase-G2P project

=head1 AUTHOR

Rob Free <rcfree@gmail.com>

=head1 LICENCE AND COPYRIGHT

Copyright (c) <2007> University of Leicester, Leicester, UK. All rights reserved.

This module is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 

=head1 CVSINFO

$Id: Broad.pm 644 2008-05-20 15:07:34Z rcf8 $

=cut