package HGVbaseG2P::Web::Controller::Assayedpanel;

# $Id: Assayedpanel.pm 1192 2009-06-18 11:26:43Z rcf8 $

=head1 NAME

  HGVbaseG2P::Web::Controller::Assayedpanel - Catalyst Controller for Assayedpanels

=head1 DESCRIPTION

  This class handles data & business logic relating to Assayedpanel entries.

=head1 METHODS

=cut


use strict;
use warnings;
use base qw(HGVbaseG2P::Web::Controller::Root);

=head2 view

Redirects from /view to default action

=cut

sub view : Local {
    my ( $self, $c ) = @_;
    my $url = $c->req->uri->as_string;
    $url =~ s|(\w+)/view|$1|;
    $c->response->redirect($url);
}

=head2 default

Retrieves an assayedpanel from the database (by identifier) and puts it in the stash for the template

=cut

sub default :Regex('^assayedpanel/(HGV\w+)$') {
    my ( $self, $c ) = @_;
    my $id = $c->req->captures->[0];

    my $apanel = $c->model("StudyDB")->get_assayedpanel_by_identifier($id);
    if(!$apanel) {
    	$c->stash->{notfound_type} = "Assayed Panel";
        $c->stash->{notfound_id}=$id;
        $c->stash->{template} = 'notfound.tt2'; 
		return;
    }
    $c->stash->{apanelid} = $id;
    $c->stash->{template} = 'assayedpanel/view.tt2';
    $c->stash->{apanel} = $apanel;
    return; 
}


=head1 AUTHOR

  Gudmundur A. Thorisson <gthorisson@gmail.com>
  Rob Free <rcfree@gmail.com>

=head1 LICENSE

This library is free software, you can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

1;
