package HGVbaseG2P::Web::Model::SeqFeature;

# $Id: SeqFeature.pm 1272 2009-08-21 15:08:35Z rcf8 $

=head1 NAME

  HGVbaseG2P::Web::Model::SeqFeature - Catalyst Model for Bioperl feature databases

=head1 SYNOPSIS


=head1 DESCRIPTION

  Catalyst Model to interact with a Bio::DB::SeqFeature::Store GFF-based feature 
  database. 

=cut

use strict;
use warnings;

use Data::Dumper;

use base qw/Catalyst::Model/;

our $AUTOLOAD;

__PACKAGE__->mk_accessors('dbh');

use HGVbaseG2P::Database::Feature;

# Initialize object
sub COMPONENT {
    my ($class, $c, $args) = @_;
    my $self = $class->NEXT::COMPONENT($c);
    
    my $dbh = HGVbaseG2P::Database::Feature->new({
    	conf_file=>$c->config,
    });

    $self->dbh($dbh);
    return $self;
}

sub AUTOLOAD {
    my ($self, @args) = @_;
    my $method = $AUTOLOAD;
    $method =~ s/\A.*:://xms;
    if($self->dbh->can($method)) {
	return $self->dbh->$method(@args);	
    }
    else {
	die "Cannot call method $method on instance of ",ref($self->dbh);
    }
}

=head1 AUTHOR

  Gudmundur A. Thorisson <gthorisson@gmail.com>

=head1 LICENSE

This library is free software, you can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

1;
