package HGVbaseG2P::Web::Model::StudyDB;

use strict;
use base qw(Catalyst::Model);

use HGVbaseG2P::Database::Study;
__PACKAGE__->mk_accessors('dbh');
our $AUTOLOAD;

#create HGVbaseG2P::Database::Study for use by web application
sub COMPONENT {
    my ($class, $c, $args) = @_;
    my $self = $class->NEXT::COMPONENT($c);
    my $dbh = HGVbaseG2P::Database::Study->new({ conf_file => $c->config });
    $self->dbh($dbh);
    return $self;
}

#if method not recognised, attempt to call it on $self->dbh
sub AUTOLOAD {
    my ($self, @args) = @_;
    my $method = $AUTOLOAD;
    $method =~ s/\A.*:://xms;
    if ($self->dbh) {
	    if($self->dbh->can($method)) {
			return $self->dbh->$method(@args);	
	    }
	    else {
			die "Cannot call method $method on instance of ",ref($self->dbh);
	    }
    }
	else {
		die "Cannot call method $method on instance of ",ref($self->dbh);
    }
}

=head1 NAME

HGVbaseG2P::Web::Model::StudyDB - Catalyst Study database module wrapper class

=head1 SYNOPSIS

See L<HGVbaseG2P::Web>

=head1 DESCRIPTION

Catalyst wrapper for L<HGVbaseG2P::Database::Study> database utility module based on L<DBIx::Class> Model using schema L<HGVbaseG2P::Schema>

=head1 AUTHOR

Rob Free

=head1 LICENSE

This library is free software, you can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

1;
