# $Id: Xapian.pm 1192 2009-06-18 11:26:43Z rcf8 $

package HGVbaseG2P::Web::Model::Xapian;

=head1 NAME

  HGVbaseG2P::Web::Model::Xapian - Catalyst Model component for a Xapian database

=head1 SYNOPSIS


=head1 DESCRIPTION

  This class provides access to a Xapian text-search index database, currently used
  for the search engine on the HGVbase-G2P website. 

Very nice component.

=cut

use strict;
use base 'Catalyst::Model';

use Data::Dumper;
use HGVbaseG2P::Database::Xapian;
__PACKAGE__->mk_accessors('dbh');

#create HGVbaseG2P::Database::Xapian for use by web application
sub COMPONENT {
    my ($class, $c, $args) = @_;
    my $self = $class->NEXT::COMPONENT($c);
    my $dbh = HGVbaseG2P::Database::Xapian->new({ conf_file => $c->config });
    $self->dbh($dbh);
    return $self;
}

=head1 AUTHOR

  Gudmundur A. Thorisson <gthorisson@gmail.com>
  Rob Free <rcfree@gmail.com>


=head1 LICENSE

This library is free software . You can redistribute it and/or modify it under
the same terms as perl itself.

=cut

1;
