CREATE TABLE `hsapiens_gene_ensembl__gene__main` (
  `gene_id_key` int(10) unsigned default NULL,
  `gene_stable_id` varchar(128) NOT NULL default '',
  `gene_stable_id_v` varbinary(140) default NULL,
  `biotype` varchar(40) NOT NULL default '',
  `source` varchar(20) NOT NULL default '',
  `gene_confidence` enum('KNOWN','NOVEL','PUTATIVE','PREDICTED','KNOWN_BY_PROJECTION','UNKNOWN') default NULL,
  `display_xref_id` int(10) unsigned default NULL,
  `gene_chrom_start` int(10) unsigned NOT NULL default '0',
  `gene_chrom_end` int(10) unsigned NOT NULL default '0',
  `chrom_strand` tinyint(2) NOT NULL default '0',
  `chromosome_id` int(10) unsigned NOT NULL default '0',
  `chr_name` varchar(40) NOT NULL default '',
  `description` text,
  `band` varchar(40) default '',
  `known_gene` int(10) unsigned default '0',
  `display_id` varchar(128) default '',
  `db_name` varchar(80) default NULL,
  `has_5utr_bool` int(1) unsigned default NULL,
  `has_3utr_bool` int(1) unsigned default NULL,
  `transcript_count` bigint(21) default '0',
  `aaegypti_homolog_bool` int(1) unsigned default NULL,
  `agambiae_homolog_bool` int(1) unsigned default NULL,
  `btaurus_homolog_bool` int(1) unsigned default NULL,
  `celegans_homolog_bool` int(1) unsigned default NULL,
  `cfamiliaris_homolog_bool` int(1) unsigned default NULL,
  `cintestinalis_homolog_bool` int(1) unsigned default NULL,
  `cporcellus_homolog_bool` int(1) unsigned default NULL,
  `csavignyi_homolog_bool` int(1) unsigned default NULL,
  `dmelanogaster_homolog_bool` int(1) unsigned default NULL,
  `dnovemcinctus_homolog_bool` int(1) unsigned default NULL,
  `drerio_homolog_bool` int(1) unsigned default NULL,
  `eeuropaeus_homolog_bool` int(1) unsigned default NULL,
  `etelfairi_homolog_bool` int(1) unsigned default NULL,
  `fcatus_homolog_bool` int(1) unsigned default NULL,
  `gaculeatus_homolog_bool` int(1) unsigned default NULL,
  `ggallus_homolog_bool` int(1) unsigned default NULL,
  `lafricana_homolog_bool` int(1) unsigned default NULL,
  `mdomestica_homolog_bool` int(1) unsigned default NULL,
  `mlucifugus_homolog_bool` int(1) unsigned default NULL,
  `mmulatta_homolog_bool` int(1) unsigned default NULL,
  `mmusculus_homolog_bool` int(1) unsigned default NULL,
  `oanatinus_homolog_bool` int(1) unsigned default NULL,
  `ocuniculus_homolog_bool` int(1) unsigned default NULL,
  `ogarnettii_homolog_bool` int(1) unsigned default NULL,
  `olatipes_homolog_bool` int(1) unsigned default NULL,
  `ptroglodytes_homolog_bool` int(1) unsigned default NULL,
  `rnorvegicus_homolog_bool` int(1) unsigned default NULL,
  `saraneus_homolog_bool` int(1) unsigned default NULL,
  `scerevisiae_homolog_bool` int(1) unsigned default NULL,
  `stridecemlineatus_homolog_bool` int(1) unsigned default NULL,
  `tbelangeri_homolog_bool` int(1) unsigned default NULL,
  `tnigroviridis_homolog_bool` int(1) unsigned default NULL,
  `trubripes_homolog_bool` int(1) unsigned default NULL,
  `xtropicalis_homolog_bool` int(1) unsigned default NULL,
  `hsapiens_paralog_bool` int(1) unsigned default NULL,
  `affy_hc_g110_bool` int(1) unsigned default NULL,
  `affy_hg_focus_bool` int(1) unsigned default NULL,
  `affy_hg_u133_plus_2_bool` int(1) unsigned default NULL,
  `affy_hg_u133a_2_bool` int(1) unsigned default NULL,
  `affy_hg_u133a_bool` int(1) unsigned default NULL,
  `affy_hg_u133b_bool` int(1) unsigned default NULL,
  `affy_hg_u95a_bool` int(1) unsigned default NULL,
  `affy_hg_u95av2_bool` int(1) unsigned default NULL,
  `affy_hg_u95b_bool` int(1) unsigned default NULL,
  `affy_hg_u95c_bool` int(1) unsigned default NULL,
  `affy_hg_u95d_bool` int(1) unsigned default NULL,
  `affy_hg_u95e_bool` int(1) unsigned default NULL,
  `affy_hugenefl_bool` int(1) unsigned default NULL,
  `affy_u133_x3p_bool` int(1) unsigned default NULL,
  `agilentcgh_bool` int(1) unsigned default NULL,
  `agilentprobe_bool` int(1) unsigned default NULL,
  `ccds_bool` int(1) unsigned default NULL,
  `codelink_bool` int(1) unsigned default NULL,
  `embl_bool` int(1) unsigned default NULL,
  `entrezgene_bool` int(1) unsigned default NULL,
  `go_bool` int(1) unsigned default NULL,
  `hugo_bool` int(1) unsigned default NULL,
  `illumina_v1_bool` int(1) unsigned default NULL,
  `illumina_v2_bool` int(1) unsigned default NULL,
  `imgt_gene_db_bool` int(1) unsigned default NULL,
  `imgt_ligm_db_bool` int(1) unsigned default NULL,
  `ipi_bool` int(1) unsigned default NULL,
  `mim_gene_bool` int(1) unsigned default NULL,
  `mim_morbid_bool` int(1) unsigned default NULL,
  `mirbase_bool` int(1) unsigned default NULL,
  `ottt_bool` int(1) unsigned default NULL,
  `pdb_bool` int(1) unsigned default NULL,
  `protein_id_bool` int(1) unsigned default NULL,
  `refseq_dna_bool` int(1) unsigned default NULL,
  `refseq_dna_predicted_bool` int(1) unsigned default NULL,
  `refseq_peptide_bool` int(1) unsigned default NULL,
  `refseq_peptide_predicted_bool` int(1) unsigned default NULL,
  `rfam_bool` int(1) unsigned default NULL,
  `shares_cds_with_enst_bool` int(1) unsigned default NULL,
  `shares_cds_with_ottt_bool` int(1) unsigned default NULL,
  `unigene_bool` int(1) unsigned default NULL,
  `uniprot_accession_bool` int(1) unsigned default NULL,
  `uniprot_id_bool` int(1) unsigned default NULL,
  `uniprot_sptrembl_bool` int(1) unsigned default NULL,
  `uniprot_swissprot_bool` int(1) unsigned default NULL,
  `uniprot_varsplic_bool` int(1) unsigned default NULL,
  `coil_bool` int(1) unsigned default NULL,
  `interpro_bool` int(1) unsigned default NULL,
  `low_complexity_bool` int(1) unsigned default NULL,
  `pfam_bool` int(1) unsigned default NULL,
  `prints_bool` int(1) unsigned default NULL,
  `profile_bool` int(1) unsigned default NULL,
  `prosite_bool` int(1) unsigned default NULL,
  `signal_peptide_bool` int(1) unsigned default NULL,
  `transmembrane_bool` int(1) unsigned default NULL,
  `tscid_bool` int(1) unsigned default NULL,
  `hgbaseid_bool` int(1) unsigned default NULL,
  `validated_bool` int(1) unsigned default NULL,
  `5upstream_bool` int(1) unsigned default NULL,
  `5utr_bool` int(1) unsigned default NULL,
  `coding_bool` int(1) unsigned default NULL,
  `intronic_bool` int(1) unsigned default NULL,
  `3utr_bool` int(1) unsigned default NULL,
  `3downstream_bool` int(1) unsigned default NULL,
  `is_encode_bool` varchar(12) default '',
  `encode_region_name` text,
  `perc_gc` int(3) unsigned default '0',
  `freq` int(1) unsigned default NULL,
  KEY `gene_stable_id` (`gene_stable_id`),
  KEY `chr` (`chr_name`),
  KEY `chromosome_id` (`chromosome_id`),
  KEY `chr_start` (`chromosome_id`,`gene_chrom_start`,`gene_id_key`),
  KEY `gene_chrom_start` (`gene_chrom_start`),
  KEY `chr_name` (`chr_name`,`gene_chrom_start`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
